/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox


  --------------------------------------------------
  Definitionen und Deklarationen fuer BayCom-Projekt
  --------------------------------------------------


  Copyright (c)       Florian Radlherr
		      Taubenbergstr. 32
		      D-83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19981011 OE3DZW added wx-code
//19990215 OE3DZW clean up
//19990721 hpk    created "CB_OPT"
//19991128 DB1RAS added "_nfile.h"

#ifdef __MSDOS__
  #include "_nfile.h"       //db1ras
#endif

#ifndef _BAYCOM_H
  #define   _BAYCOM_H

  #ifndef BOXCOMPILE
    #define VNUMMER      "1.60u"
  #endif

  #define YEAR "1999"

  #define ENGLISCH     1

  #ifdef __DPMI32__
    #define __MSDOS__
  #endif

  #ifdef _WIN32
    #define __MSDOS__
    #define __FLAT__
  #endif

  #if defined(__MSDOS__) && (!defined(_WIN32))
    #define __HWSCREEN__
    #define __DOS16__
  #endif

  #ifndef __MSDOS__
    #define __LINUX__
    #define __UNIX__
    #define __FLAT__
  #endif

  #include <ctype.h>
  #include <fcntl.h>
  #include <stdarg.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <sys/stat.h>
  #include <time.h>

  #ifndef errno // DH3MB, for compatibility with glibc
    #include <errno.h>
  #endif

  #ifdef _WIN32
    #include <setjmpex.h>
  #else
    #include <setjmp.h>
  #endif

  #define WITHNUDL     0
  #define MAIL 1
  #define NODE 0

  #define SISKIN       0
  #define PACCOMM      0
  #define PKT          0
  #define TIGERTRONICS 0

  #ifdef ENGLISCH
    #define DEUTSCH  0
  #else
    #define DEUTSCH  1
  #endif

  #if SISKIN || PACCOMM || TIGERTRONICS || PKT
    #undef  ENGLISCH
    #define ENGLISCH 1
    #undef  DEUTSCH
    #define DEUTSCH  0
  #endif

  typedef unsigned char byte;
  typedef int handle;

  #include "ad_flat.h"
  #include "ad_linux.h"
  #ifdef __MSDOS__ 
    #include "ad_win32.h"
    #include "ad_dos.h"
  #endif

  // to make the DOS-Compiler happy...
  #ifndef __LINUX__
    #define strncasecmp strnicmp
  #endif

  //
  //  Fixe Konstanten, die nie geaendert werden
  //
  #define REMLEN       80         // Laenge des Remote-Buffers
  #define FALSE    0
  #define NO       0
  #define ERROR    0
  #define NOTFOUND (-1)
  #define TRUE     1
  #define OK       1
  #define YES      1
  #define SAME     0
  #define LOWER    1
  #define HIGHER   2
  #define NIL (-1)
  #define JA   1
  #define NEIN 0
  #define JEIN -1
  #ifdef __UNIX__
  #define NEWLINE "\n"
  #else
  #define NEWLINE "\r\n"
  #endif

  #ifdef INSTCOMPILE
    #include "install.h"
  #else
    #ifdef L2COMPILE
      #include "l2_appl.h"
      #include "l2host.h"
      #include "ax_util.h"
      #include "layer2.h"
      #include "layer1.h"
      #include "util.h"
    #endif

    #ifdef TERMCOMPILE
      #include "l2_appl.h"
      //#include "l2host.h"
      #include "ax_util.h"
      //#include "layer2.h"
      #include "output.h"
      #include "mouse.h"
      #include "paramsg.h"
      #include "stext.h"
      #include "terminal.h"
    #endif

    #ifdef HRX_OPT
      #define _GUEST		// Guest-callsign 
      #define _ASKLOGIN		// Login query
      #define _AUTOFWD		// Automatic fwd-routing
      #define _PACLEN		// Configurable packetlength
      #define _LCF		// Sep. callformat for login and fwding //JJ
    #endif


    #ifdef CB_OPT             // Optionen fuer den CB-Funk
//    #define ALPHA           // This is an alpha version
      #define FEATURE_EDITOR  // enable internal editor in DOS version
      #define FEATURE_MD2     // Enable MD2 support
      #define FEATURE_MD5     // Enable MD5 support
      #define FEATURE_MDPW    // Support for MD2/MD5 passworts

      #define _PACLEN         // configurable packetlength
      #define _DEFREA         // default-readlock for new users
//    #define _AUTOFWD        // automatic fwd-routing
//      #define _FILEFWD        // fwdexport and fwdimport
      #define _SENDLT         // send-cmd ask for a lifetime if the message
                              // is a bulletin
      #define _CHECK_Q        // q-option for check-cmd (use lastquit instead
                              // of lastdirnews)
      #define _QUITCMD        // quit-cmd set lastquit to lastdirnews and
                              // "quit <any>" set lastquit without disc
      #define _BCM_F          // additional notice with BCM -F (DOS version)
      #define _BCMNET         // globale CB-BCMNET Versionskennzeichnung
      #define _UTIMEOUT       // Usertimeout
      #define _TTYPW_OPT      // ALTER TTYPW gibt added/removed aus
      #define _EXT_WATCHDOG   // external watchdog for DOS version (test only)
      #define _UIMPORT        // only thebox userimport (with uimport), if
                              // lastmybbs younger then 6 month
      #define _PWD_GPFIX      // behebt ein Problem bei der User-Pwd Abfrage
                              // mit GP (GP vertraegt kein RETURN unmittelbar
                              // vor dem Pwd) (test only)
      #define _MUISF          // Forwardreihenfolge: Msgs(System), User, Info
      #define _DEFFDELAY      // default-fwd-delay for new users
      #define _FWDONLY        // Unterstuetzung fuer reine S&F-Mailboxen
      #define _COMMANDCOM_FIX // Ruft bei Dos-Ausstiegen Command.com nicht
                              // mehr doppelt, sondern nur noch einfach auf
      #define _DOSEDITOR_FIX  // der Dos-Editor kann nur noch von der
                              // Console aus gestartet werden
    #endif

    #ifdef _BCMNET            // Optionen fuer das CB-BCMNET
      #define _EXDLOGIN       // erweiterters Loginkonzept
      #define _MAILFILTER     // ~-Mail Filter bei Dir, List, Check, Read
      #define _BCMNET_FWD     // CB-BCMNET Forward Routinen
      #define _LONG_HROUTE    // Unterstuetzung fuer lange H-Routen
    #endif


    #ifdef BOXCOMPILE

/*---------------------------------------------------------------------------*/

#ifdef __LINUX__      
  #define _AX25K       // Support for Kernel AX25 
#endif

#ifdef CB_OPT
  #ifdef __LINUX__
    #define MAILSERVER
    #define FILESURF
  #endif
#else
  #define MAILSERVER		// Enable the mailinglist server
  #define FILESURF		// Enable the fileserver area
#endif
//#define _PACLEN

#ifdef __FLAT__
//#define _FILEFWD               // Enable file-forwarding
  #define MACRO                 // Enable macro interpreter support
  #define FEATURE_MD2		// Enable MD2 support
  #define FEATURE_MD5		// Enable MD5 support
  #define FEATURE_MDPW		// Support for MD2/MD5 passworts
  #define SERVIF		// Enable the serv interface
  #define RADIOIF		// Enable radio (net cmd TNT/Wampes) interface
  #define FEATURE_YAPP		// Enable the YAPP file transfer protocol
//  #define FEATURE_DIDADIT       // Enable the DIDADIT file transfer protocol
//  #define FEATURE_BINSPLIT      // Enable BIN split capability
#endif

#define RUNUTILS       // Enable the runutility interface 
#define FBBFWD         // Enable FBB-forwarding 
//#define FEATURE_SERDOS // Enable serial interface in DOS version
//#define FEATURE_EDITOR // Enable internal editor in DOS version

// #define ALPHA          // This is an alpha version
// #define _WXSTN      // WX station (do NOT define HERE, use makefile.wx)

/*---------------------------------------------------------------------------*/

      #include "color.h"
      #include "util.h"
      #include "msg.h"
      #include "tasking.h"
      #include "mail.h"
      #include "window.h"
      #include "mbcrc.h"
      #include "mbfbb.h"
      #include "huffman.h"
      #include "mbfilesv.h"
      #include "mbmailsv.h"
      #include "mbfileio.h"
      #include "mbyapp.h"
      #include "mbdidadi.h"
      #include "mbgrep.h"
      #include "mbpop3.h"
      #include "mbmd2md5.h"
#ifdef _WXSTN
      #include "mbwx.h"
#endif
    #endif
  #endif
#endif // _BAYCOM_H

/*---------------------------------------------------------------------------*/
