/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------------
  Definitionen und Deklarationen fuer Mailbox
  -------------------------------------------


  Copyright (c)       Florian Radlherr
		      Taubenbergstr. 32
		      D-83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/


//19980115 OE3DZW removed obsolete defines, changed fbb-fwd-path
//                added ad_timezone()
//19980124 OE3DZW added define for REJECTLOGNAME
//19980202 OE3DZW added option for new callcheck (from hrx), id for cb-mode
//19980208 OE3DZW defined BETREFFLEN
//19980211 OE3DZW added bytes/connects to fwdpara_t
//19980215 OE3DZW added define for syslog_r.bcm
//19980218 OE3DZW added msgty(pe) to mailflags
//19980301 OE3DZW added ax25_set_pid (mbflex.cpp)
//19980226 hrx    added taskwin to functions (mbinterf.cpp)
//19980301 OE3DZW added killforwarded, add_hold
//19980311 DG9MHZ changes for Linux-Kernel AX25
//19980324 DG4MMI support for md2/5
//19980408 hrx    cbmodeid changed (from /cb to cb)
//                autotrcwin added to mailpara_t
//                mbcheckcount added to functions, section mbcheck.cpp
//                trcwin added to functions, section mbinterf.cpp
//19980411 hrx    changed type of mbcheckcount() to long
//                added autofwd as part of hrx_opt
//                added mbafwd.cpp to function section, currently
//                autofwd() and fwdlist() are used
//19980613 hrx    added _paclen conditional to hrx_opt
//                added _asklogin conditional tp hrx_opt
//                added _cfwd conditional tp hrx_opt
//                added CHECKNUMNAME  "checknum.bcm" and
//                CHECKNUMTMP "checknum.$$$". used for autofwd.
//                added paclen int to user_t, mailpara_t. added
//                structures hadr_t, hadr_old_t, used for autofwd.
//                added uclose(), hadr_tryopen(), loadhadr() to functions,
//                section mbhadr.cpp. added createboardfwd to mailpara_t
//                added autofwdtime to mailpara_t
//19980619 OE3DZW moved defines for options to baycom.h
//19980913 OE3DZW added savebroken
//19981015 OE3DZW added parameters for wxstation
//19990111 OE3DZW added dirformat to user-database
//19990714 DH3MB  Changed declarations for mbfwd.cpp and mbfwdrli.cpp
//19990721 hpk    added paclen in user_t for linux version
//                added minpaclen,maxpaclen,defpaclen in mailpara_t
//19990723 hpk    added defrea to mailpara_t working under _DEFREA
//19990725 DB1RAS fixed bug in _PACLEN, layer2 did not work
//19991003 hpk    added pwonly to mailpara_t, working under _EXDLOGIN
//19991009 DB1RAS fixed declaration for _AUTOFWD
//19991021 hpk    added usertimeout to mailpara_t, working under _UTIMEOUT
//19991201 DB1RAS added guestlevel to tvar_t, working under _EXDLOGIN
//19991202 DB1RAS added deffhold to mailpara_t, working under _EXDLOGIN
//199912   DB1RAS added deffdelay to mailpara_t, working under _DEFFDELAY
//19991225 DB1RAS added fwdonly to mailpara_t, working under _FWDONLY

/*---------------------------------------------------------------------------*/

#undef  VNUMMER
#define VNUMMER      "1.42_cb8"

//*************************************************************************
// Use THIS!
//*************************************************************************
#define safe_strncpy(a,b,n)             {strncpy(a,b,n-1);a[n-1]=0;}
#define safe_strcpy(a,b)                safe_strncpy(a,b,sizeof(a))

/*---------------------------------------------------------------------------*/

//*************************************************************************
//
//  Filenames
//
//*************************************************************************
#define CRONTABNAME      "crontab.bcm"
#define VIDNAME          "dosvid.bcm"
#define FWDLISTNAME      "fwd.bcm"
#define BEACONNAME       "beacon.bcm"
#define CONVFILENAME     "convname.bcm"
#define CONVTMPNAME      "convname.$$$"
#define CONVLIFENAME     "convlife.bcm"
#ifdef __MSDOS__
#define USERNAME         "users.bcm"
#define USERNAME_L       "users3.bcm"
#define USERNAMEBAK      "users.bak"
#define HADROLDNAME      "hadr2.bcm"
#define BIDNAME          "bids2.bcm"
#define BIDNAME_L        "bids3.bcm"
#else
#define USERNAME         "users3.bcm"
#define USERNAMEBAK      "users3.bak"
#define HADROLDNAME      "hadr3.bcm"
#define BIDNAME          "bids3.bcm"
#endif
#define HADRNAME         "hadr4.bcm"
#define HADRHASHNAME     "hadrhash.bcm"
#define USERHASHNAME_OLD "userhash.bcm"
#define USERHASHNAME     "userh2.bcm"
#define USERHASHNAMEBAK  "userh2.bak"
#define BIDHASHNAME      "bidh2.bcm"
#define BTMP             "bids2.$$$"
#define BHTMP            "bidh2.$$$"
#define BBAK             "bids2.bak"
#define BHBAK            "bidh2.bak"
#define DIRLISTNAME      "list.bcm"
#define DIRTMPNAME       "list.$$$"
#define MBINITOLDNAME    "bcm.ini"
#define MBINITNAME       "init.bcm"
#define INITTMPNAME      "init.$$$"
#define INITBAKNAME      "init.bak"
#define LOGNAME          "log.bcm"
#define CHECKNAME        "check.bcm"
#define CHECKTMPNAME     "check.$$$"
#define CHECKNUMNAME     "checknum.bcm" // hrx
#define CHECKNUMTMP      "checknum.$$$" // hrx


#ifdef _TTY                                    // JJ
 #define INITTTYNAME     "inittty.bcm"         // JJ
 #define INITTTYTMPNAME  "inittty.$$$"         // JJ
 #define INITTTYBAKNAME  "inittty.bak"         // JJ
#endif                                         // JJ
#define PASSWDNAME       "passwd.bcm"
#define PRIVNAME         "pwlist.bcm"
#define TREENAME         "bulletin.bcm"
#define TREETMPNAME      "bulletin.$$$"
#define TREEBAKNAME      "bulletin.bak"
#define SYSLOGNAME       "syslog.bcm"
#define SYSLOGRNAME      "syslog_r.bcm"
#define REJECTLOGNAME    "rejlog.bcm" //OE3DZW Log of all rejects
#define CMDLOGNAME       "cmdlog.bcm"
#define PWLOGNAME        "pwlog.bcm"
#define ERASELOGNAME     "eraselog.bcm"
#define UNKNOWNNAME      "unknown.bcm"
#define SFHOLDNAME       "sfhold.bcm"
#define RUNDATNAME       "rundat.bcm"
#define BIDNAME_OLD      "bids.bcm"
#define BIDHASHNAME_OLD  "bidhash.bcm"
#define RUNNAME          "runutil.bcm"
#define MAILLISTNAME     "mailserv.bcm"
#define MAILLISTTMPNAME  "mailserv.$$$"
#define REJECTNAME       "reject.bcm"
#define POPDBNAME        "popstate.bcm"
#define POPDBTMPNAME     "popstate.$$$"
//optional header for beacon 
#define BEACONHEADNAME   "beachead.bcm"
#define ISSUENAME        "issue.bcm"
#define BOARDINFO        "boardinf.bcm"
#define CONVATNAME       "convat.bcm"
#define RHOSTSNAME       "rhosts.bcm"
#define L2INITNAME       "init.l2"
#define L2PATHNAME       "netpath.bcm"

#define MSGPATH      "msg"
#define SYSTEMPATH   "system"
#define LOGPATH      "log"
#define TRACEPATH    "trace"
#define TEMPPATH     "temp"
#define FWDPATH      "fwd"
#define FBBPATH      "fwd/fbb" //OE3DZW changed path to fwd
#define STD_BOXHEADER "BayCom-Mailbox"

#define HASH16     (65536L)
#define HASH32     (65536L*2)

#define BOARDLEER (-1)
#define MAXBEREICH (UINT_MAX)

#define BINCMDLEN   80 // fix size of BIN-header within mail files
#define MK_MYCALLS  8
#define BETREFFLEN  80 // max. length of title
#define MIN_TRIG_LEN 11 // min. length of a line in the fwd-trigger file 

#define DEFSMTPPORT  8025
#define DEFPOP3PORT  8110
#define DEFNNTPPORT  8119
#define DEFHTTPPORT  8080
#define DEFTELNPORT  4719
#define DEFSERVPORT  8123
#define DEFRADIOPORT 8124

#define FWDOK       0
#define FWDNO       1
#define FWDREJ      2
#define FWDERR      3

/*---------------------------------------------------------------------------*/

typedef unsigned long bitfeld;

//*************************************************************************
//
//  Length of special strings
//
//*************************************************************************
#define BIDLEN      12
#define HADRESSLEN  39

#ifndef _LONG_HROUTE
  #define MYBBSLEN      24
#else
  #define MYBBSLEN  HADRESSLEN // length of complete MyBBS incl. H-Route
  #define OLDMYBBSLEN   24     // for compatibility with the old mybbs field
#endif

#define CALLEN      6
#define PROMPTLEN   20
#define NAMELEN     14
#define ZIPLEN      8
#define QTHLEN      30
#define FIRSTCMDLEN 20
#define REJECTLEN   79
#define ZIELLEN     10
#define FSPATHLEN   50
#define CMDBUFLEN  130

// Max. maillength ca. 10 MBytes
#define MAXMAILLEN 9999999L
#define MAXMAILDIG 7

// Min. available diskspace in kbytes
#define USERDISKFULL  5000L
#define INFODISKFULL 10000L
#define HOMEDISKFULL  1000L	//db1ras (Wunsch vom Franz)

#ifdef _BCMNET
  #define CBMODEID "*CB-BCMNET*"
#else
  #define CBMODEID "CB"
#endif

  #define START7PFLAG " go_7+. "
  #define STOP7PFLAG  " stop_7+. "

/*---------------------------------------------------------------------------*/

#define MIME_JPG "image/jpeg"
#define MIME_GIF "image/gif"
#define MIME_TXT "text/html"
#define MIME_BIN "application/x-binary"
#define MIME_WAV "audio/wav"

/*---------------------------------------------------------------------------*/

#define BINMODE_AUTOBIN 0
#define BINMODE_YAPP    1
#define BINMODE_DIDADIT 2

/*---------------------------------------------------------------------------*/

//*************************************************************************
//
//  Characters used in YAPP-file-transfer and FBB-forwarding (DG4MMI)
//
//*************************************************************************
#define NUL             0x00 // End of string / Separator
#define SOH             0x01 // Start of header
#define STX             0x02 // Start of transmission
#define ETX             0x03 // End of transmission
#define EOT             0x04 // End of Transfer
#define ENQ             0x05 //
#define ACK             0x06 // Acknowledgement
#define DLE             0x10 //
#define NAK             0x15 // Negative Acknowledgenment
#define CAN             0x18 // Cancel

/*---------------------------------------------------------------------------*/

#ifdef __MSDOS__
typedef struct user_t
//*************************************************************************
//
//  Struktur fuer die Userdaten
//
//*************************************************************************
{ char     call[CALLEN+1];          //  7 Rufzeichen des Users
  char     name[NAMELEN+1];         // 15 A NAME
#ifndef _LONG_HROUTE
  char     mybbs[MYBBSLEN+1];       // 25 A FORWARD
#else
  char     oldmybbs[OLDMYBBSLEN+1]; // 25 for compatibility with old mybbs field
#endif
  char     prompt[PROMPTLEN+1];     // 21 A PROMPT
  char     sprache[4];              //  4 A SPEECH
  char     password[40];            // 40 A PW ; pw off = 0x01 0x00 ..
  char     notvisible[REJECTLEN+1]; // 80 A REJECT
  char     firstcmd[FIRSTCMDLEN+1]; // 21 A COMMAND
  short unsigned helplevel;         //  2 A HELPLEVEL
  short unsigned zeilen;            //  2 A LINES
  char     nopurge;                 //  1 Board wird nicht geputzt
  char     nameok;                  //  1 Name selbst eingegeben
  time_t   lastboxlogin;            //  4 letzter Login (UNIX)
  time_t   lastdirnews;             //  4 letztes DIR NEWS / Check (UNIX)
  time_t   lastquit;                //  4 letztes QUIT
  long     mailsent;                //  4 gesendete Nachrichten
  long     mailgot;                 //  4 erhaltene Nachrichten
  long     mailread;                //  4 gelesene Nachrichten
  long unsigned logins;             //  4 logins
  char     mybbsok;                 //  1 MYBBS selbst eingegeben (1)
  bitfeld  opt[8];                  // 32 eingestellte Optionen
  short unsigned lf;                //  2 A LF
  char     umlaut;                  //  1 A UMLAUT (nicht impl)
  time_t   mybbstime;               //  4 Datum des letzten MYBBS (UNIX)
  char     ttypw[9];                //  9 A TTYPW (TTY-Password)
  time_t   lastload;                //  4 interner Merker fr Verwaltung
  long unsigned  daybytes;          //  4 gelesene Bytes heute
  short unsigned status;            //  2 A STATUS
  char     uplink[10];              // 10 uplink-Digi
  char     readlock;                //  1 Privatmails nicht lesbar (")
  char     pwline;                  //  1 Leerzeile beim Login
  char     echo;                    //  1 Eigene Eingaben zurckschicken
  short unsigned fdelay;            //  2 Verzgerung fr eigene Nachrichten
  short unsigned fhold;             //  2 Verzgerung fr Nachrichten
  char     rlimit;                  //  1 fremde Privatmails nicht lesbar
  char     ufwd[40];                // 40 Connect-Path fuer User-forwarding
  unsigned char loginpwtype;        //  1 Password-type for ax-login (DG4MMI)
                                    //    0..BayCom-Password 
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  unsigned char sfpwtype;           //  1 Password-type for S&F (DG4MMI)
                                    //    0..BayCom-Password                                    
                                    //    1..MD2
                                    //    2..MD5
                                    //    100..disabled
  char newcall[CALLEN+1];           //  7 New callsign (license update)
  short unsigned paclen;            //  2 Packetlength               
  char dirformat;                   //  1 Dir/Check/List in new format
  char binmode;                     //  1 AutoBIN/YAPP/DIDADIT bei BIN-Mails
  char     unsecure_smtp;           //  1  0=>needs to pop before smtp
                                    //     1=>smtp without pop allowed
#ifndef _LONG_HROUTE
  char     longmybbs[40];           // 40 reserved for long MyBBS
#else
  char     mybbs[MYBBSLEN+1];       // 40 A FORWARD
#endif
  char restplatz[82];               // 82 ist noch frei (definiert 0) 
  long unsigned filepos;            //  4 Position im Userfile
  long unsigned nextsamehash;       //  4 hash list link
  short unsigned filepos_old;       //  2 (obsolete) Position im Userfile
  short unsigned nextsamehash_old;  //  2 (obsolete) hash list link
} user_t;

/*---------------------------------------------------------------------------*/

typedef struct user_linux_t
#else
typedef struct user_t
#endif
//*************************************************************************
//
//  Struktur fuer die Userdaten in der Linux-Version, beruecksichtigt
//  Alignment vom GCC
//
//*************************************************************************
{ time_t   lastboxlogin;            //  4 letzter Login (UNIX)
  time_t   lastdirnews;             //  4 letztes DIR NEWS / Check (UNIX)
  time_t   lastquit;                //  4 letztes QUIT
  time_t   mybbstime;               //  4 Datum des letzten MYBBS (UNIX)
  time_t   lastload;                //  4 interner Merker fr Verwaltung
  long unsigned daybytes;           //  4 gelesene Bytes heute
  long     mailsent;                //  4 gesendete Nachrichten
  long     mailgot;                 //  4 erhaltene Nachrichten
  long     mailread;                //  4 gelesene Nachrichten
  long unsigned logins;             //  4 logins
  bitfeld  opt[8];                  // 32 eingestellte Optionen
  long     spare_long[10];
  short unsigned helplevel;         //  2 A HELPLEVEL
  short unsigned zeilen;            //  2 A LINES
  short unsigned lf;                //  2 A LF
  short unsigned status;            //  2 A STATUS
  short unsigned filepos_old;       //  2 (obsolete)Position im Userfile
  short unsigned nextsamehash_old;  //  2 (obsolete)hash list link
  short unsigned fdelay;            //  2 Verzoegerung fr eigene Nachrichten
  short unsigned fhold;             //  2 Verzoegerung fr Nachrichten
  short unsigned paclen;            //  2 packet length
  short unsigned spare_short[19];
  char     call[CALLEN+1];          //  7 Rufzeichen des Users
  char     name[NAMELEN+1];         // 15 A NAME
#ifndef _LONG_HROUTE
  char     mybbs[MYBBSLEN+1];       // 25 A FORWARD
#else
  char     oldmybbs[OLDMYBBSLEN+1]; // 25 for compatibility with old mybbs field
#endif
  char     prompt[PROMPTLEN+1];     // 21 A PROMPT
  char     sprache[4];              //  4 A SPEECH
  char     password[40];            // 40 A PW
  char     notvisible[REJECTLEN+1]; // 80 A REJECT
  char     firstcmd[FIRSTCMDLEN+1]; // 21 A COMMAND
  char     nopurge;                 //  1 Board wird nicht geputzt
  char     nameok;                  //  1 Name selbst eingegeben
  char     mybbsok;                 //  1 MYBBS selbst eingegeben (1)
  char     umlaut;                  //  1 A UMLAUT (nicht impl)
  char     ttypw[9];                //  9 A TTYPW (TTY-Password)
  char     uplink[10];              // 10 uplink-Digi
  char     readlock;                //  1 Privatmails "nicht lesbar"
  char     pwline;                  //  1 Leerzeile beim Login
  char     echo;                    //  1 Eigene Eingaben zurckschicken
  char     rlimit;
  char     ufwd[40];                // 40 Connect-Path fuer User-forwarding
  unsigned char loginpwtype;        //  1 Password-type for ax-login (DG4MMI)
  unsigned char sfpwtype;           //  1 Password-type for S&F (DG4MMI)
  char     newcall[CALLEN+1];       //  7 New callsign (lizence update)
  char     dirformat;               //  1 Dir/Check/List in new format
  char     unsecure_smtp;           //  1  0=>needs to pop before smtp
                                    //     1=>smtp without pop allowed
  char     binmode;                 //  1 AutoBIN/YAPP/DIDADIT bei BIN-Mails
#ifndef _LONG_HROUTE
  char     longmybbs[40];           // 40 reserved for long MyBBS
#else
  char     mybbs[MYBBSLEN+1];       // 40 A FORWARD
#endif
  char     restplatz[3];            //  3 ist noch frei (definiert 0)
  unsigned long filepos;            //  4 position within file
  unsigned long nextsamehash;       //  4 hash to next record
#ifdef __MSDOS__
} user_linux_t;
#else
} user_t;
#endif

#ifndef L2COMPILE
/*---------------------------------------------------------------------------*/

typedef struct wpdata_t
{
  char call[CALLEN+1];
  char bid[BIDLEN+1];
  char bbs[HADRESSLEN+1];
  time_t mybbstime;
  char logincall[CALLEN+1];
  char origin[CALLEN+1];
  long hops;
  char name[NAMELEN+1];
  char zip[ZIPLEN+1];
  char qth[QTHLEN+1];
} wpdata_t;

/*---------------------------------------------------------------------------*/

#ifdef _WXSTN
// for wx-station

typedef struct
{ int data_valid;
  long 
       dayoyear,
       minuteofday,
       wind_beaufort;
  double
       sat_sp,         /* saturation steam pressure */
       rainltt,        /* rain long term total  */
       steam_pressure,
       wind_chill,
       windspeed,
       outdoort,
       snowfall_limit,
       air_pres_qnh,
       air_pres_qfe,
       abs_humidity,
       dew_point,
       kond_niveau,
       indoort,           /* indoor temperature */
       humidity,
       hum_indoor,        /* humidity indoor */
       wind_direction;    /* 0..360 degrees */
       char *winddir_str;
       time_t t;
} wxdata_t;

#endif
/*---------------------------------------------------------------------------*/

typedef enum option_index_t
//*************************************************************************
//
//  Index fr das Feld mit den Optionen
//
//*************************************************************************
{ o_id=0,      // info-dir
  o_ud,        // user-dir
  o_il,        // info-list
  o_ul,        // user-list
  o_ir,        // info-read
  o_ur,        // user-read
  o_ch,        // check
  o_gr         // grep (unused)
} option_index_t;

/*---------------------------------------------------------------------------*/

typedef enum umlaut_t
{ um_none,     // keine Umlautwandlung
  um_ibm,      // IBM-Umlaute
  um_din,      // DIN-Umlaute (statt [\]{|}~)
  um_aeoeue    // Wandlung nach AE OE UE
} umlaut_t;

/*---------------------------------------------------------------------------*/

typedef enum fwdtype_t
{ fwd_none,
  fwd_standard,
  fwd_user,
  fwd_file
} fwdtype_t;

/*---------------------------------------------------------------------------*/

typedef enum loginmode_t
{ login_silent,
  login_standard,
  login_ufwd,
  login_fwd,
  login_nofwd
} loginmode_t;

/*---------------------------------------------------------------------------*/

typedef struct bulletin_t
{ char     name[MAXTREELENGTH];
  byte     flatoffset; //offset of name w/o path
  short unsigned lifetime_min;
  short unsigned lifetime_max;
  //time_t   created;
  time_t   newestmail;
} bulletin_t;
/*---------------------------------------------------------------------------*/
// JJ

typedef struct ttypara_t
{ int      comirq;
  int      comadr;
  char     cmdatz[60];
  char     cmdata[60];
  char     cmdatd[60];
  char     ringindicator[60];
  char     connectindicator[60];
  char     dialprefix[60];
  char     dialsuffix[60];
  int      ringtimeout;
  int      dialtimeout;
  int      dialdelay;
  int      connectdelay;
  int      maxcontime;
  int      maxcons;
} ttypara_t;

/*---------------------------------------------------------------------------*/

typedef struct convname_t
{ char     oldname[9];
  char     newname[9];
} convname_t;

/*---------------------------------------------------------------------------*/

typedef struct convlife_t
{ char     string[16];
  short int      life;
} convlife_t;

/*---------------------------------------------------------------------------*/

typedef struct mailpara_t
{ char     boxname[CALLEN+1];
  char     boxadress[HADRESSLEN+1];
  char     boxheader[60];
#ifdef __FLAT__  
  int      tcp_port;
  int      http_port;
  int      smtp_port;
  int      pop3_port;
  int      nntp_port;
  int      serv_port;
  int      radio_port;
#endif  
#if defined __LINUX__ && defined _AX25K
  char     ax25k_if[80];
#endif
#ifdef __DOS16__
  int      pcisutc;
  int      stimeoffset;
#endif
#ifdef _INIT_PACLEN
  int      paclen; 
#endif
  unsigned fwdssid;
  unsigned callformat;                           //format amateur/cb/both
#ifdef _LCF
  unsigned logincallformat;  //JJ  
#endif  

  unsigned savebroken;         // save broken 7+files
           // 0..do not save, 1..save if fbb-fwding, 2..always save it
  char     sysopcall[CALLEN+1];
#ifdef _GUEST
  char     guestcall[CALLEN+1]; 
#endif
  unsigned infolife;
  unsigned userlife;
  unsigned oldestfwd;
  unsigned oldestbeacon;
  char     userpath[FNAMELEN+1];
  char     infopath[FNAMELEN+1];
#ifdef FILESURF // DG4MMI
  char     fspath[FSPATHLEN+1];
#endif
  char     prompt[PROMPTLEN+1];
  char     sprache[4];
  char     firstcmd[FIRSTCMDLEN+1];
  char     mycall[4][10];
  char     macro_mycall[MK_MYCALLS][10];
  unsigned mycalls;
  unsigned macro_mycalls;
  unsigned helplevel;
  unsigned zeilen;
  unsigned deflf;
  unsigned tracelevel;
  unsigned fwdtrace;
  unsigned dosinput;
  unsigned autotrcwin;
  unsigned sysopbell;
  unsigned usvsense;
  unsigned watchdog;
  unsigned userquota;
  unsigned maxlogins;
  unsigned disable;
  unsigned scrolldelay;
  unsigned fwdtimeout;
  unsigned crtsave;
  unsigned timeslot;
  unsigned hadrstore;
  unsigned userpw;
  unsigned readlock;
  unsigned eraselog;
  unsigned remerase;
  unsigned createboard;                // 0: TMP wird erzeugt, keine Subboards
				       // 1: TMP wird erzeugt, Subboards
				       // 2: kein TMP, keine Subboards
  long     maxbids;                    // max. nr of bids
  char     ttymode[20];                // z.B. 1:9600,8,N,1,E
  bitfeld  opt[8];                     // eg. fwd-options
  unsigned long maxusers;              // max. nr. of users

#ifdef _AUTOFWD
  unsigned autofwdtime; // hrx
#endif
  unsigned nopurge;
#ifdef MAILSERVER // DG4MMI
  unsigned maillistserv;
#endif
#ifdef _TTY  
  unsigned ttydevice;
#endif  
#ifdef _WXSTN
  wxdata_t wx;
  char wxstnname[31];
  /* absolute altitude of qth in meter */
  long wxqthaltitude;
  /* relative altitude of sensor over ground */
  long wxsensoraltitude;
  char wxtty[21];
  char wxpath[30];
#endif    
#ifdef _PACLEN
  int minpaclen,maxpaclen,defpaclen;
#endif
#ifdef _DEFREA
  int defrea;
#endif
#ifdef _EXDLOGIN
  int pwonly;
  int deffhold;
#endif
#ifdef _DEFFDELAY	//db1ras
  int deffdelay;
#endif
#ifdef _FWDONLY		//db1ras
  int fwdonly;
#endif
#ifdef _UTIMEOUT
  int usertimeout;
#endif
#ifdef _EXT_WATCHDOG	//db1ras
  char dosbefore[120];
  char dosafter[120];
#endif
} mailpara_t;

/*---------------------------------------------------------------------------*/

typedef struct conv_t
{ struct conv_t *next;
  char line[100];
} conv_t;

/*---------------------------------------------------------------------------*/

typedef struct tvar_t : public task_t
{ char     logincall[CALLEN+1];   // Rufzeichen der eingelogten Station
  char     uplink[10];            // erstes Digirufzeichen bzw. 'Console'
#ifdef HRX_OPT
  char     downlink[10];          // letztes Digirufzeichen
#endif    
  char     peerip[18];            // IP-Nummer
  char     mycall[10];            // Connect-Rufzeichen ZUR Box
  int      semalock;              // Flag: File war gesperrt
  char     bereich;               // Flag fr Bereich wurde angegeben
  bitfeld  optplus;               // gesetzte Optionen der Kommandozeile
  bitfeld  optminus;              // gelschte Optionen
  int      optgroup;              // Index fr Option (vom Befehl abhngig)
  bitfeld  opt;                   // modifizierte Option (abh. Bef/Opt/U/I)
  char     line[300];             // Mehrzweckpuffer
  long     txbytes;               // Zhler fr gesendete Daten
  long     rxbytes;               // Zhler fr empfangene Daten
  unsigned sentfiles;             // Zhler fuer gesendete Files
  unsigned readfiles;             // Zhler fuer gelesene Files
  int      linecount;             // Zhler fuer Zeilenumbruch (Ausgabe)
  int      abbruch;               // Flag fr Ausgabe-Stop
  int      quit;                  // Flag fr 1=logout 2=fast logout
  char     eingabefehler;         // Zhler fr falsche Eingaben
  char     mailtype;              // Type der Mail: B(ulletin), P(ersonal), ...
  char     fwdhold;               // Mail wird nicht (mehr) automatisch weitergeleitet
  char     fwdprop;               // Mail wurde bereits beim Forward vorgeschlagen
  char     replied;               // Mail wurde beantwortet
  char     msgty,                   //msgtype
                                    // !..unknown 
                                    // 7..7plus
                                    // 6..7plus with errors
                 flag6,flag7,flag8,
           flag9,flaga,flagb,flagc,
           flagd,flage,flagf,flag0; // Reservierte weitere 12 Flags
#ifdef _EXDLOGIN
  unsigned char guestlevel;	  // Guestlevel: 0=normal, 1=gastbbs, 2=gastpwd
#endif
#if 0
  char     chatbuffer[100];       // Zeile fuer Mitteilungen von anderen
#else
  conv_t  *conv;
  int      convtable;
#endif
  char     sysop;                 // Flag: Benutzer hat Sysoprechte
  FILE     *inputfile;            // Filepointer, wenn Eingabe umgeleitet ist
  FILE     *outputfile;           // Filepointer, wenn Ausgabe umgeleitet ist
  char     oldinput;              // Merker fr Standardeingabe
  char     oldoutput;             // Merker fr Standardausgabe
  char     continous;             // Flag: Ausgabe wird nicht angehalten
  time_t   logintime;             // Merker, wann der Login war
  int      privoffset;            // index in PRIV-File (fr Forward-PWD)
#ifdef FEATURE_MDPW
  char     password[33];          // zuletzt aktives Passwort (fuer Fwd)
#else
  char     password[6];           // zuletzt aktives Password (fwd!)
#endif
  int      job;                   // Wird in User-Liste angezeigt

  char     prompt[30];            // Call/Boardname im Prompt
  char     mask[FNAMELEN+1];      // momentan aktive Dir-Maske (ende *.*)
  int      index;                 // Index in Board-Tree (nur temporr)
  char     mailpath[FNAMELEN+1];  // Name der aktiven Mail mit Pfad
  char     mailfname[10];         // nur Filename (=Datum/Uhrzeit) der Mail
  char     listpath[FNAMELEN+1];  // Name des akiven Listfiles mit Pfad
  char     boardpath[FNAMELEN+1]; // Dateipfad fr Board (z.B. "info/soft/gp")
  char     boardname[10];         // Name des Boards ohne Pfad (z.B. "GP")
  char     boardfullname[FNAMELEN+1]; // Boardname komplett (z.B. "SOFT/GP")
  char     ziel[ZIELLEN+1];       // evtl unvollst. Ziel nach SEND
  char     zielboard[ZIELLEN+1];  // DG4MMI: Board nach convname.bcm
  char     herkunft[CALLEN+1];    // Call des Verfassers der Mail
  char     frombox[CALLEN+1];     // Box, von der WIR die Mail bekommen haben
  char     at[HADRESSLEN+1];      // vollstndige H-Adresse der Nachricht
  char     bid[BIDLEN+1];         // BID der letzten Nachricht, evtl neu
  long     binstart;              // Position des BIN-Teils in der Mail-Datei
  char     destboxlist[162];      // Forward-Liste der Nachricht
  char     usermail;              // Nachricht ist User-Nachricht
  char     gelesen;               // Nachricht ist schon gelesen
  char     geloescht;             // Nachricht ist geloescht
  int      lifetime;              // Lifetime (insgesamt, nicht aktuell)
  unsigned lines;                 // Anzahl Zeilen der letzten Nachricht
  long     bytes;                 // Anzahl Bytes der letzten Nachricht
  char     betreff[BETREFFLEN+1]; // Titel der Nachricht
  time_t   abwann;                // Zeitangabe fr DIR AFTER etc.
  unsigned beginn;                // Bereich fr DIR READ ERASE CHECK
  unsigned ende;                  // -------------"------------------
  char     replyboard[10];        // Boardname der zuletzt gelesenen Nachricht
  unsigned replynum;              // Nummer der zuletzt gelesenen Nachricht
  char     tmpbid[5][BIDLEN+1];   // Momentan empfangene BIDs
  int      boardlife_max;         // momentan aktive maximale Lifetime
  int      boardlife_min;         // momentan aktive minimale Lifetime
  int      msg_loadnum;           // "magic number" fuer geladene MSG-Version
  int      msg_offset;
  time_t   lastdirnews;           // exakter Zeitpunkt des D N (Check)
  fwdtype_t forwarding;           // fwd_none, fwd_standard, fwd_user
  void    *fwd_parameter;         // ggf. Zeiger auf fpara-struktur
  char     boxtyp;                // Software, die beim Partner rennt
  char     boxversion;            // Version der Forwardpartner-Box
  void    *script_p;
  char    *inbuffer;
  int      inbindex;
  int      inbmax;
  char    *outbuffer;
  int      outbindex;
  int      outbmax;
  int      http;
  jmp_buf  io_mem_jmp;
  user_t   u;                     // USER-Struktur fuer eingeloggten User
#ifdef __FLAT__
  int       headermode;
#endif
#ifdef FILESURF // DG4MMI
  char     fspath[100];
  char     fsmode;
#endif
#ifdef FBBFWD // DG4MMI
  unsigned long int fbboffset;
#endif
#ifdef _PACLEN
  unsigned char      pacbytes;            // like txbytes but one packet only
#endif
} tvar_t;

/*---------------------------------------------------------------------------*/

typedef struct fwdpara_t
{ char    call[7];         // Rufzeichen der Nachbarboxen
  char    concall[50];     // Connect-Rufzeichen der Nachbarboxen
  char    times[25];       // Bytefeld fuer die Uhrzeiten
  long    maxbytes;        // maximale Anzahl pro geforwardetes File
  bitfeld options;         // eingestellte Optionen
  char    *dest;           // Index in boxdest[]-Liste
  char    connectbar;      // war beim letzten Versuch erreichbar  
  time_t  lastconok;
  time_t  lastlogin;
  time_t  lastwp;  
  time_t  sidrtt; 
  long    timeout_cnt;     // number of timeouts
  long    n_conok;         // number of outgoing connects
  long    n_login;         // number of incoming connects
  long    txf;             // number of files sent
  long    rxf;             // number of files received
  char    ssid;
  char    newmail;
  char    mid;
  char    u_onlydelay;
  char    i_onlydelay;
#ifdef HRX_OPT
  int     fwdcallformat;  // callformat allowed for forwarding
#endif  
} fwdpara_t;

/*---------------------------------------------------------------------------*/

typedef enum boxkind_t
{ b_baycom,
  b_dxl,
  b_thebox,
  b_fbb,
  b_rli,
  b_mbl,
  b_dp,
  b_wgt,
  b_unknown
} boxkind_t;

/*---------------------------------------------------------------------------*/

typedef enum mail_modify_t
{ w_erase,
  w_unerase,
  w_forward,
  w_transfer,
  w_setlifetime,
  w_reply,
  w_comment
} mail_modify_t;

/*---------------------------------------------------------------------------*/

typedef enum
{ unbekannt,
  bekannt,
  fuernachbarn,
  bleibtliegen
} fwd_weiter_t;

/*---------------------------------------------------------------------------*/

typedef enum
{ sh_noinput,
  sh_forceinput,
  sh_ifmultitask
} shellinput_t;

/*---------------------------------------------------------------------------*/
#define HTMP         "hadrs.$$$"
#define HHTMP        "hadrhash.$$$"
#define ADJNUM 20
#define DAY (3600L*24)
#define HEADERLEN 60
#define BSTATUSLEN 20          
#define BHWADDRESSLEN 49
#define BPROTOLEN 10		
#define BVERSION  10            // Version 1.0
#define BSTATUS  "0"            // inactive


typedef struct hadr_t
{
  long   bulletins;                // 4
  long   usermails;                // 4
  time_t delay     [ADJNUM];       // 80
  time_t lastupdate[ADJNUM];       // 80 
  time_t lasthtime;                // 4 latest header-update scanned (mail)
  time_t lastwprcvd;               // 4 latest wp-update received
  time_t lastwpsend;               // 4 latest wp-update sent
  long   bversion;                 // 4
  time_t reserved_t[24];           // 96
  short   int rel_mails [ADJNUM];  // 40
  short  int hops      [ADJNUM];   // 40
  short  unsigned nextsamehash;    // 2
  short  reserved_s[25];           // 50
  char   adr[HADRESSLEN+1];        // 40
  char   adjacent  [ADJNUM][7];    // 140
  char   lastheader[HEADERLEN+1];  // 61
  char   lastbid[BIDLEN+1];        // 13
  char   lastboard[9];             // 9
  char   lastuser[7];              // 7
  char   bstatus[BSTATUSLEN+1];    // 21
  char   sysopcall[CALLEN+1];      // 7
  char   protocol[BPROTOLEN+1];     // 11
  char   hwaddress[BHWADDRESSLEN+1];// 50
  char   reserved[253];             // 253
  } hadr_t;

/*---------------------------------------------------------------------------*/

#define ADJOLDNUM 5

#ifdef __MSDOS__
typedef struct hadrold_t
{ char   adr[HADRESSLEN+1];        // 40
  char   adjacent  [ADJOLDNUM][7];    // 35
  short  int rel_mails [ADJOLDNUM];   // 10
  time_t delay [ADJOLDNUM];           // 20
  time_t lastupdate[ADJOLDNUM];       // 20
  short  int hops      [ADJOLDNUM];   // 10
  long   bulletins;                // 4
  long   usermails;                // 4
  time_t lasthtime;                // 4
  char   lastheader[HEADERLEN+1];  // 61
  char   lastbid[BIDLEN+1];        // 13
  char   lastboard[9];             // 9
  char   lastuser[7];              // 7
  char   reserved[17];             // 51
  short unsigned nextsamehash;     // 2
} hadrold_t;
#else
typedef struct hadrold_t
{
  long   bulletins;                // 4
  long   usermails;                // 4
  time_t delay     [ADJOLDNUM];       // 20
  time_t lastupdate[ADJOLDNUM];       // 20
  time_t lasthtime;                // 4
  short  int rel_mails [ADJOLDNUM];   // 10
  short  int hops      [ADJOLDNUM];   // 10
  short  unsigned nextsamehash;    // 2
  char   adr[HADRESSLEN+1];        // 40
  char   adjacent  [ADJOLDNUM][7];    // 35
  char   lastheader[HEADERLEN+1];  // 61
  char   lastbid[BIDLEN+1];        // 13
  char   lastboard[9];             // 9
  char   lastuser[7];              // 7
  char   reserved[17];             // 51
} hadrold_t;
#endif

/*---------------------------------------------------------------------------*/

typedef struct wpb_t
{ 
	    char hadr[HADRESSLEN + 1];
	    long bversion;
	    char bstatus[BSTATUSLEN + 1];
	    char sysopcall[CALLEN + 1];
	    char protocol[BPROTOLEN + 1];
	    char hwaddress[BHWADDRESSLEN + 1];
	    time_t timestamp;
	    long hops;
} wpb_t;


/*---------------------------------------------------------------------------*/

extern unsigned treelen;
extern bulletin_t *tree;
extern unsigned fwdpartners;
extern unsigned fwddestlen;

extern mailpara_t m;
#ifdef _TTY
  extern ttypara_t tty;  //JJ
#endif
extern time_t einschaltzeit;
extern tvar_t *b;
#endif		//L2COMPILE

extern user_t *u;

#ifndef L2COMPILE
extern int boxinaktiv;
extern int reorg_noetig;

extern char abortreason[];
extern int runterfahren;
extern char *stopreason;

#define logout mblogout

//****************************
//       mbutil.cpp
//       bc_util.cpp
//****************************
unsigned           strcrc(char *s);
char               *stristr(char *s1,char *s2);
char               *nexttoken(char *buf,char *token,int maxlen);
char               *get_searchitem(char *instr,char *str,int maxlen);
char               *makeheader(int full);
char               *dezasc(long dez,int stellen);
long               nonlin(long bytes);
long               inonlin(long bytes);
long               ascdez(char *s,int stellen);
char               deznib(int dez);
char               *time2filename(time_t unixtime);
time_t             filename2time(char *name);
int                mbcallok(char *call);
#ifdef _LCF
int                fwdcallok(char *call, int fwdcallformat); //JJ
#endif
char               mbmailt(char *ziel,char *hadr);
char               *rfc_date(time_t t);
char               *full_date(time_t t);
int                mbhadrok(char *hadr);
char               *datestr(time_t time,int year);
char               *timestr(time_t time,int sec);
int                newdate(time_t d1,time_t d2);
void               findbereich(char *buf);
time_t             parse_time(char *datum);
time_t             seek_fname(handle fh,char *fname,char *ok);
int                seek_lastentry(handle fh,int anzahl);
void               scanoptions(char *buf);
void               formoptions(void);
char               *chartomakro(char c,char *ms);
char               *expandmakro(char *s,char *os);
int                filecopy(char *src,char *dest);
int                xrename(char *src,char *dest);
int                xunlink(char *name);
int                xmkdir(char *path);
void               leerzeile(void);
time_t             filetime(char *name);
long               filesize(char *name);
int                isdir(char *name);
char               *getheaderadress(char *rline);
time_t             getheadertime(char *rline);
char               *atcall(char *at);
char               *defext(char *name,char *ext);
void               killbackslash(char *s);
char               jokcmp(char *string, char *jokex, char negative);
int                line_7p(char *p);
int                returnmailok(void);
void               rmcrlf(char *line);
time_t             yymmdd2ansi(char *yymmdd);       
#ifdef HRX_OPT
int                autosysop(void); //JJ autosysop
#endif

//****************************
//       mbbids.cpp
//****************************
char               *bidvorhanden(char *bidname);
int                tmpbidvorhanden(char *bidname);
char               *bidnewfilename(char *bidname,char *newfilename);
void               tmpbidrein(char *bidname, int j);
void               tmpbidraus(int j);
unsigned           bidrein(char *bidname,char *filename);
void               bidinit(int begin);
void               listbids(char *sel);
char               *newbid(int reset);
long               bid_len(void);
void               reorgbid(void);

//****************************
//       mbdir.cpp
//****************************
int                finddir(char *path,int one_letter_boards);
handle             preparedir(char *selektor,int printerror);
void               mbdir(char *selektor,int listcmd);
char               *make_mask(char *mask,char *path);
time_t             dirline_data(char *dirline);
void               sendmailbake(char *name);
void               board_info(char *board);

#ifdef BCC
//****************************
//       mbbcc.cpp
//****************************
void               mbbcc(char *);
#endif

//****************************
//       mbcheck.cpp
//****************************
void               makecheck(void);
void               mbcheck(char *selektor,time_t abwann);
void               make_checknum(char *from);
void               purgecheck(char *name);
#ifdef HRX_OPT
long               mbcheckcount(void); 
#endif

//****************************
//       mbsend.cpp
//****************************
int                mbsend(char *befbuf, int changedir);
void               savemail(void);
char               wantmail(char *reason);
int                mbsend_parse(char *befbuf,int def);
void               showpath(char *adr,int alles);
void               writeheader(FILE *sendf,int transfer);
void               writelines();
void               writemailflags();
void               generate_ack(char *to,char *from,char *subj);
void               add_unknown(char *zielboard);
void               save_em();
void               update_mail(void);
void               convat(char *adr);
#ifdef _BCMNET_FWD
int                is_bcmnet_bid(char *bid, int cflag);
#endif

//****************************
//       mbtrans.cpp
//****************************
int                mbtransfer(char *ziel);

//****************************
//       mbread.cpp
//****************************
int                mbread(char *befbuf,int mode);
int                mbchange(char *befbuf,int wasmachen,int kommentar);
int                rmemptydir(char *mask);
int                markerased(char reason,int unerase);
int                testreadbin(FILE *f,long mimeboundary, int is7plus);
char               *putreadpath (FILE * f, char *line, int kopf);
long               scanmimetype (FILE * f);
void               putmimeheader (char *line, long mimeboundary);
void               read_file(int mode);
void               markread(int resetread,int dummy);

//****************************
//       mbtree.cpp
//****************************
void               mbreadtree(char *beginpath);
void               mbtreesave(void);
int                rmboard(char *fullname);
int                mkboard(char *mainboard,char *newboard,int sameboard);
int                mvboard(char *old,char *sub,char *newboard);
int                nameconvert(char *name);
void               mbconvload(void);
void               saveconvnames(void);
void               convedit(char *befbuf);
int                checklifeconv(char *searchstr);
void               mbclifeload(void);
void               limit_list(void);

//****************************
//       mbinit.cpp
//****************************
void               mbinit(void);
int                mbinitbef(char *befbuf,int inifile);
int                mbinitdisp(char *befbuf);
void               mbparsave(void);

//****************************
//       mbusers.cpp
//****************************
void               listuser(char *wildcard,int lokal);
int                loaduser(char *usercall,user_t *u,int anlegen);
void               saveuser(user_t *u);
void               userinit(void);
void               defaultuser(char *usercall,user_t *u);
void               reorguser(int delempty);
void               uimport(void);
void               usersuch(char *befbuf);
void               hashinit(handle uhf,long hashsize);
void               us_deletecache(void);
#ifdef _EXDLOGIN	//db1ras
void		   defaultguest(char *usercall,user_t *u);
#endif

//****************************
//       mbfwd.cpp
//****************************
int isforwardpartner(char *);
char another_fwd_sender(char *);
fwdpara_t *fpara(void);
void fwdlog(char *, char *, char);
void fwdput(char *, char *);
void fwdget(char *, int);
int chkforward(char *);
void initfwdlist(int);
void printfwdlist(char *);
void fwdstat(char *);
int isforwardtime(char *, int);
int boxbinok(int);
void add_hold(char *, int);
int scanheader(FILE *, fwdpara_t *);
char *board_aus_path(char *);
void markfwd(void);
void readmail(FILE *, char);
int setfullpath(char *);
void killforwarded(char *);
unsigned char getfwdlistentry(char *, char, char, char **);
void delfwdlistentry(char *);
void fwdsend(char *);
int fwdmainloop(void);
int weiterleiten2(int, char *);
int weiterleiten(int, char *);
void add_fwdfile(char *, short unsigned);
void trigger_ufwd(char *);
void startfwd(char *);
int waitfwdprompt(char *);

//****************************
//       mbfwdrli.cpp
//****************************
int scan_userfile(char *, int);
void fwdproc_reply(char);
void ascii_fwdmachine(int);

//****************************
//       mbwp.cpp
//****************************
void	add_emfile (char *zeile, char *frombox, 
        char *file_flag, char *boardname,char *at);
int	get_wcs (char *line);
void	addwp_m (wpdata_t  *wp);
void    addwp_e (char *at, char *originbbs, char *bid, char *bid_erase,
	char *erase_user, long hops, char *reason, char *logincall);     
void    wpgenheader (FILE *f);     
void    gen_wpmail (char *call);
int     wpparse_fbb(char *buf,wpdata_t *wp);
int     wpparse_v(char *buf,long &protnum);
int     wpparse_b(char *buf,char *hadr,long &bversion,char *bstatus,
        char *sysop,char *protocol, char *hwaddress,time_t &timestamp,
        long &hops);
int     wpparse_m(char *buf,wpdata_t *wp);
int     wpparse_e(char *buf,char *at,char* bid,char *originbbs,
        char *bid_erase,char *origin,long &hops,char *comment);
void    scan_wp (void);
void    remeraser (char *at, char *bid, char *herkunft, char *bid_erase,
        char *logincall, char *erase_user, long hops, char *reason);

//****************************
//       mblogin.cpp
//****************************
void               mblogin(char *logincall,loginmode_t lmode,char *uplink);
void               mblogout(int kill);
void               putlogauszug(char *selektor);
void               putaktuell(int immer);
int                readtext(char *text);

//****************************
//       mbreorg.cpp
//****************************
void               mbreorg(char *name);
void               createdirlist(int remdouble);
int                appenddirlist(void);
char               *dirsort(char *mask,int users);
void               postfwd(char *);

//****************************
//       mbalter.cpp
//****************************
int                get_mybbs(char *call,char *bbs,int setmybbs);
void               set_mybbs(char *call,char *bbs,long bime,char *bid,
                     char *origin, long hops,char *w_name);
void               set_name(char *call,char *name);
char               *get_name(char *call,int par);
int                get_smtp_security(char *call);
char               *get_httppw(char *call);
void               inc_mailgot(char *call);
void               inc_mailsent(char *call);
int                mbalter(char *bef,char *selektor,char *call);
char               *optstr(bitfeld option);
char               *get_ttypw(char *call,char *pw);
int                get_nopurge(char *call);
int                get_fdelay(char *call);
int                get_readlock(char *call);
char               *get_ufwd(char *call);
void               display_parameter(char *call,int full);
int                get_newcall(char *call,char *newcall);
int                get_usr_local(char *call, time_t &lastlogin);

//****************************
//       mbsysop.cpp
//****************************
int                sysbef(char *befbuf);
void               sysimport(char *befbuf);
void               testdfull(void);
void               putlog(char *name,char *befbuf);

//****************************
//       mbgrep.cpp
//****************************
int                grep(char *name,char *pattern,bitfeld options);

//****************************
//       mbmain.cpp
//****************************
int                mailbef(char *befbuf,int echo);
void               mbmainbegin(void);
void               mbmain(char *call,char *uplink,char *mycall);
int                checkquota(void);
void               mbmainloop(int doprompt);
int                testhttp(void);
#ifdef _WXSTN
void               wxdaemon(char *name);
#endif
//****************************
//       mbinout.cpp
//****************************
char               getline(char *s,int maxlen,char cut);
int                janein(char *prompt);
void               putv(int c);
void               bputv(int c);
void               putf(char *format, ...);
int                getv(void);
int                getvalid(void);
int                putfree(void);
void               putflush(void);
int                testabbruch(void);

//****************************
//       mbinterf.cpp
//****************************
void               mbwin2(char *name);
void               n_win2(char *name);
void               userwin(char *name);
void               mbwindow(char *name);
void               boxusertask(char *usercall);
int                getlogin(char *s,int withpw,char *source);
void               mbimport(char *filename);
void               genmail(char *sendline,char *content);
void               doodle(int soundnum);
void               runbatch(char *batch);
void               taskwin(char *name);
#ifdef HRX_OPT
void               trcwin(char *befbuf); 
#endif

//****************************
//       mbrun.cpp
//****************************
#ifdef RUNUTILS
void               read_runfile(void);
int                start_runutil(char *befbuf);
void               list_runutils(char *befbuf);
#endif

//****************************
//       mbhelp.cpp
//****************************
void               mbinithelp(void);
void               mbreadhelp(char *befehl);

//****************************
//       mbpurge.cpp
//****************************
void               mbpurge(char *procname);
void               userpurge(char *befbuf);

//****************************
//       cfgflex.cpp
//****************************
void               cfgflex(char *zielcall);

//****************************
//       mbtnc.cpp
//****************************
void               putv_tnc(int c);
int                putfree_tnc(void);
void               putflush_tnc(void);
int                getv_tnc(void);
int                getvalid_tnc(void);
void               getclear_tnc(void);
void               inputline_tnc(char *s,int maxlen,char cut);
void               getmycall_tnc(char *outcall);
int                makeconnect(char *mycall,char *conncall);
void               mbdisconnect(int wait);
int                freeblocks_tnc(void);
void               control_tnc(char *befehl);
void               putversion_tnc(void);
void               logindaemon(char *name);
void               monwindow(char *name);
void               setsession(void);
void               putbeacon_tnc(char *adressfeld, char *bakentext);
void               align_mycalls(void);

//****************************
//       mbsocket.cpp
//****************************
void               putv_sock(int c);
int                putfree_sock(void);
void               putflush_sock(void);
int                getv_sock(void);
int                getvalid_sock(void);
void               inputline_sock(char *s,int maxlen,char cut);
void               logindaemon_sock(char *name);
void               disconnect_sock(void);
void               show_sock(void);
enum
{
  _TELNET=-1, _HTTP=-2, _SMTP=-3, _POP=-4, _NNTP=-5, _SERV=-6, _RADIO=-7
};

//****************************
//       mbhttp.cpp
//****************************
void               mblogin_http(char *);
void               html_putf(char *format, ...);
int                isamprnet(char *ip);

//****************************
//       mbsmtp.cpp
//****************************
int                myhostname (char *s, int len);
void               mblogin_smtp(char *);

//****************************
//       mbpop3.cpp
//****************************
void               mblogin_pop3(char *name);
void               show_popdb(void);

//****************************
//       mbnntp.cpp
//****************************
void               mblogin_nntp(char *name);

//****************************
//       mbserv.cpp
//****************************
void               mblogin_serv(char *name);

//****************************
//       mbradio.cpp
//****************************
void               mblogin_radio(char *name);



//****************************
//       mbflex.cpp
//****************************
// f_  ??
void               f_putv_tnc(int c);
int                f_putfree_tnc(void);
void               f_putflush_tnc(void);
int                f_getv_tnc(void);
int                f_getvalid_tnc(void);
void               f_getclear_tnc(void);
void               f_getmycall_tnc(char *outcall);
void               f_inputline_tnc(char *s,int maxlen,char cut);
int                f_makeconnect(char *mycall,char *conncall);
void               f_mbdisconnect(int wait);
int                f_freeblocks_tnc(void);
void               f_control_tnc(char *befehl);
void               f_putversion_tnc(void);
void               f_logindaemon(char *name);
void               f_monwindow(char *name);
void               f_setsession(void);
void               f_putbeacon_tnc(char *adressfeld, char *bakentext);
void               disable_tnc(void);
void               f_ax25_set_pid(unsigned short int qsonum, unsigned char pid);

//****************************
//       mbserial.cpp
//****************************
void               putv_tty(int ch);
void               putflush_tty(void);
int                putfree_tty(void);
int                getv_tty(void);
int                getvalid_tty(void);
void               inputline_tty(char *s,int maxlen,char cut);
void               init_tty(void);
void               ttysetecho(int echo);
#ifdef _TTY
void               putf_tty(char *format, ...);             
int                tty_cmd(char *cmd);                      
int                tty_waitring(void);                     
int                tty_hangup(void);                        
void               tty_kill(void);                        
int                tty_dial(char *befbuf,int fwdtaskid); // JJ
int                tty_autologin(char *s);                
void               tty_statustext(void);                 // JJ
void               tty_win(char *befbuf);                // JJ
void               ttyinit(void);
int                ttyinitbef(char *befbuf,int inifile); // JJ 
int                ttybef(char *befbuf);                 // JJ 
void               ttyparsave(void);
void               tty_counterreset(void);               // JJ 
#endif

//****************************
//       mbmsg.cpp
//****************************
char               *ms(MSG_TYP msgnum);
char               *msg_landsuch(char *call);
void               msg_listspeech(void);
void               msg_dealloc(int all);
int                is_msgkenner(char *kenn);
unsigned           msg_limit(int actual);

//****************************
//       mbtimer.cpp
//       ad_timer.cpp
//****************************
void               set_watchdog(int on);
void               ad_settimer(int on,void (*callback)(void));
void               put_cpuload(void);
int                cpuload(void);
extern int         lastjob;

//****************************
//       mbhadr.cpp
//****************************
void               show_hadr(char *call);
int                update_hadr(char *headerline,int hops,int uplink);
void               reorg_hadr(void);
void               browse_hadr(char *search);
void               expand_hadr(char *adr,int force);
void               edit_hadr(bitfeld opt,char *line);
long               hadr_len(int max);
int                wpupdate_hadr(wpb_t *wpb);
void               hadrfile_newformat(void);
#ifdef _AUTOFWD		//db1ras
  void               uclose(void);
  void               hadr_tryopen(void);
  int                loadhadr(char *hadrcall,hadr_t *u,int anlegen);
#endif

//****************************
//       termqso.cpp
//****************************
void               termqso(char *calls);

//****************************
//       mbconv.cpp
//****************************
int                conversout(int prompt);
void               convers(char *befbuf,char *befname);

//****************************
//       ad_dos.cpp 
//       ad_linux.cpp
//       ad_util.cpp
//****************************
int                oshell(char *befbuf,shellinput_t input);
char               *memfree(int swapfree);
char               *cpuinfo(void);
unsigned long      dfree(char *path,int total);
void               fixpath(char *argv0);
void               cdhome(void);
void               resetreadonly(char *name);
struct tm          *ad_comtime(time_t time);
time_t             ad_mktime(struct tm *tt);
time_t             ad_time(void);
time_t             ad_timezone(void);
time_t             isdst(void);
#ifndef _GNU_SOURCE
int                snprintf(char *str,size_t n,const char *format,...);    
#endif

//****************************
//       mbcron.cpp
//****************************
void               mbcron(char *);

//****************************
//       mbvideo.cpp
//****************************
void               video_open(void);
void               video_close(void);
void               video_putchar(int x,int y,int attr,int c);
void               video_setcursor(unsigned x,unsigned y);
void               video_putc(int x,int y,unsigned attr,unsigned c);
void               video_puts(int x,int y,unsigned attr,char *s);
void               video_update(void);
void               video_checkoff(int force);
void               video_switchon(void);
extern             int cgadisp;
extern             int monodisp;
extern             int novideo;
extern             int video_off;

//****************************
//        mbmacro.cpp
//****************************
typedef enum mk_job_t
{ MK_NOJOB,
  MK_LOGIN,
  MK_ACCEPT,
  MK_CMD,
  MK_SCMD,
  MK_BEFORECMD,
  MK_AFTERCMD,
  MK_MAILFROM,
  MK_MAILTO,
  MK_UNKNOWN
} mk_job_t;
#ifdef MACRO
  int              mk_start(char *name);
  void             mk_read_jobs(void);
  int              mk_perform(mk_job_t job,char *parameter);
#else
  #define mk_start(x) 0
  #define mk_read_jobs()
  #define mk_perform(x,y) 0
#endif
#endif		//L2COMPILE

// DG4MMI
//****************************
//       mbtimcvt.cpp
//****************************
time_t             time_dos2unix(char *dostime);
void               time_unix2dos(time_t unix_date, char *buffer);

//****************************
//	mbax25k.cpp
//****************************
int  ax25k_putfree();
void ax25k_putv(int c);
void ax25k_flush();
void ax25k_putbeacon(char *addr, char *beacontext);
int ax25k_isdefault();
int  ax25k_init();
int  ax25k_getvalid_tnc();
int  ax25k_getv();
void ax25k_getclear();
void ax25k_getmycall(char *s);
void ax25k_inputline(char *s, int maxlen, char cut);
int  ax25k_connect(char *mycall, char *conncall);
void ax25k_disconnect(int wait);
void ax25k_checklogin();
void ax25k_shutdown();

//****************************
//        mbpw.cpp
//****************************
void genPWstring(char *pw, char * pwstring, char * result);
char maxpwtype();
char *pwtypestr(char pwnum);
char pwtypenum(char *pwstr);
int  getpw(void);
int  pwauswert(char *pw);
int  getpriv(char *befbuf,char *privname);

//****************************
//        mbmdpw.cpp
//****************************
#ifdef FEATURE_MDPW
void calcMD2pw(char *MDstring, char *pw, char *MD2result);
void calcMD5pw(char *MDstring, char *pw, char *MD5result);
void genMDstring(char MDtype, char *pw, char *pwstring, char *result);
char getMDpw(char MDtype, char *pw);
void getMDsysoppw(char MDtype);
#endif

#ifdef _AUTOFWD
//****************************                        
//       mbafwd.cpp                                  
//****************************                     
char                *autofwd(char *call,int ausgabe); 
void                fwdlist(char *befbuf); //JJ  
#endif

//****************************
//       end of file
//****************************
