/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------
  BINSPLIT-Protocol for BCM
  -------------------------


  Copyright (C)       Johann Hanne, DH3MB, jonny@baycom.org
                      Falkenweg 6
                      D-85122 Hitzhofen

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19990703 DH3MB  Begin of implementation

#include "baycom.h"

#ifdef FEATURE_BINSPLIT

#define BS_MAGIC ">BS<"
#define BINSPLIT_SIZE 20000

/*---------------------------------------------------------------------------*/

class binsplit
{

private:
  void putheaderitem(crcthp *, char *, ...);
  void putheader(unsigned char, unsigned char);
  char *fname;
  unsigned long int fsize;
  time_t ftime;

public:
  void tx_binsplit(void);

};

/*---------------------------------------------------------------------------*/

void binsplit::putheaderitem(crcthp *headercrc, char *format, ...)
{ va_list argpoint;
  char cbuf[260];
  char *s=cbuf;

  va_start(argpoint,format);
  vsprintf(cbuf,format,argpoint);
  va_end(argpoint);
  if(strlen(s)>257)
  { s[50]=0;
    trace(tr_abbruch,"putbs","long %s",s);
  }
  while(*s)
  { headercrc->update(*s);
    putv(*(s++));
  }

  headercrc->update(LF);
  bputv(LF);
}

/*---------------------------------------------------------------------------*/

void binsplit::putheader(unsigned char num, unsigned char total)
{ crcthp headercrc;
  struct tm *tt=ad_comtime(ftime);

  putheaderitem(&headercrc, BS_MAGIC);
  putheaderitem(&headercrc, "%02X", num);
  putheaderitem(&headercrc, "%02X", total);
  putheaderitem(&headercrc, "%ld", BINSPLIT_SIZE);
  putheaderitem(&headercrc, "%ld", fsize);
  putheaderitem(&headercrc, "%s", fname);
  putheaderitem(&headercrc, "%04d%02d%02d%02d%02d%02d",
                            tt->tm_year, tt->tm_mon, tt->tm_mday,
                            tt->tm_hour, tt->tm_min, tt->tm_sec);

  bputv(0);
  headercrc.update((unsigned char)0);

  bputv(headercrc.result % 0x100);
  bputv(headercrc.result / 0x100);
  bputv(LF);
}

/*---------------------------------------------------------------------------*/

void binsplit::tx_binsplit(void)
{
  unsigned char partnum, i;

  if((ftime=filetime(fname))==0)
  { putf("File not found.\n");
    return;
  }

  fsize=filesize(fname);

  partnum=fsize/BINSPLIT_SIZE;
  if(fsize>partnum*BINSPLIT_SIZE)
    partnum++;

  for(i=1;i<=partnum;i++)
  {



  }


}

/*---------------------------------------------------------------------------*/

#endif
