/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ------------------------------
  Kommandoprozessor und Zubehoer
  ------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#include "baycom.h"

/*---------------------------------------------------------------------------*/

int blkill(char *bf)
{ int i=0;
  while(bf[i]==13 || bf[i]==' ' || bf[i]==',') i++;
  return i;
}

/*---------------------------------------------------------------------------*/

char *blankweg(char *s)
{ if(s==NULL)
    return NULL;
  s=strchr(s,' ');
  if(s)
  { s[0]=0;
    s+=1;
    s+=blkill(s);
    return s;
  }
  return s;
}

/*---------------------------------------------------------------------------*/

int nextdez(char **bf)
{ int i=-1;
  int a=0;

  if(!(**bf)) return -1;
  while(**bf && ((**bf<'0')||(**bf>'9'))) (*bf)++;
  if(!(**bf)) return -1;
  i=atoi(*bf);
  while((**bf>='0') && (**bf<='9'))
  { (*bf)++;
    a++;
  }
  (*bf)+=blkill(*bf);
  if(a) return i;
  else  return -1;
}

/*---------------------------------------------------------------------------*/

int readcmd(char *beftab[],char **buffer,int minimum)
//*************************************************************************
//
//  vergleicht die Kommandos in einer Befehlstabelle mit einem
//  Stringanfang. Wird das Kommando gefunden, so wird der String-
//  zeiger entsprechend nachgefuehrt.
//
//  beftab[] = Pointer-Array, dessen Eintraege auf die Befehls-Strings
//             zeigen. Das Array mu an letzter Stelle stets mit
//             dem NULL-Pointer besetzt sein.
//  *buffer    Zeiger auf einen String, in dem am Anfang der Befehl
//             steht.
//  minimum    Gibt die Anzahl der mindestens ~Abereinstimmenden
//             Zeichen an, damit ein Befehl als solcher akzeptiert
//             wird.
//             0 bedeutet, dass der Befehl stets mit String-Ende (\0)
//             oder mit einem Blank abgeschlossen sein muss (fuer Node)
//
//*************************************************************************
{ int i=0,j=0,cmd=0,maxcmd=0;
  while(beftab[i])
  { j=0;
    while(beftab[i][j] && (toupper(buffer[0][j])==beftab[i][j]))j++;
    i++;
    if((j>maxcmd)&&(j>=minimum))
    { // if(minimum || (buffer[0][j]==0) || (buffer[0][j]==' '))
      if((buffer[0][j]==0) || (buffer[0][j]==' ') || (buffer[0][j]=='='))
      { maxcmd=j;
	cmd=i;
      }
    }
  }
  *buffer+=maxcmd;
  *buffer+=blkill(*buffer);
  return cmd;
}

/*---------------------------------------------------------------------------*/

/*
static char *putzeit(time_t zeit)
{ long unsigned hours=zeit/360;
  long unsigned days=hours/24;
  static char s[12];

  s[0]=0;
  if(days>99)
    sprintf(s,"-:--");
  else
  { zeit-=hours*360;
    hours-=days*24;

    if(days)
      sprintf(s,"%lu.",days);
    sprintf(s+strlen(s),"%02lu:%02lu",hours,zeit/6);
  }
  return s;
}
*/
