/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fr Benutzeroberflche


  ---------------------
  Desktop-Hauptprogramm
  ---------------------


  Copyright (c)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights reserved

 ***************************************************************/

//19980215 OE3DZW tracelevel always 0 at startup
//19980923 OE3DZW added mkdir fwd-path

#include "baycom.h"

/*---------------------------------------------------------------------------*/

unsigned cpuindex=0;

/*---------------------------------------------------------------------------*/

static int desktopupdate(int full)
{ if(full)
    wclear(color.desktop);
  return 1;
}

/*---------------------------------------------------------------------------*/

void desktop(char *)
{ char instr[50];
  char *msg[12]={ "",
		"               BayCom Packet-Radio Mailbox",
		"  / \\",
		" /   \\                 Version "VNUMMER,
		" \\   /",
		"  \\ /  ",
		" __ __",
                "                 (c) GNU Copyright 1992-"YEAR,
		"                 Florian Radlherr DL8MBT et al.",
		"                 Copy Policy is GNU GPL",
		NULL
	      };

  mkdir(LOGPATH);
  mkdir(TRACEPATH);
  mkdir(TEMPPATH);
  mkdir(FWDPATH);
#ifdef FBBFWD // DG4MMI
  mkdir(FBBPATH);
#endif

  m.tracelevel=0;

  e->x=0;
  e->xend=bildspalten-1;
  e->y=0;
  e->yend=bildzeilen-1;
  e->update=desktopupdate;
  wopen();
  wclear(color.desktop);

  fork(P_WIND,0,monwindow,"Monitor");
#ifndef __FLAT__
//  fork(P_WIND,0,userwin,"Users");
#endif
  fork(P_WIND,0,tracewindow,"Console");
  fork(P_MAIL|P_WIND|P_KEYB,0,mbwindow,"Sysop");
  testcputask();

  deskkey=1;
  message("About",msg,6);
  deskkey=0;

  while(!runterfahren)
  { wdelay(146);

    if(deskkey)
    { switch(deskkey)
      { case 23:
	  instr[0]=0;
	  if(inputwin("Login","Call [Boxcall]:",instr,20)!=ESC)
	  { strupr(instr);
	    fork(P_WIND|P_KEYB|P_MAIL,0,mbwin2,instr);
	  }
	  break;

#if NODE
        case 22:
	  instr[0]=0;
	  if(inputwin("Node","Call:",instr,8)!=ESC)
	  { strupr(instr);
	    if(!mbcallok(instr))
	      strcpy(instr,m.sysopcall);
	    fork(P_WIND|P_KEYB|P_MAIL,0,n_win2,instr);
	  }
	  break;
#endif

#ifdef FEATURE_EDITOR
	case 24:
	  instr[0]=0;
	  if(inputwin("Editor","Filename:",instr,20)!=ESC)
	  { strupr(instr);
	    fork(P_WIND|P_KEYB,0,editfile,instr);
	  }
	  break;
#endif

	case 'Z':
	case 25:
	  resize(keywindow(),0);
	  break;

	case 'N':
	case 26:
	  newkeywin=keywindow()+1;
	  break;

	case 'C':
	  colselect();
	  break;

	case 'M':
	 // menu();
	  break;

	case 'R':
	case 27:
	  resize(keywindow(),1);
	  break;

	case 33:
	  if(yesno("Close window?",1)==YES)
	    kill(keytaskid);
	  break;

	case 'S':
	  video_checkoff(1);
	  break;

#ifdef __MSDOS__
	case 35:
          set_watchdog(2);

	  video_close();
          waitdoskey();
	  video_open();
          set_watchdog(1);
	  newkeywin=keywindow();
	  break;
#endif

	case 'X':
	  if(yesno("Mailbox shutdown?",1)==YES)
	  { runterfahren=1;
            stopreason="alt-x pressed";
          }
	  break;

	case '0':
	{ sprintf(instr,"%d",keywindow());
	  if(inputwin("Window","new window:",instr,20)!=ESC)
	  { if(atoi(instr))
	      newkeywin=atoi(instr);
	  }
	}
	break;

      }
      deskkey=0;
    }
    video_checkoff(0);
    desk_cyclic();
  }
}
