/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------
  Desktop-Dummy for Linux/Win32-Version
  -------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980222 DG2FEF changes to signal-handler
//19980309 OE3DZW fixed above for win32

#include "baycom.h"

/*---------------------------------------------------------------------------*/

unsigned cpuindex=0;

struct edstruct *e;
char     *buf;
int      boxopen=0;

unsigned bildzeilen=25;
unsigned bildspalten=80;
int      wa=0;  
int      video_off=1;

static void int_handler(int)
{
  runterfahren=1;
  stopreason="SIGINT";
}

static void term_handler(int)
{
  runterfahren=1;
  stopreason="SIGTERM"; 
}

static void ill_handler(int)
{ 
  post_mortem_dump("SIGILL");
  #ifdef __UNIX__
  kill(getpid(),SIGILL);
  #else
  abort();
  #endif
}

static void segv_handler(int)
{
  #ifdef __UNIX__
    post_mortem_dump("SIGSEGV");

    signal(SIGSEGV,SIG_DFL); //dg2fef
    raise(SIGSEGV);

    //kill(getpid(),SIGSEGV);

  #else
    abort();
  #endif
}


/*---------------------------------------------------------------------------*/

// dummies to satisfy open references of dos-relevant parts
void putvo_win(int) {}
void putflush_win(void) {}
void inputline_win(char *, int, char) { while(1) wdelay(789); }
void preparewin(int (*update)(int),char *name,unsigned buflen) {}
int putupdate(int) { return OK; }
void video_putc(int,int,unsigned,unsigned) {}
void video_update(void) {}
void wclose(void) {}
void wf(int,int,int,char *,...) {}
void setzcurs(int,int,edstruct *) {}
void nachvorne(int) {}
void editfile(char *) {}
void vorne_reorg(void) {}

/*---------------------------------------------------------------------------*/

void desktop(char *)
{
  mkdir(LOGPATH);
  mkdir(TRACEPATH);
  mkdir(TEMPPATH);
  mkdir(FWDPATH); // OE3DZW
  mkdir(MSGPATH);
#ifdef FBBFWD // DG4MMI
  mkdir(FBBPATH);
#endif

  m.tracelevel=0;

#ifndef _DEBUG
  signal(SIGTERM,term_handler);
  signal(SIGINT,int_handler);
  signal(SIGSEGV,segv_handler);
  signal(SIGILL,ill_handler);
#endif

#ifdef __LINUX__
  //ignore sigpipe
  signal(SIGPIPE,SIG_IGN);
#endif

  fork(P_WIND,0,tracewindow,"Console");
  fork(P_WIND,0,monwindow,"Monitor");
  fork(P_MAIL|P_WIND|P_KEYB,0,mbwindow,"Sysop");

  while(!runterfahren)
  {
    wdelay(146);
    desk_cyclic();
  }
}
