/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -----------------------------------------------------------------
  Allgemeine Forward-Ein- und Ausgabe sowie Adressierungsauswertung
  -----------------------------------------------------------------


  Copyright (C)       Florian Radlherr et al
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980109 OE3DZW Added debug output isforwardpartner()
//                Removed check for D-Box (bin-fwd)
//                Added Call & BID in Errmsg "bin-mail could not be fwded"
//                Added seperator for "d p"
//19980115 OE3DZW reduced priority of err-msges in delfwdlistentry
//                Text "Info-mails" in "st f"
//                Added comment
//19980118 OE3DZW Removed REJ from trace (for s52d)
//19880118 OE3DZW sec in timestr
//19980120 OE3DZW Removed Space in st f, added fix 80 Bytes per
//                Mail (incl. E/M),
//19980124 OE3DZW fwdprop max. 127 
//                Added Fwd-Style to Fwd-Log
//                Remove trace rx-sid, removed boxtypes
//                Fixed sidrtt
//                SID may be 119 chars long (was 79 before) - for Wingt-pw
//                removed support for -S-flag in forwarding
//19980126 OE3DZW fixed fwd-machine (went from FBB into ASCII-Mode)
//19980128 OE3DZW Twice sid in fwd log, fixed
//                added fbb-states to st-f command
//19980205 OE3DZW better alignment at st f
//                fixed sid-rtt
//19980211 OE3DZW fixed lastconok, was not set
//                added number of incoming/outgoing connects to st f
//                removed err-msg in fpara()
//19980215 OE3DZW alignment st f
//19980216 OE3DZW removed old entries in fwd-triggerfile
//                checked fwd-trigger before starting fwd for erased mail
//19980223 OE3DZW fwdget to 78 (was 119) due seg fault, will not accept wingt-pw
//19980225 OE3DZW fixed above bug, wingt-fwd should be ok now
//19980301 OE3DZW fixed fwdlog
//                removed debug output in killfwded
//                removed  CTRLZ from log
//                chkforward() entfernt alte eintraege, keine leeren vorschlaege im fbb-fwd
//19980302 OE3DZW added check for logincall when init fwd-list
//                added return-mail to hold-function
//                only mails type P/A are set to hold, not bulletins 
//19980304 OE3DZW fixed bug, fwd bulletins were erased
//19980307 OE3DZW will not erase but hold if personal, also when o_r
//19980309 OE3DZW initfwdlist - output only when logincall 
//                add_hold with reason
//19980311 DG9MHZ changes for Linux-Kernel AX25
//19980311 OE3DZW removed unused variables
//19980318 OE3DZW more robust against invalid entries in fwd-triggerfile
//                fixed bug in killfwded, added some debug-output
//19980329 OE3DZW E/M-lines will be put into the fwd-log (ascii-fwd)
//19980404 OE3DZW hold-msg only in fwd-standard,not in user-fwd
//19980404 hrx    support tty-fwd
//19980408 OE3DZW fwd should be started when there is a mail to send
//19980418 DG4MMI added space for diebox-pwd
//19980418 OE3DZW fwdlog shows taskid (was tnc-number)
//19980420 OE3DZW removed dashes after protests of flori,deti,chris an me
//                Total only if at least on mail in queue
//19980421 OE3DZW no UNKNOWN mail for CP-Mails
//19980423 OE3DZW hold due to loop only if not held before
//                included returnmailok()
//19980505 OE3DZW used rmcrlf instead of x[strlen(x)-1]=0..
//19980524 OE3DZW removed Fwd-Option -o in fwd.bcm
//19980609 OE3DZW killfwd will check for 0x00..0x00
//                usermails will be erased when replied with "no" in userfwd
//                sfhold - added parameter returnmail
//19980610 OE3DZW sfhold - not for  "sysop" mails of type "p"
//19980614 OE3DZW killfwded will also remove entries longer 50 chars
//19980615 OE3DZW new fwdproc_reply - common for ascii and fbb-fwding
//19980830 OE3DZW text fwdreply no changed to "already rcvd", was 
//                not clear
//19980914 OE3DZW mails not twice in one proposal
//19980916 OE3DZW fwdlog will show taskid even on logout
//19981013 OE3DZW binary personal messages will be sent to fbb's
//19981015 OE3DZW users may totally disable active userforwarding
//19990201 OE3DZW commented out conat()
//19990211 OE3DZW added "W" to SID, added check for D2..D4 and B2..B4 in SID
//19990214 OE3DZW when fwd-times are incorrect, standard will be used
//19990215 OE3DZW generating sample fwd.bcm
//19990427 OE3DZW replaced E/M by WP in st f
//19990726 OE3DZW fixed security bug
//19990817 OE3DZW added JJ's code, added fwdoption -l 
//19990918 OE3DZW added Jan's changes: filefwd
//19991003 hpk    added "Z" to SID, option make sure that partner is using
//                a CB-BCMNET Version, userforward possible without "Z" in SID
//                function automatically switched on with 01.01.2000

#include "baycom.h"

/*---------------------------------------------------------------------------*/

#define DUMMY "DUMMY"

unsigned fwdpartners=0;
unsigned fwddestlen=0;

/*---------------------------------------------------------------------------*/

static fwdpara_t fp[MAXFWD+1];
static char      boxdest[MAXDESTLEN];
// Liste mit allen Zielbezeichnern, in der Reihenfolge des Forwardfiles,
// jeweils durch ein Blank von einander getrennt. Durch destindex[] kann
// festgestellt werden, zu welcher Box der jeweilige Bezeichner gehrt

/*---------------------------------------------------------------------------*/

int waitfwdprompt(char *buf)
//*************************************************************************
//
//  Wartet auf ein Forward-Prompt (Wird benutzt beim SID-Austausch
//  und beim RLI-Forwarding)
//
//  Rueckgabe:
//    0..Linkfehler 
//    1..Prompt > (Normales Prompt)
//    2..CRC-Fehler-BIN-Prompt
//
//*************************************************************************
{
#ifdef _FILEFWD
  if(b->forwarding == fwd_file)
    return 1;
#endif

  do
  { fwdget(buf,(int) 118);
    if(stristr(buf,"RECONNECT"))
      return 0;
    if(stristr(buf,"FAILURE"))
      return 0;
    if(strstr(buf,"|>"))
      return 2;
  }
  while(buf[strlen(buf)-1]!='>');
  return 1;
}

/*---------------------------------------------------------------------------*/

int isforwardpartner(char *call)
//*************************************************************************
//
//  Gibt zurueck, ob das uebergebene Call ein eingetragener
//  Forwardpartner ist.
//
//*************************************************************************
{ int i=0;
  if(strcmp(call,DUMMY)==0)
    return NOTFOUND;

  while(fp[i].call[0])
  { if(strcmp(fp[i].call,call)==0)
      return i;
    else
      i++;
  }

  return NOTFOUND;
}

/*---------------------------------------------------------------------------*/

char another_fwd_sender(char *call)
//*************************************************************************
//
//  Checks, if we are sending files in another forward-session (OE3DZW)
//
//*************************************************************************
{ return(eingelogt(call,j_fwdsend) ||
         eingelogt(call,j_fwdsendf) ||
         eingelogt(call,j_fwdlink) ||
         eingelogt(call,j_fbb_recv_propose) || // DG4MMI
         eingelogt(call,j_fbb_send_propose) ||
         eingelogt(call,j_fbb_send_mail) ||
         eingelogt(call,j_fbb_send_delay) ||
         //OE3DZW forward-receive should be allowed or not??
         (eingelogt(call,0)>1)); // DG4MMI: Workaround for DP-Box
}

/*---------------------------------------------------------------------------*/

fwdpara_t *fpara(void)
//*************************************************************************
//
//  Gibt einen Zeiger auf die forward-Parameterstruktur zurueck
//  Beim User-Forwarding wird online ein Dummy befuellt
//
//*************************************************************************
{ int box=isforwardpartner(b->logincall);
  fwdpara_t *ff;

  if(box!=NOTFOUND)
    return &fp[box];

  if(b->forwarding==fwd_none)
    trace(serious,"fpara","no fwd: \"%s\"",t->lastcmd);
  if(b->fwd_parameter==NULL)
    b->fwd_parameter=t_malloc(sizeof(fwdpara_t),"fwdp");
  ff=(fwdpara_t *)b->fwd_parameter;
  memset(ff,0,sizeof(fwdpara_t));
  strcpy(ff->call,b->logincall);
  strcpy(ff->concall,get_ufwd(ff->call));
  if (ff->concall[0]==1)  //user has disabled userfwding
    ff->concall[0]=0;
  strcpy(ff->times,"AAAAAAAAAAAAAAAAAAAAAAAA");
  ff->dest=ff->call;
  ff->connectbar=1;
  ff->n_conok=0;
  ff->n_login=0;
  ff->lastwp=0;
  ff->txf=0;
  ff->rxf=0;
  ff->sidrtt=0;
  ff->timeout_cnt=0;
  ff->ssid=m.fwdssid;
  if(b->forwarding==fwd_standard)  
    trace(fatal,"fpara","%s unknown fwd params",b->logincall);
  return ff;
}

/*---------------------------------------------------------------------------*/

void fwdlog(char *s1,char *s2,char dir)
//*************************************************************************
//
//  Schreibt ggf (nur wenn konfiguriert) jede FWD-Zeile in ein
//  zum Loginrufzeichen passendes Logfile
//
//*************************************************************************
{ char buf[80];
  handle fh;
  char filename[30];
  char *a;

  if(m.fwdtrace)
  { if(m.fwdtrace==2 && !(fpara()->options & o_t))
      return;
    sprintf(filename,TRACEPATH"/t_%s.bcm",b->logincall);
    strlwr(filename);

    fh=s_open(filename,"sab");
    if(fh==EOF)
      fh=s_open(filename,"swb");
    if(fh!=EOF)
    { sprintf(buf,"%s %2d%c ",zeitstring(ad_time(),1),t->taskid,dir);
      buf[79]=0;
      _write(fh,buf,strlen(buf));
      a=strchr(s1,CTRLZ);
      if (a)
      { *a=0;
        _write(fh,s1,strlen(s1));
        *a=CTRLZ;
      }
      else
        _write(fh,s1,strlen(s1));
      a=strchr(s2,CTRLZ);
      if (a)
      { *a=0;
        _write(fh,s2,strlen(s2));
        *a=CTRLZ;
      }
      else
        _write(fh,s2,strlen(s2));
      _write(fh,NEWLINE,strlen(NEWLINE));
      s_close(fh);
    }
  }
}

/*---------------------------------------------------------------------------*/

void fwdput(char *s1,char *s2)
{ putf("%s%s\n",s1,s2);
  fwdlog(s1,s2,'S');
}

/*---------------------------------------------------------------------------*/

void fwdget(char *s,int maxlen)
{ getline(s,maxlen,(int)1);
  timeout(m.fwdtimeout);
  fwdlog(s,"",'R');
}

/*---------------------------------------------------------------------------*/

static int parseline(char *s,char *indizes)
//*************************************************************************
//
//  Teilt eine Zeile in einzelne Woerter auf.
//  Rueckgabe: Anzahl der Woerter
//             Array mit den Indizes der einzelnen Woerter
//
//*************************************************************************
{ int offset=0,
      i=0,
      word=0;

  while(s[0]>=' ')
  { if(((*s)==' ')||((*s)==','))
    { *s=0;
      word=0;
    }
    else
    { if(!word)
	indizes[i++]=offset;
      word=1;
    }
    s++;
    offset++;
  }
  *s=0;
  indizes[i]=0;
  return i;
}

/*---------------------------------------------------------------------------*/

static int scanforwardoption(char *opt,int boxindex)
{ if((opt[0]=='-') && isalpha(opt[1]))
  { fp[boxindex].options|=(1L<<(toupper(opt[1])-'A'));
    switch(opt[1])
    { case 'B':
	fp[boxindex].maxbytes=atol(opt+2);
	break;
#ifdef HRX_OPT
      case 'C':                                   // JJ
        fp[boxindex].fwdcallformat=atoi(opt+2);   // JJ
        break;                                    // JJ
#endif
    }
    return 1;
  }
  else
    return 0;
}

/*---------------------------------------------------------------------------*/

static char *last_field(char *adr)
{ int len=strlen(adr);
  while(len && adr[len]!='.')
    len--;
  return adr+len;
}

/*---------------------------------------------------------------------------*/

static void strip_hadr(char *adr)
{ while(strchr(adr,'.') && strstr(m.boxadress,last_field(adr)))
    last_field(adr)[0]=0;
}

/*---------------------------------------------------------------------------*/

void initfwdlist(int) // int??? TODO (DH3MB)
//*************************************************************************
//
//  Legt die Forwardliste an. Die Liste wird aus einem File eingelesen
//  und bleibt dann stndig im Speicher liegen.
//
//*************************************************************************
{ FILE *f;
  char s[100];
  char word[40];
  int boxindex=0;
  int destentry;
  int line=0;
  int i;
  fwdpara_t *ff;
  static char name[]="initfwdlist";

  static char fwd_init[]=
  ";sample fwd file\n"
  ";\n"
  ";db0aab - db0aab-8 hb9ra-2\n"
  ";     db0aab  $wp\n"
  ";\n";

  ff=&fp[0];
  for(i=0;i<MAXFWD;i++)
    memset(&fp[i],0,sizeof(fwdpara_t));

  f=s_fopen(FWDLISTNAME,"srt");
  if(f)
  { while(fgets(s,100,f))
    { line++;
      if(strchr(s,';')) 
        strchr(s,';')[0]=0;
      if(strlen(s)>3)
      { destentry=(s[0]==' ');
	strupr(s);
	parseline(s,word);

	if(destentry)
	{ if(boxindex==0)   // erster Eintrag: Boxcall fehlt
	    goto error;
	  else
	  { char *dest=fp[boxindex-1].dest;
            i=0;
            if(dest[0]==0)
            { if(strcmp(fp[boxindex-1].call,m.boxname)!=0 &&
                 strcmp(fp[boxindex-1].call,DUMMY)!=0)
                sprintf(dest," %s ",fp[boxindex-1].call);
              else
                strcpy(dest," ");
            }
            while(word[i])
	    { char dstb[20]=" ";
              strncpy(dstb+1,s+word[i],18);
              dstb[19]=0;
              strip_hadr(dstb+1);
              if(dstb[1] && !scanforwardoption(dstb+1,boxindex-1))
              { strcat(dstb," ");
                if(!strstr(dest,dstb))
                  strcat(dest,dstb+1);
	      }
	      i++;
	    }
	  }
	}
	else
	{ if(boxindex==0)
	    ff->dest=boxdest;
	  else
	    ff->dest=fp[boxindex-1].dest+strlen(fp[boxindex-1].dest)+1;

	  ff->dest[0]=0;
	  ff->call[0]=0;
	  ff->sidrtt=0;
	  ff->concall[0]=0;
	  ff->times[0]=0;
          ff->n_conok=0;
          ff->lastwp=0;
          ff->n_login=0;
          ff->txf=0;
          ff->rxf=0;
          ff->timeout_cnt=0;
          ff->connectbar=0;

	  if(strlen(s+word[0])<=6)
	    strcpy(ff->call,s+word[0]);
	  else goto error;                        // Boxcall zu lang
	  if(word[1])
	  { if(strlen(s+word[1])==24)
	      strcpy(ff->times,s+word[1]);
	    else if (*(s+word[1])=='-')
              strcpy(ff->times,"APAAAAAAAAAAAAAAAAAAAAAA");
            else goto error;
	    ff->concall[0]=0;
	    i=2;
	    while(word[i])
	    { if(strlen(s+word[i])<=15) //dg9mhz: was 9, ax: needs more
	      {	strcat(ff->concall,s+word[i]);
		strcat(ff->concall," ");
	      }
	      else goto error;                      // Connectcall zu lang
	      i++;
	    }
	    ff->connectbar=1;
	    ff->ssid=m.fwdssid;
	  }
	  boxindex++;
	  ff=&fp[boxindex];
	  if(boxindex>=MAXFWD)
	  { trace(serious,name,"too many partners");
            if (*b->logincall)
              putf("fwdlist: too many partners.\n");    
	    break;
	  }
	}
      }
    }
    ff->call[0]=0;
    s_fclose(f);
    trace(report,name,"%d partners",boxindex);
    if (*b->logincall)
      putf("initfwdlist: %d partners.\n",boxindex);
    fwdpartners=boxindex;
    if(boxindex)
      fwddestlen=(unsigned)(fp[boxindex-1].dest-boxdest)+
                           strlen(fp[boxindex-1].dest);
    else
      fwddestlen=0;
    return;
  }
  else
  { f=s_fopen(FWDLISTNAME,"swt");
    if(!f)
    { // file is not accessible (why ever...)
      trace(serious,name,"open "FWDLISTNAME);
      if (*b->logincall)
      putf("fwdlist: open "FWDLISTNAME" error.\n");
      return;        
    }
    fwrite(fwd_init,sizeof(fwd_init)-1,1,f);
    s_fclose(f);
    trace(replog,name,"sample fwd.bcm generated");
    return;
  }

  error:
    sound(1000);
    wdelay(106);
    nosound();
    trace(serious,"fwdlist","line %d error",line);
    if (*b->logincall)
      putf("fwdlist: line %d error.\n",line);
    s_fclose(f);
}

/*---------------------------------------------------------------------------*/

void printfwdlist(char *box)
//*************************************************************************
//
//  Gibt die Forwardliste aus. Die Ausgabe erfolgt im gleichen
//  Format wie die Eingabe ber das Initialisierungsfile
//
//*************************************************************************
{ int boxindex=0;
  int di=0,tab=0;
  fwdpara_t *ff;

  ff=&fp[boxindex];
  while(ff->call[0])
  { if((!box[0])||(stristr(ff->call,box)))
    { putf("\n; BBS  012345678901234567890123 Path\n%-6s %s %s", //OE3DZW sep.
        ff->call,ff->times,ff->concall);
      if(ff->options)
      { int i;
	putf("\n ");
	for(i=0;i<26;i++)
	{ if((ff->options>>i)&1)
	  { int ch=i+'A';
            putf(" -%c",ch);
	    switch(ch)
	    { case  'B': putf("%ld",ff->maxbytes); break;
#ifdef _LCF
              case  'C': putf("%ld",ff->fwdcallformat); break; // JJ
#endif
	    }
	  }
	}
      }
      di=0;
      if(ff->dest[0])
      { tab=80;
	while(ff->dest[di])
	{ if((tab>65) && ff->dest[di]==' ' && ff->dest[di+1])
	  { putf("\n ");
	    tab=0;
	  }
	  putv(ff->dest[di]);
	  di++;
	  tab++;
	}
      }
    }
    boxindex++;
    ff=&fp[boxindex];
  }
  putv('\n');
}

/*---------------------------------------------------------------------------*/

void fwdstat(char *box)
//*************************************************************************
//
//  Gibt die Anzahl der anstehenden Nachrichten fr alle Nachbarboxen aus
//
//*************************************************************************
{ int boxidx=0;
  char fname[FNAMELEN+1];
  char s[82];
  long mails;
  int bulletin;
  FILE *f;
  int ok;
  fwdpara_t *ff;
  long int bytes;
  long int bytessum=0L;
  long int mailsum[2]={0L, 0L};

  ff=&fp[boxidx];
//      123456_123456781234_12345_1234_12345_1234
  putf("BBS    Status    incoming   outgoing  RTT");
//      _1234567_1234567_123456
  putf("    User    Info kBytes");
  #ifdef HRX_OPT2  
  putf("\n-----------------------------------------");
  putf("-------------------------------");
  #endif
  while(ff->call[0])
  { if(box[0]==0 || stristr(ff->call,box))
    { if(strcmp(ff->call,DUMMY)!=0)
      { bytes=0L;
        if(eingelogt(ff->call,j_fbb_send_propose))      ok=11;
        else if(eingelogt(ff->call,j_fbb_send_mail))    ok=10;
        else if(eingelogt(ff->call,j_fbb_send_delay))   ok=9;
        else if(eingelogt(ff->call,j_fbb_recv_propose)) ok=8;
        else if(eingelogt(ff->call,j_fbb_recv_mail))    ok=7;
        else if(eingelogt(ff->call,j_fbb_end))          ok=6;
        else if(eingelogt(ff->call,j_fbb_error))        ok=5;       
        else if(eingelogt(ff->call,j_fwdsend))          ok=4;
        else if(eingelogt(ff->call,j_fwdlink))          ok=3;
        else if(eingelogt(ff->call,j_fwdrecv))          ok=2;
        else                                            ok=ff->connectbar;        
        putf("\n%-6s ",ff->call);
                             //  12345678
//      if (ok==0)         putf("        ");
        if (ok==0)         putf("no link "); // Zur Mailbox kann keine Ver-
					     // bindung aufgebaut werden. (hpk)
        if (ok==1)         putf("ok      ");
        if (ok==2)         putf("a recv  ");
        if (ok==3)         putf("setup   ");
        if (ok==4)         putf("a send  ");
        if (ok==5||ok==6)  putf("f end   ");
        if (ok==7||ok==8)  putf("f recv  ");
        if (ok==9)         putf("f delay ");
        if (ok==10||ok==11)putf("f send  ");

        putf("%4s ",zeitspanne(ad_time()-ff->lastlogin,zs_seconds));
        if (ff->n_login)
          putf("%5ld ",ff->n_login);
        else
          putf("      ");
        putf("%4s ",zeitspanne(ad_time()-ff->lastconok,zs_seconds));
        if (ff->n_conok)
          putf("%5ld ",ff->n_conok);
        else
          putf("      ");
        if (ff->sidrtt)
          putf("%4s",zeitspanne(ff->sidrtt,zs_seconds));
        else
          putf("    ");
        //if (ff->timeout_cnt)
        //  putf("%5ld",ff->timeout_cnt);
        //else
        //  putf("     ");
        for(bulletin=0;bulletin<2;bulletin++)
        { switch(bulletin)
          { case 0:
              strcpy(fname,FWDPATH"/u_");
              break;
            case 1:
              strcpy(fname,FWDPATH"/i_");
              break;
          }
          strcat(fname,ff->call);
          strcat(fname,".bcm");
          strlwr(fname);
          mails=0L;
          f=s_fopen(fname,"lrt");  //fwdtrigger
          if(f)
          { while(fgets(s,80,f))
            { if(s[0]!=' ')
                mails++;
              if(strchr(s, ' '))
                bytes+=atol(strchr(s, ' ')+1);
              bytes+=80; //OE3DZW fix 80 Bytes per Mail;
              waitfor(e_ticsfull);
            }
            s_fclose(f);
          }
          if(mails)
          { mailsum[bulletin]+=mails;
            putf(" %7ld",mails);
          }
          else // 12345678
            putf("        ");
        }

        if(bytes)
          putf(" %6ld", bytes/1024);
        bytessum+=bytes/1024;
      }
    }
    boxidx++;
    ff=&fp[boxidx];
  }
  if (mailsum[0] || mailsum[1])
  { 
    #ifdef HRX_OPT2  
    putf("\n-----------------------------------------");
    putf("-------------------------------");
    #endif
    putf("\nTotal                                    ");
    for(bulletin=0;bulletin<2;bulletin++)
    { if(mailsum[bulletin])
      {
       putf(" %7ld",mailsum[bulletin]);
      }
      else // _1234567
        putf("        ");
    }
    putf(" %6ld", bytessum);
  }
  putf("\n");
}

/*---------------------------------------------------------------------------*/

#ifdef _TTY
// JJ - TTY - erkennt ob gewhlt werden mu
int isdialtime(char *call)
{ int i=0;
  struct tm *tt;
  time_t ti=ad_time();
  char ch;

  tt=ad_comtime(ti);

  while(fp[i].call[0])
  { if(stricmp(fp[i].call,call)==0)
    { ch=fp[i].times[tt->tm_hour];
      if((ch=='D'))
	return 1;
    return 0;
    }
    else
      i++;
  }
  return 0;
}
#endif

/*---------------------------------------------------------------------------*/

int isforwardtime(char *call, int bulletins)
//*************************************************************************
//
//  Gibt zurck, ob gerade zu einem Forwardpartner geforwardet
//  werden soll
//
//  Bei bulletins=3 wird zurckgegeben, ob fwdpartner gepollt werden soll
//
//*************************************************************************
{ int i=0;
  struct tm *tt;
  time_t ti=ad_time();
  char ch;
  int retwert=1;

  tt=ad_comtime(ti);

  while(fp[i].call[0])
  { if(stricmp(fp[i].call,call)==0)
    { ch=fp[i].times[tt->tm_hour];
      if(fp[i].connectbar)
	retwert=2;

      if(bulletins==3)
      { if(ch=='P')
	  return retwert;
	else
	  return 0;
      }
#ifdef _TTY
      if((ch=='A') || (ch=='P') || (ch=='D'))  // JJ
#else
      if((ch=='A') || (ch=='P'))
#endif
	return retwert;
      if(!bulletins && (ch=='U'))
	return retwert;
      else
	return 0;
    }
    else
      i++;
  }
  return 0;
}

/*---------------------------------------------------------------------------*/

int boxbinok(int fbball)
{ if(b->forwarding==fwd_none)
    return 1;
  if(b->opt&o_d)
    return 1;
  if(b->boxtyp==b_thebox && b->boxversion>=19)
    return 1;

  // Send personal binary messages to fbb

  if(b->opt&o_b && (fbball || b->mailtype=='P'))  
    return 1;

  if((b->forwarding==fwd_standard
#ifdef _FILEFWD
      || b->forwarding == fwd_file
#endif
      ) && (fpara()->options&o_i))
    return 1;
  return 0;
}

/*---------------------------------------------------------------------------*/

void add_hold(char *reason, int returnmail)
//*************************************************************************
//
//  Erzeugt eine Zeile in sfhold
//
//*************************************************************************
{ FILE *f=s_fopen(TRACEPATH"/"SFHOLDNAME,"sab");
  if (!f)
    f=s_fopen(TRACEPATH"/"SFHOLDNAME,"swb");
  if(f)
  { fprintf(f,"%s %s ",datestr(ad_time(),1),timestr(ad_time(),1));
    fprintf(f,"#%c %-6s:%-6s > %-6s ",b->fwdhold,b->logincall,
      b->herkunft,b->ziel);
    fprintf(f,"@%s $%s %s"NEWLINE,b->at, b->bid,reason);
    s_fclose(f);
  }
  if(returnmail && returnmailok() &&
     b->forwarding==fwd_standard)
  { char sendcmd[80];
    char content[255];
    sprintf (sendcmd,"SP %s < %s HOLD: Your mail for %s",
             b->herkunft,m.boxname,b->zielboard);
    sprintf (content, "Your msg for %s @ %s $%s could\n"
                      "not be forwarded from %s to %s.\nReason: %s.",
                      b->zielboard, b->at, b->bid, m.boxname, b->logincall,
                      reason);
    genmail(sendcmd,content);
  }
}

/*---------------------------------------------------------------------------*/

int scanheader(FILE *f,fwdpara_t *ff)
//*************************************************************************
//
//  Investigate the header of a message against plausibility
//  faults before forwarding the mail.
//
//  return value:
//
//    - 1 if message was found correctly
//    - 0 if an error had occurred. message is not forwarded
//        reason is remarked into syslog
//
//*************************************************************************
{ char s[257];
  int i=3;
  int ownbox=0;
  time_t lasttime=ad_time();

  if(!f || !ff) return 0;

  rewind(f);
  fgets(s,256,f);
  mbsend_parse(s,0);
  s[90]=0;

  // Max. Mailgroesse wurde ueberschritten
  // oe3dzw: Mail generieren falls nicht Status HOLD gesetzt
  if((ff->options & o_b) && (b->bytes>ff->maxbytes) &&(ff->maxbytes > 1024))
  { if (returnmailok() && (b->fwdhold == '!'))
    { char sendcmd[80];
      char content[80];
      sprintf(sendcmd,"SP %s @ %s < %s Mail at %s\n",
                      b->ziel,b->at,b->herkunft,m.boxadress);
      sprintf(content,"Message too large, no forward to %s.\n",
                      b->logincall);
      genmail(sendcmd,content);
      b->fwdhold = 'S';
      add_hold("too large",1);
      writemailflags();
    }
    return 0;
  }
  // Nachbarbox kann kein BoxBin
  if(b->binstart && !boxbinok(0))
  { //oe3dzw: Mailtype..
    if((b->mailtype == 'P') && (b->fwdhold == '!'))
    { 
      b->fwdhold = 'B';
      add_hold("no binary fwd",1);
      writemailflags();
    }
    return 0;
  }
  // oe3dzw: Bulletin kam von dieser Box
  if(b->mailtype=='B' && (strcmp(b->frombox,b->logincall)==0))
    return 0;

  // JJ no 7+/BIN bulletins
  if(b->mailtype=='B' && (ff->options & o_k) &&
     (b->msgty=='7' || b->msgty=='6' || b->binstart))
  {
#ifdef HRX_OPT
    b->fwdhold='K';
    add_hold("no 7plus/bin fwd",1);
    trace(report,"fwds","7p/bin not for this box");
#endif
    return 0;
  }

  // No 7+/BIN personal mails
  if(b->mailtype!='B' && (ff->options & o_l) &&
     (b->msgty=='6' || b->msgty=='7' || b->binstart))
  { b->fwdhold='L';
    add_hold("no 7plus/bin fwd",1);
    writemailflags();
    return 0;
  }

  // BID verloren?
  if((b->mailtype == 'B')  && (b->bid[0]==0))
  { trace(serious,"fwds","bid missing %s>%s",b->herkunft,b->ziel);
    b->fwdhold = 'E';
    add_hold("no bid",1);
    writemailflags();
    return 0;
  }

  while(fgets(s,256,f))
  { if(i)  // Komandokopf, Forwardcalls und Betreff der Nachricht wegmachen
      i--;
    else
    { char *ha;
      if((s[0]=='R') && (s[1]==':'))
      { if(b->mailtype == 'P')    // oe3dzw mailtype abgefragt 
	  lasttime=ad_time();     // oldestfwd soll nur bei Bulletins greifen
	else
	{ lasttime=getheadertime(s);
          if(lasttime==0)
            lasttime=ad_time();
        }
	ha=getheaderadress(s);
	if(ha && strcmp(ha,m.boxadress)==0 && s[13]=='z')
	  ownbox++;
      }
      else
	break;
    }
  }
  // loop
  if(b->fwdhold=='!' &&         // check only if not held before
     ownbox>(1+(( !(b->mailtype=='B') &1)*2)))   // Pers. mails drfen 
					         // 3mal durchlaufen
  { if(b->mailtype=='P') 
    { trace(replog,"fwds","loop %s>%s @%s",b->herkunft,b->ziel,b->at);
      b->fwdhold = 'L';
      add_hold("fwd loop",1);
      writemailflags();
    }
    return 0;
  }

  // too old..
  else if(lasttime<(ad_time()-((long)m.oldestfwd*1440L*60L)))
  { trace(replog,"fwds","too old %s>%s $%s",b->herkunft,b->ziel,b->bid);
    return 0;
  }
  else
    return 1;
}

/*---------------------------------------------------------------------------*/

static char *fname_aus_path(char *path)
//*************************************************************************
//
//  Extrahiert aus einem Pfadnamen den Filenamen (steht am Ende, bis /)
//
//  z.B. Eingang:  INFO/GERAETE/YAESU/12DEAD6
//       Rckgabe: 12DEAD6
//
//*************************************************************************
{ int i=strlen(path);

  while(i && (path[i-1]!='/')) i--;
  return path+i;
}

/*---------------------------------------------------------------------------*/

char *board_aus_path(char *path)
//*************************************************************************
//
//  Extrahiert den Namen eines Boards aus dem vollstndigen Pfadnamen
//
//  z.B. Eingang:  INFO/GERAETE/YAESU/12DEAD6
//       Rckgabe: YAESU
//
//*************************************************************************
{ static char boardname[10];
  int i=strlen(path),j=0;
  int end=0;

  while(i && (path[i-1]!='/')) i--;
  if(!i)
    trace(serious,"board_aus_path","path %s",path);
  else
  { i=end=i-1;

    while(i && (path[i-1]!='/')) i--;
    for(;i<end;i++)
    { boardname[j++]=path[i];
      if(j>8)
      {	trace(serious,"board_aus_path","fn %s",path);
	break;
      }
    }
    boardname[j]=0;
    return boardname;
  }
  return "??";
}

/*---------------------------------------------------------------------------*/

void markfwd(void)
//*************************************************************************
//
//  Vermerkt in einer Nachricht, dass sie geforwardet worden ist
//
//*************************************************************************
{ char line[256];
  char *pos;
  char *crlf;
  FILE *f;

  strlwr(b->mailpath);
  f=s_fopen(b->mailpath,"sr+b");
  if(f)
  { fread(line,255,1,f);    // Header- und Forwardzeile einlesen
    line[255]=0;

    crlf=strchr(line,'\n');
    if(crlf!=NULL)
    { if((pos=strstr(crlf+1,b->logincall))!=NULL)
      { while(isalnum(pos[0]))
	  pos++;
	if((pos[0]==' ')||(pos[0]=='.'))
	{ pos[0]='*';
	  rewind(f);
	  fwrite(line,255,1,f);
	}
      }
    }
    s_fclose(f);
  }
}

/*---------------------------------------------------------------------------*/

void readmail(FILE *f, char crlf) // DG4MMI
{ int c, last=0;

  while((c=fgetc(f))!=EOF)
  { if(last=='\n' && c=='#' && testreadbin(f,0,0))
    { f=NULL;
      break;
    }

    if(crlf && (c=='\n')) // DG4MMI: Force CR/LF as EOL-specifier
      bputv('\r');        // (Used in the uncompressed files in FBB-Forward)

    putv(c);
    last=c;
    if(c=='\n')
    { waitfor(e_ticsfull);
      timeout(m.fwdtimeout);
    }
  }

  if(!b->binstart && last!='\n')
  { if(crlf)       // DG4MMI: Force CR/LF as EOL-specifier
      bputv('\r'); // (Used in the uncompressed files in FBB-Forward)
    putf("\n");
  }

  if(f)
    s_fclose(f);
}

/*---------------------------------------------------------------------------*/

int setfullpath(char *path)
{ if(finddir(board_aus_path(path),b->sysop))
  { strcpy(b->mailpath,b->boardpath);
    strcat(b->mailpath,"/");
    strcpy(b->listpath,b->mailpath);
    strcpy(b->mailfname,fname_aus_path(path));
    strcat(b->mailpath,b->mailfname);
    strcat(b->listpath,DIRLISTNAME);
    return 1;
  }
  return 0;
}

/*---------------------------------------------------------------------------*/

void killforwarded(char *fname)
//*************************************************************************
//
//  Durchsucht eine Forwardliste und loescht Files, die bereits
//  geforwardet sind.
//
//*************************************************************************
{ if(strstr(fname,"/m_")) //only if not e/m-Mails
    return;

  FILE *f;
  FILE *f2;
  char s[80];
  char mailname[30];
  long n=0; // number of mails in output-triggerfile
  long x=0; // number of mails in input-triggerfile
  int good; // this entry is vaild
  char name[]="killforwarded";
  char tmpname[20];  // [8+CALLEN+strlen(FWDPATH)]; // eg. fwd/i_db0aab.bcm

  if (strstr(fname,".bcm"))
  { strcpy(tmpname,fname);
    char * a=strstr(tmpname,".bcm");
    strcpy(a,".tmp");  // eg. fwd/i_db0aab.tmp
  }
  else
    trace(fatal,name,"fname %s",fname);
  
  while(sema_lock(fname)==0)
    wdelay(1543);
  
  f=s_fopen(fname,"srt");
  if(f)
  { FILE *of=s_fopen(tmpname,"swt");
    if(of==NULL)
    { trace(serious,"killforwarded","fopen errno=%d",errno);
      s_fclose(f);
      return;
    }
    s_fsetopt(of,1);
    while(fgets(s,78,f))
    { if (strlen(s)==0 || strlen(s) > 50)  // if there is trash in the forward file, remove it
      { fgets(s,78,f); //skip next entry 
        trace(serious,name,"trash");
        continue;
      }
      x++;
      if(s[0]>' ')
        { strncpy(mailname,s,29);
          mailname[29]=0;
          if (strchr(mailname,' '))  //remove trailing infos
            *strchr(mailname,' ')=0;
          if (strlen(s) < MIN_TRIG_LEN)
          { trace(serious,name,"%s trash %s",fname,s); //debug
            good=0;
          }
          if (n > 7) // at least the first 7 entries should be ok 
          {
            good=1;
          }
          else          
          { setfullpath(mailname);
            strlwr(b->mailpath);
            if((f2=s_fopen(b->mailpath,"srt"))!=NULL)              
            { fgets(b->line,255,f2); //skip header line
              fgets(b->line,255,f2);  //read trigger line
              s_fclose(f2); 
              if (b->line[0]=='*') 
                good=0;
              else
                good=1;
            }
            else
              good=0;
          }
          if (good)
          { n++;
            fputs(s,of);
          }
        }
      //waitfor(e_ticsfull);  
    }
    s_fclose(f);
    s_fclose(of);
    xunlink(fname);
    if (n)
      xrename(tmpname,fname);
    else
      xunlink(tmpname);
    //trace(report,"killfwded","%s: %ld->%ld", 
    //  fname,x,n);
  }
  sema_unlock(fname);
}

/*---------------------------------------------------------------------------*/

unsigned char getfwdlistentry(char *call, char type, char num, char **lines)
//*************************************************************************
//
//  Scans the list- or fwd-trigger-file of "call" and returns a list
//  seperated with 0-bytes of at most <num> mails we must forward to
//  the partner
//
//  Returns number of mails in the list
//
//  "*lines" is set to one byte after the final 0-byte of the list
//
//  type: 'u', 'i', 'm': Scan a forward-trigger-file (fwd/<type>_<call>.bcm)
//        'l': Scan a list-file (<userpath>/<user>/<list.bcm>)
//        'c': Scan a list-file, but only check, if there are mails for S&F
//
//  (DG4MMI)
//
//*************************************************************************
{ char found=0;
  char *bytepos;
  char *delaypos;
  char mailname[30]; 
  char fpath[30];
  FILE *f,*f2;
  handle fh;
  char name[]="getfwdlistentry";
  char *lineptr[FBB_MAX_PROP];

  if(num<=0)
    return 0;

  if(type=='u' || type=='i' || type=='m') 
  { sprintf(fpath, FWDPATH"/%c_%s.bcm", type, call);
    strlwr(fpath);
    killforwarded(fpath);

    if((f=s_fopen(fpath, "srt"))!=0) // fwdtrigger
    { while((found<num) && fgets(b->line,80,f)) // swapped
      { if(b->line[0]==' ') // skip already forwarded entries
          continue;

        if (strlen(b->line) < MIN_TRIG_LEN) // Simple plausibility check
        { trace(serious,name,"trash: %s",b->line);
          continue;
        }

        rmcrlf(b->line);
        waitfor(e_ticsfull);

        if(type!='m')
        { if((bytepos=strchr(b->line,' '))!=0) // Find byte-field
          { *(bytepos++)=0; // Replace space by end-of-string
            while(*bytepos==' ')
              bytepos++; // Skip blanks

            if((delaypos=strchr(bytepos,' '))!=0)
            { *(delaypos++)=0; // Replace space by end-of-string
              while(*delaypos==' ')
                delaypos++; // Skip blanks
            }
            else
              bytepos=0;
          }
          else
            delaypos=0;
        }
        else
        { bytepos=0;
          delaypos=0;
        }

        if(!(delaypos && atol(delaypos)>ad_time()))
        {




          if(type!='m')
          { strncpy(mailname,b->line,29);
            mailname[29]=0;
            setfullpath(mailname);
            strlwr(b->mailpath);

            if((f2=s_fopen(b->mailpath,"srt"))!=NULL)
            { fgets(b->line,255,f2); // Skip header line
              fgets(b->line,255,f2); // Read trigger line
              s_fclose(f2);
              if (b->line[0]=='*')
                trace(report,name,"erased: %s",mailname);
              else
              { int i=0;
                int d=0;
                while(i<found)
                { if(strcmp(lineptr[i],mailname)==0)
                    d++;
                  i++;
                }
                if(!d)
                { strcpy(*lines, mailname);
                  lineptr[found]=*lines;
                  *lines+=strlen(*lines)+1;
                  found++;
                }
              }
            }
          }
          else
          { int i=0;
            int d=0;
            while(i<found) 
            { if(strcmp(lineptr[i],b->line)==0)
                d++;
              i++;
            }
            if(!d) 
            { strcpy(*lines, b->line);
              lineptr[found]=*lines;
              *lines+=strlen(*lines)+1;
              found++;
            }
          }  





        }

      }
      s_fclose(f);
      return found;
    }
    else
      return 0;

  }
  else // type 'l' or 'c'
  { sprintf(b->listpath,"%s/%s/"DIRLISTNAME,m.userpath,call);
    strlwr(b->listpath);

    if((fh=s_open(b->listpath,"srb"))!=EOF)
    { while((_read(fh,b->line,128)==128) && (found<num))
      { waitfor(e_ticsfull);
        if(b->line[14]=='>') // Is the message erased?
        { if(type=='c')
          { s_close(fh);
            return 1;
          }
          else // type 'l'
          { b->line[7]=0;
            sprintf(*lines,"%s/%s",b->logincall,b->line);
            strupr(*lines);
            *lines+=strlen(*lines)+1;
            found++;
          }
        }
      }
      s_close(fh);
      return found;
    }
    else
      return 0;
  }
}

/*---------------------------------------------------------------------------*/

void delfwdlistentry(char *entry)
//*************************************************************************
//
//  Deletes an entry from a forward-list and deletes the whole
//  forward-trigger-file if there is no entry left
//  The function decides, in which forward-trigger-file the entry
//  must be
//
//  (DG4MMI)
//
//  19980115 OE3DZW reduced priority of err-msges
//
//*************************************************************************
{ char type;
  char entry_left=0;
  char fwdfname[FNAMELEN+1];
  char found=0;
  unsigned long int lastpos=0L, curpos;
  FILE *f;
  char name[]="delfwdlistentry";

  if(entry[1]==' ')
    type='m';
  else
  { if(!strchr(entry, '/'))
    { trace(replog,name,"invalid: %s",entry);
      return;
    }
    *strchr(entry, '/')=0;
    if(mbcallok(entry))
      type='u';
    else
      type='i';
    *(entry+strlen(entry))='/';
  }

  sprintf(fwdfname, "%s/%c_%s.bcm", FWDPATH, type, b->logincall);
  strlwr(fwdfname);

  waitfor(e_ticsfull);

  f=s_fopen(fwdfname,"sr+t");  //fwdtrigger
  if(f)
  { while(fgets(b->line,100,f))
    { curpos=ftell(f);
      if(b->line[0]!=' ')
        if(stristr(b->line,entry)==b->line)
        { fseek(f,lastpos,SEEK_SET);
          fputc(' ',f);
          fseek(f,curpos,SEEK_SET);
          found++;
        }
        else
          entry_left=1;
      lastpos=ftell(f);
      waitfor(e_reschedule);
    }
    s_fclose(f);
    if(!entry_left)
      xunlink(fwdfname);
  }

  if(!found)
    trace(report,name,"not found: %s", entry);

  if(found>1)
    trace(report,name,"ambigious: %s", entry);
}

/*---------------------------------------------------------------------------*/

static void putsid(int tx)
//*************************************************************************
//
//  tx = 0 .. incoming connection
//       1 .. outgoing connection
//
//  Erzeugt das SID (System-ID) der eigenen Station.
//  Es wird beim Beginn jeder Forward-Session ausgetauscht
//
//*************************************************************************
{ char pwdfname[20];
  char pwds[30]="";
  char sid[40];
  int i;

  sprintf(pwdfname,"%s.pwd",b->logincall);
  strlwr(pwdfname);

  if(filetime(pwdfname)) // TheBox style password
  { if(tx)
    { if(b->privoffset<0)
      { fwdput("*** no logintime","");
        return;
      }
      else
      { FILE *f=s_fopen(pwdfname,"srt");
        if(f)
        { fseek(f,b->privoffset,SEEK_SET);
          fread(pwds,4,1,f);
          pwds[4]=0;
          s_fclose(f);
        }
        else
          trace(replog,"putsid","%s not found",pwdfname);
      }
    }
    else
    { struct tm *tt=ad_comtime(b->logintime);
      sprintf(pwds,"%02d%02d%02d%02d%02d",
              tt->tm_mday,tt->tm_mon+1,tt->tm_year%100,tt->tm_hour,tt->tm_min);

      //strftime(pwds,sizeof(pwds)," %d%m%y%H%M",localtime(&b->logintime));
    }
  }
  else if(u->password[0]>1 && u->sfpwtype<=2) // BayCom-/MD2-/MD5-password
  { if(tx)
    { if(b->password[0])
      { switch(u->sfpwtype)
        { case 0:
            { //randomize();
              int rndpos=random_max(6)+1;
              sprintf(pwds," ");
              for(int block=1;block<=6;block++)
              { for(i=0;i<5;i++)
                sprintf(pwds+strlen(pwds),"%c",(block==rndpos)?
                   b->password[i]:
                   (u->password[random_max(strlen(u->password))]));
              }
            } break;

          case 1:
          case 2:
            strcpy(pwds,b->password);
            break;
        }
      }
    }
    else
    { switch(u->sfpwtype)
      { case 0: genPWstring(u->password, pwds, b->password);break;
#ifdef FEATURE_MDPW
        case 1: genMDstring(2, u->password, pwds, b->password);break;
        case 2: genMDstring(5, u->password, pwds, b->password);break;
#endif
      }
    }
  }

#ifdef FBBFWD
  sprintf(sid,"[BayCom-"VNUMMER"-");
  if (!tx)
#ifndef _BCMNET_FWD //hpk & db1ras
    sprintf(sid+strlen(sid),"AB1D1FHMRW");
#else
    sprintf(sid+strlen(sid),"AB1D1FHMRWZ");
#endif    
  else
  { if (b->opt & o_a)
      sprintf(sid+strlen(sid),"A");
    if (b->opt & o_b) 
    { sprintf(sid+strlen(sid),"B");
      if (b->opt & o_b1) sprintf(sid+strlen(sid),"1");
    }
    if (b->opt & o_d) 
    { sprintf(sid+strlen(sid),"D");
      if (b->opt & o_d1) sprintf(sid+strlen(sid),"1");
    } 
    if (b->opt & o_f)
      sprintf(sid+strlen(sid),"F");
    sprintf(sid+strlen(sid),"H");
    if (b->opt & o_m)
      sprintf(sid+strlen(sid),"M");
    if (b->opt & o_r)
      sprintf(sid+strlen(sid),"R");
    if (b->opt & o_w)
      sprintf(sid+strlen(sid),"W");
#ifdef _BCMNET_FWD //hpk & db1ras
    if (b->opt & o_z)
      sprintf(sid+strlen(sid),"Z");
#endif    
  }
  sprintf(sid+strlen(sid),"$]");

#else
  strcpy(sid,"[BayCom-"VNUMMER"-ADHMR$]");
#endif

  if(pwds[0])
    strcat(sid," ");

  fwdput(sid,pwds);
}

/*---------------------------------------------------------------------------*/

static int fwd_privauswert(char *date,char *pwdfname)
//*************************************************************************
//
//  Hier wird bei einem ankommenen SID der Teil hinter der Klammer
//  ausgewertet, wenn fuer den Partner ein PRIV-File existiert.
//  Abhaengig von der Laenge wird der String entweder als Aufforderung
//  oder als Antwort interpretiert.
//
//*************************************************************************
{ if(strlen(date)!=4)
  { // 2301941530    23.01.94 15:30
    // 0123456789
    int day,hour,min;

    while(date[0] && !isdigit(date[0])) date++;
    if(date[0]==0)
    { fwdput("*** no priv logindate","");
      return 0;
    }
    min=atoi(date+8);
    date[8]=0;
    hour=atoi(date+6);
    date[2]=0;
    day=atoi(date);

    b->privoffset=((min+day)%60)*27+hour;
  }
  else
  { if(getpriv(date,pwdfname)==0)
    { fwdput("*** priv failure","");
      pwlog(b->logincall,b->uplink,"fwd priv failure");
      return 0;
    }
  }
  return 1;
}

/*---------------------------------------------------------------------------*/

static int fwd_pwauswert(char *str)
//*************************************************************************
//
//  Hier wird bei einem ankommenden SID der Teil hinter der Klammer 
//  ausgewertet, wenn kein PRIV-Password gesetzt ist.
//
//  Returns:  0 .. pw failed
//            1 .. pw ok
//
//*************************************************************************
{ int i=0;
  unsigned int n[5];

  /* sfpwtype:   0  ... BayCom
   *             1  ... MD2
   *             2  ... MD5
   *           100  ... inactive (for fwd/login)
   *           101  ... Errmsg (internal)
   *
   *  password[0]:  0 ... no password set
   *                1 ... password disabled
   *               >1 ... 1st character of password
   */

  // No password set and the partner did not send one
  if((u->sfpwtype>99 || u->password[0]<=1) && str[0]==0)
    return 1;

  // Password set, but partner did not send one
  if(str[0]==0)
  { fwdput("*** password expected","");
    pwlog(b->logincall,b->uplink,"fwd pw empty");
    return 0;
  }

  // No password set, but the partner did send one
  if(u->sfpwtype>99 || u->password[0]<=1)
  { trace(report,"fwd_pwauswert","str='%s'",str);
    fwdput("*** no password expected","");
    return 0;
  }

  switch(u->sfpwtype) // DG4MMI
  {
  case 0:
    if(sscanf(str,"%d%d%d%d%d",n,n+1,n+2,n+3,n+4)==5)
    { for(i=0;i<5;i++)
      { if((n[i]-1)<strlen(u->password)) 
          b->password[i]=u->password[(n[i]-1)];
        else
        { fwdput("*** pw value out of range","");
          b->password[0]=0;
          return 0;
        }
      }    
      b->password[5]=0;
    }
    else
    { if(b->password[0] && strstr(str,b->password))
        return 1;
      else
      { fwdput("*** pw failure","");
        pwlog(b->logincall,b->uplink,"fwd pw failure");
        return 0;
      }
    }
    break;

#ifdef FEATURE_MDPW
  case 1: // MD2
  case 2: // MD5
    if(str[0]=='[')
    { char MDstr[12];
      strncpy(MDstr, str+1, 11);
      if(MDstr[10]!=']')
      { fwdput("*** pw request string invalid","");
        return 0;
      }
      MDstr[10]=0;
      switch(u->sfpwtype)
      { case 1: calcMD2pw(MDstr, u->password, b->password); break;
        case 2: calcMD5pw(MDstr, u->password, b->password); break;
      }
    }
    else
    { if(b->password[0] && strcmp(str,b->password)==0)
        return 1;
      else
      { fwdput("*** pw failure","");
        pwlog(b->logincall,b->uplink,"fwd pw failure");
        return 0;
      }
    }
    break;
#endif
  }

  return 1;
}

/*---------------------------------------------------------------------------*/

static int sidauswert(char *sid)
//*************************************************************************
//
//  Wertet das ankommende SID des Forwardpartners aus. Hier koennen
//  unterschiedliche Gegebenheiten im Forwardprotokoll festgestellt werden
//
//*************************************************************************
{ char *pkt;
  int i;
  char pwdfname[20];

  sprintf(pwdfname,"%s.pwd",b->logincall);
  strlwr(pwdfname);

  if(strcmp(b->logincall,"DB0SAO")==0)   // DB0SAO machts anders....
  { b->boxtyp=b_thebox;
    b->boxversion=18;
    return 1;
  }

  for(i=0;i<2;i++)           // 2 Versuche, falls TNC-Ctext eingestellt
  { fwdget(sid,118);

    while(sid[0]=='>') // workaround for unknown bug at unknown site
      sid++;
    if((sid[0]=='[') && strchr(sid,'$'))
    {
      char *klzu=strchr(sid,']');
      if(klzu==NULL || klzu[1]!=' ')
        klzu="  ";
      if(filetime(pwdfname))
      { 
        if(fwd_privauswert(klzu+2,pwdfname)==0)
          return 0;
      }
      else
      {
        if(fwd_pwauswert(klzu+2)==0)
          return 0;
      }
      b->opt=0;
      klzu=strchr(sid,']');
      //OE3DZW: Auswertung der Optionsbuchstaben, Versionsnummer wird nicht
      //ausgewertet, $ wird fix vorausgesetzt 
      while(klzu && (--klzu)[0]!='-' && klzu>sid)
      { if(isalpha(klzu[0]))
        {  b->opt|=(1L<<(toupper(klzu[0])-'A'));
        //   trace(report,"fwd","SID-Option: %c",toupper(klzu[0]));
        }       
      }
      // test for D1..D4, B1..B4
      if (strstr(sid,"D1") > strrchr(sid,'-'))
        b->opt|=o_d1;
      if (strstr(sid,"D2") > strrchr(sid,'-'))
        b->opt|=o_d1;
      if (strstr(sid,"D3") > strrchr(sid,'-'))
        b->opt|=o_d1;
      if (strstr(sid,"D4") > strrchr(sid,'-'))
        b->opt|=o_d1;

      if (strstr(sid,"B1") > strrchr(sid,'-'))
        b->opt|=o_b1;
      if (strstr(sid,"B2") > strrchr(sid,'-'))
        b->opt|=o_b1;
      if (strstr(sid,"B3") > strrchr(sid,'-'))
        b->opt|=o_b1;
      if (strstr(sid,"B4") > strrchr(sid,'-'))
        b->opt|=o_b1;


      strupr(sid);

      if(strstr(sid,"BAYCOM") || strstr(sid,"OPENBCM"))
      {
        b->boxtyp=b_baycom;
#ifdef _BCMNET_FWD //hpk & db1ras
        if(! (b->opt & o_z))
          return 0;
#endif
      }
      else if(strstr(sid,"THEBOX"))
	b->boxtyp=b_thebox;
      else
	b->boxtyp=b_unknown;
      pkt=strchr(sid,'-');
      b->boxversion=0;
      if(pkt)
      { if(isdigit(pkt[1]))
	  b->boxversion=(pkt[1]&15)*10;
	if(isdigit(pkt[3]))
	  b->boxversion+=(pkt[3]&15);
      }
      return 1;
    }
  }
  return 0;
}

/*---------------------------------------------------------------------------*/

// OE3DZW: Diese Texte sind fix eingestellt, vgl. FBB, dort ist eine
// Sysop-Konfiguration notwendig.

static int waitconnect(char *buf, int fpac)
{ for(;;)
  { fwdget(buf,80);
    strupr(buf);
    // trace(report,"waitconnect","%d:%s",fpac,buf);
    if (!fpac) //BayCom,Flexnet,Nordlink-Connect-String
    { if(strstr(buf,"CONNECTED TO"))
        return 1;
    }
    else  //FPAC-Connect-String
    { //france
      if (strstr(buf," @ ") && strstr(buf,"CONNECTE"))
      return 1; //  "Connecte a F6KIF-1 @ 208651501"
      //slovenia vzpostavljena /croatia 
      if (strstr(buf,"ZPOSTAVLJEN"))
      return 1;
    }
    if(strstr(buf,"INVALID"))
      return 0;
    if(strstr(buf,"FAILURE"))
      return 0;
    if(strstr(buf,"BUSY"))
      return 0;
    if(strstr(buf,"LOOP"))
      return 0;
    if(strstr(buf,"FULL"))
      return 0;
    if(strstr(buf,"NO CHAN"))
      return 0;
    if(strstr(buf,"NO ROUT"))
      return 0;
    if(strstr(buf,"T ROUTE"))
      return 0;
    //slovenia
    if(strstr(buf,"PODRTA"))
      return 0;
    //croatia
    if(strstr(buf,"PREKINUTA"))
      return 0;
  }
}

/*---------------------------------------------------------------------------*/

void fwdsend(char *call)
{ int box=0;
  int i=0;
  int fpac;
  char buf[132];
  char mycall[20];
  char rauscall[10];
  char *cc;
  time_t sidt;
  fwdpara_t *ff;

  if(m.disable==1)
    return;

  b->continous=1;
  b->job=j_fwdlink;
  strupr(call);
  strcpy(b->logincall,call);
  box=isforwardpartner(call);
  if(box==NOTFOUND)
    b->forwarding=fwd_user;
  else
    b->forwarding=fwd_standard;

  if(another_fwd_sender(call))
    return;

  ff=fpara();

  strcpy(mycall,m.mycall[0]);
  if(strstr(mycall,"-"))
    strstr(mycall,"-")[0]=0;

  if(ff->ssid)
    sprintf(rauscall,"%s-%u",mycall,ff->ssid);
  else
    strcpy(rauscall,mycall);

  if(ff->ssid==m.fwdssid) // change SSID in relation to last connect
  { ff->ssid+=1;          // to avoid similar address fields
    if(ff->ssid>15)
      ff->ssid=1;         // avoid ssid zero
  }
  else
    ff->ssid=m.fwdssid;   // toggle between both ssids

  strcpy(b->logincall,ff->call);

  cc=ff->concall;
  while(cc[0] && (cc[0]!='/'))
  { buf[i]=cc[0];
    i++;
    cc++;
  }

  // OE3DZW: Anhaengende Leerzeichen entfernen
  while ((!buf[0]==0)&&(buf[i-1]==' '))
    i--;
  buf[i]=0;

  ff->connectbar=0;
  trace(report,"fwdsend","%s (%s > %s)",call,rauscall,buf);
  lastcmd("fwd_connect");
  sidt = ad_time();
 
#ifdef _TTY         
  if(strstr(buf,"DUMMY")) return;                             // JJ
  if(!strstr(buf,"TTY") && !strncmp(b->uplink,"TTY",3)==0)    // JJ
  { if(!makeconnect(rauscall,buf))          
    { fwdlog("---- ","connect failed",'-'); 
      b->logincall[0]=0;                  
      return;                             
    }                                     
  setsession();                            
  b->logincall[0]=0;                                          // JJ
  mblogin(ff->call,login_fwd,"");                             // JJ
  }                                       
  else                                      
  { // TTY-FWD start                                          // JJ
    if(!strncmp(b->uplink,"TTY",3)==0)                        // JJ
    { if(!isdialtime(call)) return;                           // JJ
      if(!tty_dial(buf,t->taskid))                            // JJ
      { fwdlog("---- ","connect failed",'-');                 // JJ
        b->logincall[0]=0;                                    // JJ
        return;                                               // JJ
      }                                                       // JJ
    }                                                         // JJ
    setsession();                                             // JJ
    t->input=io_tty;                        
    t->output=io_tty;                      
    b->logincall[0]=0;                 // JJ
    mblogin(ff->call,login_fwd,"TTY"); // JJ - UPLINK WICHTIG fr sptere Abfragen
  }                                         
#else
 
  if(!makeconnect(rauscall,buf))
  { fwdlog("---- ","connect failed",'-');
    b->logincall[0]=0;
    return;
  }
  setsession();
  b->logincall[0]=0;
  mblogin(ff->call,login_fwd,"");
#endif

  fwdlog("---- ","connect ok",'-');
  timeout(m.fwdtimeout);
  while(cc[0]=='/')
  { cc++;
    i=0;
    while(cc[0] && (cc[0]!='/'))
    { buf[i]=cc[0];
      i++;
      cc++;
    }
    // OE3DZW: Remove trailing blanks
    while ((!buf[0]==0)&&(buf[i-1]==' '))
      i--;           
    buf[i]=0;
    // Remove leading blanks
    i=0;     
    while (buf[i] != 0 && buf[i] == ' ')
      ++i; 

    // when connect-string starts with "%" -> expect fpac-connect-text

    fpac=0; //simple hack for fpac-digis
    if (buf[i] == '%')
    { i++;
      fpac=1;
    }

    while (buf[i] != 0 && buf[i] == ' ')
      ++i; 

    if (buf[i] == '=')
      fwdput(buf+i+1,"");
    else
      fwdput("C ",buf+i);
    putflush();
    lastcmd(buf);
    if(!waitconnect(buf,fpac))
    { mblogout(1);
      mbdisconnect(1);
      return;
    }
  }
  ff=fpara();
  if(ff->options & o_f) // OE3DZW: We send CR to TCP/IP-boxes
  { fwdput("","");
    putflush();
  }
  // OE3DZW: ...for...
  lastcmd("wait_for_sid");
  // DG4MMI: Changed structure of sending/receiving prompts/SIDs (for FBBfwd)
  if(sidauswert(buf))
  { lastcmd("wait_pr1");
    if(waitfwdprompt(buf)) // First prompt (we now may send our SID)
    { putsid(1);
      ff->connectbar=1;
      ff->lastconok=ad_time();
      ff->n_conok++;      
      ff->sidrtt=ff->lastconok-sidt+1;

      gen_wpmail(b->logincall);

#ifdef FBBFWD
      if (b->opt & o_f)
      { fbb fbbfwd;
        fwdlog("---- ","[FBB Fwd outgoing connection]",'-');
        fbbfwd.fwdmachine(1);
      }
      else
#endif
      { fwdlog("---- ","[RLI Fwd outgoing connection]",'-');
        lastcmd("wait_pr2");
        if(waitfwdprompt(buf)) // Second prompt (we now may send a RLI-command)
        ascii_fwdmachine(1);
      }
    }
  }

  mblogout(0);
  mbdisconnect(1);
}

/*---------------------------------------------------------------------------*/

int fwdmainloop(void)
//*************************************************************************
//
//  Handles an incoming S&F-connect
//
//*************************************************************************
{ char s[121]="";

  b->continous=1;
  b->job=j_fwdrecv;
  trace(report,"fwdlogin","%s via %s",b->logincall,b->uplink);
  fwdlog("---- ","login",'-');
  fpara()->lastlogin=ad_time();
  fpara()->n_login++;

  if(!eingelogt(b->logincall,j_fwdrecv))
  { if(fpara()->options & o_f)
    { fwdput("","");
      putflush();
    }
    putsid(0);
    lastcmd("rx_wait_sid");
    timeout(m.fwdtimeout);
    if(!(fpara()->options & o_p))
      fwdput(">","");

    if(sidauswert(s))
    { gen_wpmail(b->logincall);

#ifdef FBBFWD
      if (b->opt & o_f)
      { fbb fbbfwd;
        fwdlog("---- ","[FBB Fwd incoming connection]",'-');
        fbbfwd.fwdmachine(0);
      }
      else
#endif
      { fwdlog("---- ","[RLI Fwd incoming connection]",'-');
        ascii_fwdmachine(0);
      }
    }
  }

  return 1;
}

/*---------------------------------------------------------------------------*/

int weiterleiten2(int setmybbs,char *boardname)
//*************************************************************************
//
//  Hier werden ankommende H-Adressen ausgewertet.
//
//  Dabei koennen folgende Ergebnisse herauskommen: (enum fwd_weiter_typ)
//
//     unbekannt    - Adresse konnte nicht sinnvoll ausgewertet werden
//                    bzw. es ist kein Forwardpartner bekannt, der einen
//                    passenden Eintrag hat.
//
//     bekannt      - Eintrag wurde gefunden, zurckgelieferte Boxenliste
//                    zeigt die Boxen, zu denen das File geschickt werden
//                    soll
//
//
//     bleibtliegen - Es ist entweder gar keine Adresse angegeben, oder
//                    die Adresse ist das eigene Call. In beiden Fllen
//                    ist die Angabe gltig, fhrt aber nicht zum
//                    Weiterleiten der Nachricht.
//   obsolete option:
//     fuernachbarn - Adresse zeigt auf einen direkten Forwardnachbarn
//                    Beim Absenden des Files sollte die Adresse
//                    NICHT mitgesendet werden, damit dort eine evtl
//                    Weiterleitung durch MYBBS erfolgt.
//
//*************************************************************************
{ int box=0;
  unsigned int matchlen=0;
  char *adr=b->at;
  char atc[12];
  char tmp[HADRESSLEN+1];
  char hadr[HADRESSLEN+1];
  char testboard[12];

  b->destboxlist[0]=0;

  if(mbcallok(boardname) && adr[0] && mbhadrok(adr)!=1)
    return unbekannt;

  if(boardname[0] && !mbcallok(boardname))
    strcpy(testboard+1,boardname);
  else
    strcpy(testboard+1,"**");
  testboard[7]=0;
  testboard[0]='*';
  if(strlen(testboard)<7)
    strcat(testboard," ");

  if(strcmp(atcall(adr),m.boxname)==0)
  { if(b->forwarding!=fwd_none)  // wenns von einer anderen Box kommt dann
      adr[0]=0;              // die Adresse entfernen damit evtl mybbs greifen
  }                          // kann.

  if(mbcallok(boardname)==1 && (adr[0]==0 || setmybbs))   // don't waste stack
    get_mybbs(boardname,adr,setmybbs);

  strcpy(atc,atcall(adr));

  int expandforce=m.hadrstore;  // fix 2
  do
  {
    expand_hadr(adr,expandforce);
    strcpy(hadr,adr);

    b->destboxlist[0]=0;

    if(adr[0]==0)
      return mbcallok(boardname)?unbekannt:bleibtliegen;
   
    // ist es an das eigene Boxcall gerichtet?
    //
    if(strcmp(atc,m.boxname)==0)
      return bleibtliegen;
    // Suche nach dem ersten Teil des H-Bezeichners, ob er in der FWD-Liste
    // steht. Bei gueltigen Rufzeichen reicht es, wenn .CALL in der Adresse
    // vorkommt.
    //
    for(box=0;fp[box].call[0];box++)
    { char *ds=fp[box].dest;
      char *bl;
      char *found;

      while((bl=strchr(ds,' '))!=NULL) 
      { strncpy(tmp,ds,HADRESSLEN-1);
        tmp[HADRESSLEN-1]=0;
        found=strchr(tmp,' ');
        if(found && found!=tmp)
        { found[0]=0;
          if(strlen(b->destboxlist)<131 && strcmp(atc,tmp)==0 )
          { if(mbcallok(atc) ||
	      (!strstr(fp[box].dest,testboard) ^ !!(fp[box].options & o_r)))
	    { strcat(b->destboxlist,fp[box].call);
	      strcat(b->destboxlist,"  ");
            }
          }
        }
        ds=bl+1;
      }
    }
    if(b->destboxlist[0])
      return bekannt;
    strip_hadr(hadr);
    // Suche nach am Ende nach Bezeichnern,
    // die in der Destinations-Liste stehen
    //
    for(box=0;fp[box].call[0];box++)
    { char *ds=fp[box].dest;
      char *bl;
      char *found;
      unsigned int  adrend=strlen(hadr);
      unsigned int  len;

      while((bl=strchr(ds,' '))!=NULL)
      { strncpy(tmp,ds,HADRESSLEN);
        tmp[HADRESSLEN]=0;//string alloc  HADRESSLEN+1
        found=strchr(tmp,' ');
        if(found && found!=tmp)
        { found[0]=0;
          if(tmp[0]=='.' || mbhadrok(tmp)==1)
          { len=strlen(tmp);
	    if(len<=adrend && strcmp(hadr+(adrend-len),tmp)==0)
	    { if(len>matchlen)
	      { matchlen=len;
	        b->destboxlist[0]=0;
	      }
	      if(len==matchlen && strlen(b->destboxlist)<131)
              { strcat(b->destboxlist,fp[box].call);
	        strcat(b->destboxlist,"  ");
              }
	    }
	  }
        }
        ds=bl+1;
      }
    }

    if(b->destboxlist[0])
      return bekannt;
    else if(!mbcallok(atc))
      return unbekannt;
    // Wenn der Bezeichner selbst nicht gefunden wurde, wird die Liste
    // nach evtl. passenden Wildcards durchsucht.
    //
    matchlen=0;
    for(box=0;fp[box].call[0];box++)
    { char *ds=fp[box].dest;
      char *bl;
      char *found;
      char *anyfound;

      while((bl=strchr(ds,' '))!=NULL)
      { strncpy(tmp,ds,HADRESSLEN);
        tmp[HADRESSLEN]=0;
        found=strchr(tmp,'*');
        anyfound=strstr(tmp,"**");
        if (anyfound)
          found++;
        if(found && found!=tmp)
        { found[0]=0;
	  found=strstr(adr,tmp);
          if (!found && anyfound)
             found=adr;              // "**" will match any address
	  if(tmp[0] && (found==adr))
	  { if(strlen(tmp)>matchlen)
	    { matchlen=strlen(tmp);
	      b->destboxlist[0]=0;
	    }
	    if(strlen(tmp)==matchlen)
	    { if(strlen(b->destboxlist)<131)
              { strcat(b->destboxlist,fp[box].call);
	        strcat(b->destboxlist,"  ");
              }
	    }
	  }
        }
        ds=bl+1;
      }
    }

#ifdef _AUTOFWD
    if(!b->destboxlist[0] && m.autofwdtime!=0)    
    { char *autopathcall=autofwd(atcall(adr),0); 
      if (autopathcall)                           
       { strcat(b->destboxlist,autopathcall);   
         strcat(b->destboxlist,"  ");            
       }                                         
    }                                            
#endif

    if(b->destboxlist[0])
      return bekannt;
    else
    { if(expandforce==2 && mbcallok(atc))
        expandforce=3;
      else
        return unbekannt;
    }
  } while(1);
}

/*---------------------------------------------------------------------------*/

int weiterleiten(int setmybbs,char *boardname)
{ // Check for converted address if original address was not found

  int erg1=weiterleiten2(setmybbs,boardname);
  if (erg1==unbekannt && mbhadrok(b->at)==2)
  { char adr[HADRESSLEN+1];
    strcpy(adr,b->at);
    convat(b->at);
    erg1=weiterleiten2(setmybbs,boardname);
    strcpy(b->at,adr);
  }
  return erg1;
}

/*---------------------------------------------------------------------------*/

void add_fwdfile(char *frombox,short unsigned delaytime)
//*************************************************************************
//
//  Legt den angegebenen Filenamen in den Forwardlisten ab, die
//  zu den Nachbarboxen in (boxenliste) gehren.
//
//*************************************************************************
{ char fwdfname[20];
  char boxcall[8];
  char *boxenliste=b->destboxlist;
  FILE *fwdfile;
  char ds[20]="";

#ifdef _EXDLOGIN	//db1ras
  if (b->at[0]=='~')
    return;
#endif

  if(strchr(boxenliste,'.'))
    strchr(boxenliste,'.')[0]=0;
  b->usermail=mbcallok(b->boardname);

  // DG4MMI: Removed delaytime check

  if(delaytime)
    sprintf(ds," %ld",ad_time()+((long)delaytime)*60);

  while(boxenliste=nexttoken(boxenliste,boxcall,6),boxcall[0]>='0')
  { int box=isforwardpartner(boxcall);
    if(box!=NOTFOUND && (b->usermail || (strcmp(frombox,boxcall)!=0)))
    { if(b->usermail)
      {	fp[box].newmail=2;
        strcpy(fwdfname,FWDPATH"/u_");
      }
      else
      {	fp[box].newmail=1;
	strcpy(fwdfname,FWDPATH"/i_");
      }
      strcat(fwdfname,boxcall);
      strcat(fwdfname,".bcm");
      strlwr(fwdfname);

      if(strcmp(boxcall,DUMMY)!=0)
      { // Forward small mails first (DG4MMI)
/*  Code is buggy!      
        if((fp[box].options & o_o) && filetime(fwdfname))
        { char entrywritten=0;
          char fwdfnametmp[20];
          FILE *fwdnewfile;
          unsigned long int length;

          strcpy(fwdfnametmp, fwdfname);
          *strchr(fwdfnametmp, '_')='-'; // Replace '_' by '-'

          fwdfile=s_fopen(fwdfname, "srt"); //fwdtrigger
          fwdnewfile=s_fopen(fwdfnametmp, "swt");

          while(fgets(b->line,100,fwdfile))
          { if(strchr(b->line, ' '))
              length=atol(strchr(b->line, ' ')+1);
            else
              length=0L;

            if(b->bytes < length && !entrywritten)
            { fprintf(fwdnewfile,"%s/%s %ld%s\n",b->boardname,b->mailfname,
                                                 b->bytes,ds);
              entrywritten=1;
            }

            fputs(b->line, fwdnewfile);
            waitfor(e_ticsfull);
          }

          if(!entrywritten)
            fprintf(fwdnewfile,"%s/%s %ld%s\n",b->boardname,b->mailfname,
                                               b->bytes,ds);

          s_fclose(fwdnewfile);
          s_fclose(fwdfile);
          xunlink(fwdfname);
          xrename(fwdfnametmp, fwdfname);
        }
        else
*/        
        { fwdfile=s_fopen(fwdfname,"sat");
          if(!fwdfile)                // wenn es nicht gegangen ist, ist evtl.
          { mkdir(FWDPATH);           // das Directory noch gar nicht angelegt
            fwdfile=s_fopen(fwdfname,"sat");
          }
          if(fwdfile)
          { fprintf(fwdfile,"%s/%s %ld%s\n",b->boardname,b->mailfname,
                                            b->bytes,ds);
            s_fclose(fwdfile);
#ifdef _EXDLOGIN	//db1ras
	    trace(report,"mbfwd","%s: bulletin %s", boxcall, b->boardname);
#endif
          }
          else
            trace(serious,"add_fwd","fopen %s errno=%d",fwdfname,errno);
          waitfor(e_reschedule);
          if(    //   !delaytime &&
            isforwardtime(boxcall,!b->usermail)==2 && !(fp[box].options&o_d))
            fork(P_BACK|P_MAIL,0,fwdsend,boxcall);
        }
      }
    }
  }
}

/*---------------------------------------------------------------------------*/

void trigger_ufwd(char *call)
{ if(get_ufwd(call)[0] && scan_userfile(call,1))
    fork(P_BACK|P_MAIL,0,fwdsend,call);
}

/*---------------------------------------------------------------------------*/

static int testfwd(char *call,int bulletin)
{ char fname[FNAMELEN+1];

  wdelay(1861);
  if(isforwardtime(call,bulletin))
  { switch(bulletin)
    { case 0:
	strcpy(fname,FWDPATH"/u_");
	break;
      case 1:
	strcpy(fname,FWDPATH"/i_");
	break;
      case 2:
	strcpy(fname,FWDPATH"/m_");
	break;
      case 3:
	goto dofwd;
    }
    strcat(fname,call);
    strcat(fname,".bcm");
    strlwr(fname);

    if(filetime(fname))
    { dofwd:
      fork(P_BACK|P_MAIL,0,fwdsend,call);
      wdelay(15012);                        // erst nach 15s nchste Box
      return 1;
    }
  }
  return 0;
}

/*---------------------------------------------------------------------------*/

void startfwd(char *) // char *??? TODO (DH3MB)
{ int i=0;
  if(sema_lock("forward")==0)
  { trace(report,"startfwd","sema was set");
    return;
  }
  while(fp[i].call[0])
  { trace(report,"startfwd","starting %s",fp[i].call);
    testfwd(fp[i].call,0);    // Usermails?
    testfwd(fp[i].call,1);    // Bulletins?
    testfwd(fp[i].call,2);    // E/M-Files?
    testfwd(fp[i].call,3);    // Pollen?
    i++;
  }
}

/*---------------------------------------------------------------------------*/
