/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ----------------------------------------
  Zeichen Ein- Ausgabe fr TNC und Fenster
  ----------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980307 OE3DZW bugfix: inputline_file stopped on 0x00 0x00
//19980404 hrx    tty: putv(), case io_tty: extension for fwding via tty
//19980614 hrx    added paclen extensions to void putv(int c), and void
//                bputv(int c) Binary (transparent) putv (OE3DZW)
//19990612 hpk    fixed bug in _PACLEN, did not work in DOS Version
//19990817 OE3DZW added JJ code

#include "baycom.h"

/*---------------------------------------------------------------------------*/

int janein(char *prompt)
{ char s[5];
  char *yes;
  putf(ms(m_yesnoquestion),prompt);
  getline(s,4,1);
  putf("\n");
  strupr(s);

  if((yes = strchr(ms(m_yesnoquestion),'(')) != NULL && *yes != 0)
    yes++;
  else
    yes = NULL;

  if((s[0]=='Y') || (s[0]=='J') || (s[0]=='O') || (yes != NULL && s[0]==*yes))
    return JA;
  if(s[0]=='N')
    return NEIN;
  else
    return JEIN;
}

/*---------------------------------------------------------------------------*/

void putf(char *format, ...)
{ va_list argpoint;
  char cbuf[260];
  char *s=cbuf;

  va_start(argpoint,format);
  vsprintf(cbuf,format,argpoint);
  va_end(argpoint);
  if(strlen(s)>257)
  { s[50]=0;
    trace(tr_abbruch,"putf","long %s",s);
  }
  while(*s)
    putv(*(s++));
}

/*---------------------------------------------------------------------------*/

int testabbruch(void)
{ waitfor(e_ticsfull);
  if(b)
  { if((getvalid()==CR) && (!b->abbruch))
      b->abbruch++;
    if(b->abbruch==1)
    { putf(ms(m_aborted));
      b->abbruch++;
    }
    return b->abbruch;
  }
  else
    return 0;
}

/*---------------------------------------------------------------------------*/

static void near mon(int c,bitfeld opt)
{ monbuf_t *mm=t->monitor;
  if(b)
  { switch(b->job)
    { case j_fwdrecvf:
      case j_send:   if(mm->opt&o_s) return; break;
      case j_fwdsendf:
      case j_read:   if(mm->opt&o_r) return; break;
      case j_search: if(mm->opt&o_d) return; break;
    }
  }
  if(!(mm->opt&opt))
  { int congestion_count=0;
    while(t->monitor && ((mm->in+1)%MONBUFLEN)==mm->out)
    { if((congestion_count++)>20)
      { mm->congested=1;
        break;
      }
      wdelay(282);
    }
    if(t->monitor==NULL)
      return;
    mm->buf[mm->in++]=c;
    if(mm->in>=MONBUFLEN)
      mm->in=0;
  }
}

/*---------------------------------------------------------------------------*/

void putv(int c)
{ if(c=='\r')
    return;

  if(t->monitor)
    mon(c,o_o);

  if(c=='\n')
  { if(b && u)
    { if(u->zeilen && !b->continous && ((++b->linecount)>=(u->zeilen)))
      { char line[4];
        putf("+?>");
        getline(line,3,1);
        b->linecount=0;
        switch(toupper(line[0]))
	{
        case 'C':
          b->continous=1;
          break;

        case 'Q':
        case 'B':
          b->abbruch++;
          b->quit=1;

        case ' ': // DG4MMI
        case 0:
          break;

        default:
          b->abbruch++;
          break;
	}
      }
      else
      { if((getvalid()==CR) && (!b->abbruch))
	  b->abbruch++;
      }
    }
  }

  if(b && b->http==2)
  { switch(c)
    { // Conversion IBM -> HTML
      case '>': putf("&gt;"); return;
      case '<': putf("&lt;"); return;
      case 0x84: putf("&auml;"); return;
      case 0x94: putf("&ouml;"); return;
      case 0x81: putf("&uuml;"); return;
      case 0x8e: putf("&Auml;"); return;
      case 0x99: putf("&Ouml;"); return;
      case 0x9a: putf("&Uuml;"); return;
      case 0xe1: putf("&szlig;"); return;
    }
  }

  switch(t->output)
  {
  case io_window:
    putvo_win(c);
    break;

  case io_tnc:
    if(c=='\n')
      c='\r';
    putv_tnc(c);
#ifdef _PACLEN
/*   if(u->paclen>0 && ++b->pacbytes == u->paclen) */
     if(u->paclen>0 && (b->txbytes%u->paclen==0)) // hpk
      putflush();
#endif
    break;

  case io_socket:
    if(c=='\n')
      putv_sock('\r');
    putv_sock(c);
    break;

  case io_tty:
#ifdef _TTY                // JJ
    if(c=='\n')            // JJ
        putv_tty('\r');    // JJ
#endif                     // JJ
    putv_tty(c);           // JJ
    break;                 // JJ

  case io_file:
    if(b)
      fputc(c,b->outputfile);
    break;

  case io_memory:
    if(b && b->outbuffer)
    { b->outbuffer[b->outbindex++]=c;
      if(b->outbindex==b->outbmax)
        longjmp(b->io_mem_jmp,2);
    }
    break;
  }

#ifdef _UTIMEOUT	//db1ras
    if (t->timeout && b && b->txbytes%1024==0)
      t->last_output=ad_time();
#endif

  if(b)
    b->txbytes++;
}

/*---------------------------------------------------------------------------*/

void bputv(int c) // Binary (transparent) putv (OE3DZW)
{ 

 if (t->monitor)
   mon(c,o_o);

 switch(t->output)
  {
  case io_window:
    putvo_win(c);
    break;

  case io_tnc:
    putv_tnc(c);
#ifdef _PACLEN
/*   if(u->paclen>0 && ++b->pacbytes == u->paclen) */
     if(u->paclen>0 && (b->txbytes%u->paclen==0)) // hpk
      putflush();
#endif
    break;

  case io_socket:
    putv_sock(c);
    break;

  case io_tty:
    putv_tty(c);
    break;

  case io_file:
    if(b)
      fputc(c,b->outputfile);
    break;

  case io_memory:
    if(b && b->outbuffer)
    { b->outbuffer[b->outbindex++]=c;
      if(b->outbindex==b->outbmax)
        longjmp(b->io_mem_jmp,2);
    }
    break;
  }

#ifdef _UTIMEOUT	//db1ras
  if(t->timeout && b && b->txbytes%1024==0)
    t->last_output=ad_time();
#endif

  if(b)
    b->txbytes++;
}

/*---------------------------------------------------------------------------*/

int getvalid(void)
{ switch(t->input)
  {
  case io_window:
    return taskkbhit();

  case io_tnc:
    return getvalid_tnc();

  case io_socket:
    return getvalid_sock();

  case io_tty:
    return getvalid_tty();

  case io_file:
  case io_dummy:
  case io_memory:
    return 1;
  }

  return 0;
}

/*---------------------------------------------------------------------------*/

int getv(void)
{ int c=0;

  switch(t->input)
  {
  case io_window:
    c=waitkey()&255;
    break;

  case io_tnc:
    c=getv_tnc();
    break;

  case io_socket:
    c=getv_sock();
    break;

  case io_tty:
    c=getv_tty();
    break;

  case io_file:
    c=fgetc(b->inputfile);
    break;

  case io_memory:
    if(b && b->inbuffer)
    { if(b->inbindex<b->inbmax)
        c=b->inbuffer[b->inbindex++];
      else if(b->inbindex==b->inbmax)
      { c='\n';
        b->inbindex++;
      }
      else
        longjmp(b->io_mem_jmp,1);
    }
    break;
  }

  if(t->monitor)
    mon(c,o_i);

#ifdef _UTIMEOUT	//db1ras
  if (t->timeout && b && b->rxbytes%1024==0)
    t->last_input=ad_time();
#endif

  if(b)
    b->rxbytes++;

  return c;
}

/*---------------------------------------------------------------------------*/

int putfree(void)
{ switch(t->input)
  {
  case io_tnc:
    return putfree_tnc();

  case io_socket:
    return putfree_sock();

  case io_tty:
    return putfree_tty();

  case io_file:
  case io_memory:
  case io_window:
    return 1;
  }

  return 0;
}

/*---------------------------------------------------------------------------*/

void putflush(void)
{ switch(t->input)
  {
  case io_window:
    putflush_win();
    break;

  case io_tnc:
    putflush_tnc();
    break;

  case io_socket:
    putflush_sock();
    break;

  case io_tty:
    putflush_tty();
    break;

  case io_file:
  case io_memory:
    break;
  }
}

/*---------------------------------------------------------------------------*/

static void near inputline_mem(char *s,int maxlen,char cut)
{ int i=0;
  int c;

  s[0]=0;
  if(t->input==io_memory && b)
  { if(maxlen<0)
      maxlen=(-maxlen);

    while(i<maxlen)
    { c=getv();
      s[i++]=c;
      s[i]=0;
      if(c=='\n')
      { if(cut)
          s[i-1]=0;
        break;
      }
    }

  }
}

/*---------------------------------------------------------------------------*/

static char near inputline_file(char *s, int maxlen, char cut)
{ unsigned long int prepos;

  s[0]=0;
  if(t->input==io_file && b && b->inputfile)
  { if(maxlen<0)
      maxlen=(-maxlen);

    prepos=ftell(b->inputfile);

    do
    { if(!fgets(s, maxlen, b->inputfile))
      { s_fclose(b->inputfile);
        b->inputfile=NULL;
        t->input=(io_t)b->oldinput;
        return(0);
      }
    waitfor(e_ticsfull);
    }
    while(strlen(s)==0);
 
    if(cut)
    { if(s[strlen(s)-1]=='\n')
        s[strlen(s)-1]=0;
    }
    else
    { if(s[strlen(s)-1]!='\n')                         // Move to the position
        fseek(b->inputfile,prepos+strlen(s),SEEK_SET); // after last read byte
    }

    // DG4MMI Removed check for "impdel" (this now is a mailbox-command) and
    // "end" (is not needed any more), so this function now is completely
    // transparent

    return(1);
  }
  else
    return(0);
}

/*---------------------------------------------------------------------------*/

char getline(char *s,int maxlen,char cut)
//*************************************************************************
//
//  Gets one line with at most maxlen characters from the current input
//  (t->input)
//
//  If cut==1, the line will be cut if there are more than maxlen
//  characters and the final '\n' is not added to the returned string
//  If cut==0 the function will return after having read maxlen bytes or
//  a '\n' (DG4MMI)
//
//  If maxlen<0, there may be more commands stated in one line
//  seperated by semicolons (";"). Note that the seperation with ";"s
//  will not work on io_file, io_win and io_mem, and not if cut==0
//
//  Returns 0, if(t->input==io_file && feof(b->inputfile)), 1 otherwise
//
//*************************************************************************
{ char retval=1;

  if(b)
    b->linecount=b->abbruch=0;
  t_unlock(1);

  switch(t->input)
  {
  case io_window:
    inputline_win(s,maxlen,cut);
    break;

  case io_tnc:
    inputline_tnc(s,maxlen,cut);
    break;

  case io_socket:
    inputline_sock(s,maxlen,cut);
    break;

  case io_tty:
    inputline_tty(s,maxlen,cut);
    break;

  case io_file:
    retval=inputline_file(s,maxlen,cut);
    break;

  case io_memory:
    inputline_mem(s,maxlen,cut);
    break;

  case io_dummy:
    if(t->output==io_file)
    { s_fclose(b->outputfile);
      b->outputfile=NULL;
      t->input=(io_t)b->oldinput;
      t->output=(io_t)b->oldoutput;
    }
    s[0]=0; // return empty line
    break;
  }

  if(b)
    b->rxbytes+=strlen(s)+1;

  t->last_input=ad_time();

  if(t->monitor)
  { int i=0;
    while(s[i])
      mon(s[i++],o_i);
    mon('\n',o_i);
  }

  return(retval);
}

/*---------------------------------------------------------------------------*/
