/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------------
  Schnittstelle Mailbox / Benutzeroberflaeche
  -------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980226 hrx    new: taskwindow - to be called with twin (sysopcommand).
//                like the standard uwin, outfit is like ps -ru.
//19980408 hrx    taskwin has been changed, replaced old with new.
//                added trcwin()
//19980526 OE3DZW Flat-batch only when file exists
//19980608 OE3DZW added support for user-fwd at getlogin - not in _TTY
//19981001 OE3DZW removed filename at genmail
//19990206 OE3DZW genmail will only generate mails if boxheader is set
//19990621 OE3DZW import blocked during sendlock (fixed)
//19991201 DB1RAS added _EXT_WATCHDOG in runbat()

#include "baycom.h"

static int einrueck=1;

/*---------------------------------------------------------------------------*/

void userwin(char *name)
{ int keysave=keywindow();
  int width;

//  e->x=bildspalten-19;
//  e->xend=bildspalten-1;
//  e->y=0;
//  e->yend=8;

  e->x=0;
  e->xend=29;
  e->y=2;
  e->yend=bildzeilen/3;

  preparewin(putupdate,name,400);
  newkeywin=keysave;
  while(!runterfahren)
  { wdelay(534);
    e->index=e->modified=e->curline=0;
    width=(e->xlen-1)/9;
    if(!width)width=1;
    listusers(2+width);
    e->shouldupdate++;
  }
  wclose();
}

/*---------------------------------------------------------------------------*/

void taskwin(char *befbuf)                                                  
{ int keysave=keywindow();                                                  
                                                                            
  e->x=0;                                                                   
  e->xend=79;                                                               
  e->y=3;                                                                   
  e->yend=bildzeilen/3;                                                     
                                                                            
  scanoptions(befbuf);                                                      
  strcpy(t->name,"Tasks");                                                  
                                                                            
  preparewin(putupdate,"Tasks",2000);                                       
  newkeywin=keysave;                                                        
  while(!runterfahren)                                                      
  { wdelay(492);                                                            
    e->index=e->modified=e->curline=0;                                      
    putf("\n");                                                             
    listprocess(b->optplus);                                                
    e->shouldupdate++;                                                      
  }                                                                         
  wclose();                                                                 
}                                                                           

/*---------------------------------------------------------------------------*/

#ifdef HRX_OPT
void trcwin(char *befbuf)                                                   
{ int keysave=keywindow();                                                  
  char *name=0;                                                             
                                                                            
  e->x=0;                                                                   
  e->xend=79;                                                               
  e->y=9;                                                                   
  e->yend=35;                                                               
                                                                            
  scanoptions(befbuf);                                                      
  b->continous=1;                                                           
  sprintf(name,"Trace: Task %s",befbuf);                                    
  strcpy(t->name,"Trace");                                                  
                                                                            
  preparewin(putupdate,name,2000);                                          
  newkeywin=keysave;                                                        
  e->index=e->modified=e->curline=0;                                        
  putf("\n");                                                               
  monitor(atoi(befbuf),b->optplus);                                         
  e->shouldupdate++;                                                        
  wdelay(4234);                                                             
  wclose();                                                                 
}                                                                           
#endif

/*---------------------------------------------------------------------------*/

void mbwin2(char *name)
{ char call[10];
  char mycall[10];
  name=nexttoken(name,call,9);
  nexttoken(name,mycall,9);
#ifdef _LCF                                  // JJ
  if(!fwdcallok(call,m.logincallformat))     // JJ
    strcpy(call,m.sysopcall);                // JJ
#else                                        // JJ
  if(!mbcallok(call))
    strcpy(call,m.sysopcall);
#endif                                       // JJ
  e->x=einrueck;
  e->xend=bildspalten-1;
  e->y=bildzeilen/3+einrueck;
  e->yend=bildzeilen-1;
  einrueck++;
  preparewin(putupdate,call,3000);
  putf("\n");
  mbmain(call,"Console",mycall);
  wclose();
  t_free(buf);
  buf=0;
  einrueck--;
}

/*---------------------------------------------------------------------------*/

#if NODE
void n_win2(char *name)
{ char call[10];

  strcpy(call,name);
  e->x=einrueck;
  e->xend=bildspalten-1;
  e->y=bildzeilen/3+einrueck;
  e->yend=bildzeilen-1;
  einrueck++;
  preparewin(putupdate,name,3000);
  putf("\n");
  n_main(call,"Console");
  wclose();
  t_free(buf);
  buf=0;
  einrueck--;
}
#endif

/*---------------------------------------------------------------------------*/

#ifdef _TTY                                              
//warning *-option (fwd) not supported here!

#define conlogintext   "ctextcon"
#define ttylogintext   "ctexttty"

int getlogin(char *s,int withpw,char *source)
{ char pwstr[10];
  char userpw[10];
  int count=0;
  int tty=0;

  lastcmd("wait for login");
  tty=(strcmp(source,"TTY")==0);

  if (tty)
   { ttysetecho(1);
     putv(12);
   }

  if (m.callformat)                                                 
  putf("\n\nBayCom-Mailbox V"VNUMMER" ("OPSYSTEM") "CBMODEID"\n");
   else                                                            
  putf("\n\nBayCom-Mailbox V"VNUMMER" ("OPSYSTEM")\n");

  if(tty) readtext(ttylogintext);
  if(t->name=="Sysop") readtext(conlogintext);

  while(count<3)
  { ttysetecho(1);
    putf("\nlogin: ");
    s[0]=0;
    getline(s,20,1);

    if(strcmp(s,"NO CARRIER")==0)
     return 0;
    strupr(s);

    if(strcmp(s,".")==0)
    { strcpy(s,m.sysopcall);
    }

    if(strcmp(s,"gast")==0)
    { strcpy(s,m.guestcall);
    }

#ifdef _LCF                             // JJ
    if(fwdcallok(s,m.logincallformat))  // JJ
#else                                   // JJ
    if(mbcallok(s))
#endif                                  // JJ
    { if(withpw && !(strcmp(s,m.guestcall)==0))
      { get_ttypw(s,userpw);
	if(!userpw[0] && tty)
          putf("\nsorry, tty-password is not set.\n");
	else
	{ putf("\npassword: ");
	  ttysetecho(2);
	  getline(pwstr,9,1);
          if (strcmp(pwstr,"NO CARRIER")==0) return 0;
	  ttysetecho(1);
	  if(userpw[0] && strcmp(pwstr,userpw)==0)
	    break;
	  else
            pwlog(s,source,"tty login failure.");
	}
      }
      else
	break;
    }
    if(s[0])
      count++;
      putf("\nlogin incorrect");
      if (tty) putf(" - %i tries left.\n",3-count);
    if(count>=3)
    { putf("\ngood bye.\n");
      wdelay(534);
      return 0;
    }
  }
  putf("\n");
  return 1;
}

#else

int getlogin(char *s,int withpw,char *source)
{ char pwstr[10];
  char userpw[10];
  char inputline[10];
  int tty_fwd=0;
  int count=0;
  int i;
  FILE* f;

  f = s_fopen(ISSUENAME,"srt");
  if (f)
  { i = fgetc(f);
    while (i!=EOF)
    { putf("%c",i);
      i=fgetc(f);
    }    
    s_fclose(f);
  } 


  if (m.callformat)                                                  
  putf("\n\nBayCom-Mailbox V"VNUMMER" ("OPSYSTEM") ("CBMODEID")\n"); 
   else                                                             
  putf("\n\nBayCom-Mailbox V"VNUMMER" ("OPSYSTEM")\n");

  while(count<3)
  { putf("\n%s login: ",m.boxname);
    inputline[0]=0;
    inputline[1]=0;
    getline(inputline,8,1);
    strupr(inputline);
    tty_fwd=(inputline[0]=='*');
    strcpy(s,inputline+tty_fwd);                
    if((s[0]=='.') && !withpw)
    { strcpy(s,m.sysopcall);
      break;
    }
#ifdef _LCF                               // JJ
    if(fwdcallok(s,m.logincallformat))    // JJ
#else                                     // JJ
    if(mbcallok(s))
#endif                                    // JJ
    { if(withpw)
      { putf("password: ");
	ttysetecho(0);
	getline(pwstr,9,1);
	ttysetecho(1);
	get_ttypw(s,userpw);
	if(userpw[0] && strcmp(pwstr,userpw)==0)
	  break;
        else
          pwlog(s,source,"tty login failure");
      }
      else break;
    }
    if(s[0])
      putf("\nlogin incorrect.\n");
    count++;
    if(count>=3)
    { putf("\nsorry.\n\n");
      wdelay(534);
      return 0;
    }
  }
  putf("\n\n");
  return 1+tty_fwd;
}
#endif

/*---------------------------------------------------------------------------*/

void doodle(int soundnum)
{ int i;

  if(!m.sysopbell)
    return;

  switch(soundnum)
  { case 0:
    { for(i=0;i<3;i++)
      { delay(2);
	nosound();
        sound(800);
        delay(20);
        sound(1100);
        delay(15);
        sound(1700);
        delay(10);
        nosound();
      }
    } break;
    case 1:
    { sound(800);
      delay(50);
      nosound();
      delay(50);
      sound(1100);
      delay(50);
      nosound();
      delay(50);
      sound(1700);
      delay(50);
      nosound();
      delay(100);
    } break;
    case 2:
    { sound(2000);
      delay(50);
      nosound();
      delay(50);
      sound(2000);
      delay(50);
      nosound();
      delay(100);
    } break;
    case 3:
    { sound(2000);
      delay(50);
      nosound();
      delay(50);
      sound(1100);
      delay(50);
      nosound();
      delay(100);
    } break;
  }
}

/*---------------------------------------------------------------------------*/

void mbwindow(char *name)
{ char s[10];

  e->x=0;
  e->xend=bildspalten-1;
  e->y=bildzeilen/3;
  e->yend=bildzeilen-1;
  preparewin(putupdate,name,60*bildzeilen);
  putf("\n");

  mbmainbegin();
#if NODE
  n_mainbegin();
#endif
  init_tty();

  while(!runterfahren)
  { getlogin(s,0,"Console");
    mbmain(s,"Console","");
    b->quit=0;
  }
  wclose();
}

/*---------------------------------------------------------------------------*/

void boxusertask(char *usercall)
{ char call[7];
  char uplink[10];
#ifdef HRX_OPT
  char downlink[10]; // hrx
#endif
  int i=0;
  char mycall[10];

  getclear_tnc();
  while(isalnum(usercall[0]) && (i<6))
  { call[i++]=usercall[0];
    usercall++;
  }
  call[i]=0;
  while(usercall[0] && (usercall[0]<'A'))
    usercall++;
  i=0;
  while((usercall[0]>' ') && (i<9))
  { uplink[i++]=usercall[0];
    usercall++;
  }
  uplink[i]=0;

#ifdef HRX_OPT
  usercall++;                       
  i=0;                              
  while((usercall[0]>' ') && (i<9)) 
  { downlink[i++]=usercall[0];    
    usercall++;                    
  }                               
  downlink[i]=0;                   
  strcpy(t->downlink,downlink);    
#endif

  doodle(1);
  strcpy(t->name,call);

  getmycall_tnc(mycall);

  mbmain(call,uplink,mycall);
  if (b->quit==2) //when "bye" do not wait
  { //trace(report,"boxusertask","fast logout");
    mbdisconnect(0);
  }
  else
  { //trace(report,"boxusertask","slow logout");
    mbdisconnect(1);
  } 
  getclear_tnc();
  doodle(2);
}

/*---------------------------------------------------------------------------*/

void mbimport(char *filename)
{ 
  t->output=io_dummy;
  b->oldinput=io_dummy;

  b->inputfile=s_fopen(filename,"lrt");
  if(b->inputfile)
  { t->input=io_file;
    while (sema_test("sendlock"))
    { lastcmd("wait sendlock");
      wdelay(30130);    
    }
     mbmain(m.boxname,"Import","");
  }
}

/*---------------------------------------------------------------------------*/

void genmail(char *sendline,char *content)
{ char tmpname[30];
  FILE *f;

  //do not generate automatic mails if Boxheader is 
  //standard header. Test-BCM's should be silent ;-)
  if (strcmp(m.boxheader,STD_BOXHEADER)==0)
    return;

  sprintf(tmpname,TEMPPATH"/%s",time2filename(0));
  strcat(tmpname,".imp");
  strlwr(tmpname);
  f=s_fopen(tmpname,"swt");
  if(f)
  { s_fsetopt(f,1);
    fprintf(f,"%s\n",sendline);
    fprintf(f,"%s\nnnnn\nimpdel\n",content);
    s_fclose(f);
    fork(P_BACK|P_MAIL,0,mbimport,tmpname);
  }
  else
    trace(serious,"genmail","fopen %s errno=%d",tmpname,errno);
}

/*---------------------------------------------------------------------------*/

void runbatch(char *batch)
{ char cpy[FNAMELEN+1];

  snprintf(cpy,sizeof(cpy),"%s.bat",batch);
#ifdef __MSDOS__
  if(filetime(cpy))
  { trace(report,"runbatch",cpy);
    set_watchdog(2);

#ifdef _EXT_WATCHDOG	//db1ras
  if (strcmp(m.dosbefore,"OFF"))
  {
    char dosbefore[120];
    sprintf(dosbefore,"%s >nul",m.dosbefore);
    system(dosbefore);
  }
#endif

    sprintf(cpy,"%s.err",batch);
    freopen(cpy,"wt",stderr);
#ifndef _COMMANDCOM_FIX		//db1ras
    sprintf(cpy,"command /c %s > %s.out",batch,batch);
#else
    sprintf(cpy,"%s > %s.out",batch,batch);
#endif
    system(cpy);
    freopen("con","wt",stderr);

#ifdef _EXT_WATCHDOG	//db1ras
  if (strcmp(m.dosafter,"OFF"))
  {
    char dosafter[120];
    sprintf(dosafter,"%s >nul",m.dosafter);
    system(dosafter);
  }
#endif

    set_watchdog(1);
  }
#else 
  if (filetime(cpy))
    oshell(cpy,sh_noinput);
#endif
  sprintf(cpy,"%s.imp",batch);
  if(filetime(cpy))
    fork(P_BACK|P_MAIL,0,mbimport,cpy);
}

/*---------------------------------------------------------------------------*/
