/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ---------------------------
  Alles beim Login und Logout
  ---------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980121 OE3DZW Added Logbook for http-access
//19980124 OE3DZW Removed Logbook for 0 bytes RX (=http-access),
//                it added Flexnet-link-checks...
//19980202 OE3DZW added support for CB (callformat)
//19980329 OE3DZW added log for http again
//19980404 hrx    support for tty-fwding
//19980404 hrx    support for guests
//19980408 hrx    added autotrcwin conditional
//19980408 OE3DZW fixed notvisible, string could become too long
//19980416 hrx    added asklogin(). added condition for asklogin()
//                to be called in mblogin()
//19980830 OE3DZW removed check for m.userpw at login
//19980830 OE3DZW corrected flag for pop/smtp login (was sysop before)
//19980914 OE3DZW guest are never sysop, mblogin
//19990206 OE3DZW added fspath at login
//19990423 OE3DZW fixed mblogout, caused watchdog-reset at db0aab
//19990621 OE3DZW fixed log command for 9axxx (call starting with number)
//19990721 hpk    a new user becomes paclen which is defined in init.bcm
//                at line defpaclen <value>. example: defpaclen 80
//                for disable 0
//19990723 hpk    new users will become as readlock defrea which is defined 
//                in init.bcm at defrea <value>. example: defrea 2    
//                for disable 0 -> readlock works how ever
//19991023 hpk    extended login for guests see documentation
//                mybbs will be updated every month in CB-BCMNET version

#include "baycom.h"

static char *logkopf =
"Call   Date     Start End   TxBytes RxBytes CPUsec F TXFi RXFi  via\n";

/*---------------------------------------------------------------------------*/

//*************************************************************************
//
//  Statistik (nicht fertig)
//
//*************************************************************************
#if 0
#define TAGE 7
typedef struct loginstat
  {
    unsigned userlogins[TAGE];
    unsigned fwdlogins[TAGE];
    char logins[TAGE][48];
    long usertx[TAGE];
    long userrx[TAGE];
    long fwdtx[TAGE];
    long fwdrx[TAGE];
  }
loginstat;

loginstat ls;

void
putstatus (void)
{
  int tag, avlogins;
  for (tag = 0; tag < TAGE; tag++)
    {
      int j;
      avlogins = 0;
      for (j = 0; j < 48; j++)
	avlogins += logins[tag][j];
      avlogins /= 48;
      if (!tag)
	putf ("Userlogins ");
      putf ("%4u", ls.userlogins[tag]);
      if (!tag)
	putf ("FWDlogins  ");
      putf ("%4u", ls.fwdlogins[tag]);
      if (!tag)
	putf ("AverageLog ");
      putf ("%4u", avlogins);
      if (!tag)
	putf ("FwdTXkB    ");
      putf ("%4u", ls.fwdtx[tag] / 1000);
      if (!tag)
	putf ("FwdRXkB    ");
      putf ("%4u", ls.fwdrx[tag] / 1000);
      if (!tag)
	putf ("UserTXkB   ");
      putf ("%4u", ls.usertx[tag] / 1000);
      if (!tag)
	putf ("UserRXkB   ");
      putf ("%4u", ls.userrx[tag] / 1000);
    }
}
#endif

/*---------------------------------------------------------------------------*/

static char *
msgpath (char *name, char *land)
//*************************************************************************
//
//  Setzt einen Filepfad fuer ein Sprachabhaengiges Textfile zusammen
//
//*************************************************************************
{
  static char buf[20];

  strcpy (buf, MSGPATH "/");
  strcat (buf, name);
  strcat (buf, ".");
  strcat (buf, land);
  strlwr (buf);
  return buf;
}

/*---------------------------------------------------------------------------*/

int
readtext (char *text)
//*************************************************************************
//
//  Gibt einen Text abhaengig von der Landessprache aus
//
//*************************************************************************
{
  char buf[50];
  int a, last = 0;
  char *msg;
  int prozent = 0;
  FILE *f;

  f = s_fopen (msgpath (text, ms (m_helpext)), "lrt");
  if (!f)
    f = s_fopen (msgpath (text, "GB"), "lrt");
  if (!f)
    f = s_fopen (msgpath (text, "DL"), "lrt");
  if (f)
    {
      while ((a = fgetc (f)) != EOF)
	{
	  last = a;

	  if (prozent)
	    {
	      msg = chartomakro (a, buf);
	      putf ("%s", msg);
	      prozent = 0;
	    }
	  else if (a == '%')
	    prozent = 1;
	  else
	    putv (a);
	}
      if (last != '\n')
	putv ('\n');
      s_fclose (f);
      return 1;
    }
  return 0;
}

/*---------------------------------------------------------------------------*/

static void near
logbuch (void)
//*************************************************************************
//
//  Schreibt einen Eintrag ins Logbuch
//
//*************************************************************************
{
  FILE *logf;
  char logname[20];
  //char dat[10];
  char flag = ' ';
  time_t ti = ad_time ();

  if (u->lastquit > (ti - 8))
    flag = 'Q';
  if (b->forwarding == fwd_standard)
    flag = 'F';
  if (b->forwarding == fwd_user)
    flag = 'U';
  if (strcmp (b->uplink, "SMTP") == 0)
    flag = 'E';
  if (strcmp (b->uplink, "POP3") == 0)
    flag = 'P';
  if (strcmp (b->uplink, "TCP/IP") == 0)	//telnet

    flag = 'T';
  if (strcmp (b->uplink, "HTTP") == 0)
    flag = 'H';
  if (b->sysop && flag != 'E' && flag != 'P')
    flag = 'S';

  if (t->cputics > 30000L)	// Falls durch Uhrzeitaenderung Mist drin

    t->cputics = 100;		// steht, hier eine Kruecke damit im Log kein
  // zu grosser Unsinn auftaucht

  if (b->rxbytes > 1)
    {				//strftime(dat,sizeof(dat),"%y%m%d",localtime(&ti));
      //sprintf(logname,LOGPATH"/log%s.bcm",dat+1);

      struct tm *tt = ad_comtime (ti);
      snprintf (logname, 19, LOGPATH "/log%d%02d%02d.bcm",
		tt->tm_year % 10, tt->tm_mon + 1, tt->tm_mday);

      logf = s_fopen (logname, "sat");
      if (logf)
	{
	  fseek (logf, 0, SEEK_END);
	  if (ftell (logf) == 0)
	    fprintf (logf, logkopf);
	  fprintf (logf, "%-6.6s %s %s-",
		   b->logincall, datestr (b->logintime, 1),
		   timestr (b->logintime, 0));
	  fprintf (logf, "%s%8lu%8lu",
		   timestr (ad_time (), 0), b->txbytes, b->rxbytes);
	  fprintf (logf, "%7s", zeitspanne (t->cputics, zs_cpuexact));
	  fprintf (logf, " %c%5u%5u", flag, b->readfiles, b->sentfiles);
	  if (b->uplink[0])
	    {			//fprintf(logf,"  via %s",b->uplink);

	      if (b->peerip[0])
		fprintf (logf, " %s", b->peerip);
	      else
		fprintf (logf, "  via %s", b->uplink);
	    }
	  fprintf (logf, "\n");
	  s_fclose (logf);
	}
    }
}

/*---------------------------------------------------------------------------*/

#define LOGLEN 20

void
putlogauszug (char *selektor)
//*************************************************************************
//
//  Gibt einen Logbuchauszug aus. Suchbegriffe und Optionen werden
//  verarbeitet.
//
//*************************************************************************
{
  char s[100];
  FILE *f;
  char logname[20];
  //char dat[10];
  time_t logtime = ad_time ();
  char *suche;
  char *logarr = (char *) t_malloc ((LOGLEN + 1) * 80, "putl");
  int pmin = 0, pmax = 0;
  int i;
  int tage = 1;
  long newestlog;
  long anzahl = 0;

  selektor += blkill (selektor);
  suche = selektor;
  strupr (suche);
  if (!mbcallok(selektor) && isdigit (selektor[0]))
    {
      suche = blankweg (selektor);
      logtime = parse_time (selektor);
    }

  if (b->optplus & o_w)
    tage = 8;
  if (b->optplus & o_m)
    tage = 31;
  if (b->optplus & o_q)
    tage = 91;
  if (b->optplus & o_y)
    tage = 366;

  newestlog = logtime;
  logtime -= (3600L * 24 * (tage - 1));
  if (!(b->optplus & o_c))
    {
      putf (ms (m_logoutput));
      if (!(b->optplus & o_a))
	putf ("(max %d) ", LOGLEN);
      putf ("%s", datestr (logtime, 2));
      if (tage > 1)
	putf ("-%s", datestr (newestlog, 2));
      if (suche && suche[0])
	putf (" (\"%s\")", suche);
      putf (":\n%s", logkopf);
    }

  for (i = 0; i < tage; i++)
    {
      struct tm *tt = ad_comtime (logtime);
      sprintf (logname, LOGPATH "/log%d%02d%02d.bcm",
	       tt->tm_year % 10, tt->tm_mon + 1, tt->tm_mday);
      //strftime(dat,sizeof(dat),"%y%m%d",localtime(&logtime));
      //sprintf(logname,LOGPATH"/log%s.bcm",dat+1);

      f = s_fopen (logname, "lrt");
      if (f)
	{
	  fgets (s, 99, f);
	  while (fgets (s, 99, f))
	    {
	      if (!suche || strstr (s, suche))
		{
		  if ((s[51] != 'F') || (b->optplus & (o_f | o_g)))
		    {
		      if ((s[51] == 'S') || !(b->optplus & o_s))
			{
			  if ((s[51] == 'U') || !(b->optplus & o_u))
			    {
			      if ((s[51] == 'E') || !(b->optplus & o_e))
				{
				  if ((s[51] == 'T') || !(b->optplus & o_t))
				    {
				      if ((s[51] == 'P') || !(b->optplus & o_p))
					{
					  if ((s[51] == 'F') || !(b->optplus & o_g))
					    {
					      if (b->sysop || (strstr (s + 62, "TTY") == NULL))
						{
						  strcpy (logarr + pmax * 80, s);
						  if (b->optplus & o_a)
						    putf ("%s", s);
						  else
						    {
						      pmax = (pmax + 1) % (LOGLEN + 1);
						      if (pmin == pmax)
							pmin = (pmin + 1) % (LOGLEN + 1);
						    }
						  anzahl++;
						}
					    }
					}
				    }
				}
			    }
			}
		    }
		}
	      waitfor (e_ticsfull);
	      if (testabbruch ())
		break;
	    }
	  s_fclose (f);
	}
      logtime += (3600L * 24);	// einen Tag weiter

      if (testabbruch ())
	break;
    }
  if (!testabbruch ())
    {
      if (anzahl == 0)
	putf (ms (m_noentryfound));
      else
	{
	  if (!(b->optplus & o_c))
	    {
	      while (pmin != pmax)
		{
		  putf ("%s", logarr + pmin * 80);
		  pmin = (pmin + 1) % (LOGLEN + 1);
		}
	    }
	  if (anzahl > 1)
	    putf (ms (m_entriesfound), anzahl);
	  else
	    putf (ms (m_oneentryfound));
	}
    }
  t_free (logarr);
}

/*---------------------------------------------------------------------------*/

void
putaktuell (int immer)
//*************************************************************************
//
//  Gibt einen Aktuelltext mit Datum und Uhrzeit aus
//
//*************************************************************************
{
  time_t akttime = filetime (msgpath ("aktuell", u->sprache));
  if (!akttime)
    akttime = filetime (msgpath ("aktuell", "GB"));
  if (!akttime)
    akttime = filetime (msgpath ("aktuell", "DL"));

  if ((akttime > u->lastboxlogin) || immer)
    {
      if (akttime)
	{
	  putf (ms (m_actual), datestr (akttime, 2), timestr (akttime, 1));
	  readtext ("aktuell");
	}
      else
	putf (ms (m_noactual));
      if (!immer)
	leerzeile ();
    }
}

/*---------------------------------------------------------------------------*/
#ifdef _ASKLOGIN
//*************************************************************************
//
//  Generates a short query about the most important user settings.
//  Will be displayed during the first login or if any of the following
//  conditions is true: No username stored, no mybbs entered.
//
//*************************************************************************
void asklogin(char *logincall)
{ if(strcmp(b->uplink,"Import")!=0)  // JJ
  {                                  // JJ
  if (!u->name[0])
    {
      readtext ("cein");
      char x[64];
      putf ("\nNAME               :");
      getline (x, 32, 1);
      leerzeile ();
      mbalter("NAME", x, logincall);
      putf ("\n");
    }

  if (!u->mybbs[0])
    {
      char x1[64];
      putf ("HomeBBS            :");
      getline (x1, 32, 1);
      putf ("\n");
      mbalter ("MYBBS", x1, logincall);
      putf ("\n");
    }

  if (m.userquota && u->helplevel == 2)
    {
      char x1[10];
      putf (
	     "If you want to switch off the userquota (READ/SEND\nlimitation answer 'yes'. The system will send an automatically\ngenerated mail to the sysop informing him/her about your request. \nYes/No             :");
      getline (x1, 1, 1);
      strupr (x1);
      if (strcmp (x1, "Y") == 0)
	{
	  putf ("\n");
	  b->sysop = 1;
	  mbalter ("H", "1", logincall);
	  char sendcmd[100];
	  char content[255];
	  sprintf (sendcmd, "SP %s < SYSTEM NEW_USER: %s(%s)",
		   m.sysopcall, logincall, u->name);
	  sprintf (content, " \n\n\n CALL       : %s \n NAME       : %s \n HOMEBBS    : %s \n              No userquota.\n\n\n",
		   logincall, u->name, u->mybbs);
	  genmail (sendcmd, content);
	  b->sysop = 0;
	}
    }
  }
}
#endif
/*---------------------------------------------------------------------------*/

void
mblogin (char *logincall, loginmode_t lmode, char *uplink)
//*************************************************************************
//
//  Fuehrt einen ordentlichen Login aus. Bei einem Userlogin
//  wird CTEXT etc. gesendet und das erste Kommando ausgefuehrt.
//
//*************************************************************************
{
  char buf[80];
  char *semicolon, *bufptr;
  char i;

  if (b->logincall[0])
    mblogout (1);
  if (uplink[0] == 0)
    uplink = m.boxname;
  strupr (logincall);
  logincall[6] = 0;
  strcpy (b->logincall, logincall);
  strcpy (b->prompt, b->logincall);
  b->logintime = ad_time ();
  b->txbytes = 0;
#ifdef _PACLEN
  b->pacbytes = 0;
#endif
#ifdef __FLAT__
  if (strcmp (b->uplink, "HTTP"))
#endif
#ifdef FILESURF			// DG4MMI
    b->fspath[0] = 0;
#endif
  b->rxbytes = 0;
  b->sentfiles = b->readfiles = 0;
  b->privoffset = (-1);
  b->sysop = (islower (uplink[1]) && uplink[0]) || b->sysop;
  if (b->sysop)
    testdfull ();

  loaduser (logincall, u, 1);
  u->logins++;

  if (!is_msgkenner (u->sprache))
    strcpy (u->sprache, msg_landsuch (logincall));

  for (i = 0; i < 5; i++)
    tmpbidraus (i);

  b->lastdirnews = u->lastdirnews;
  switch (lmode)
    {
    case login_ufwd:
      b->forwarding = fwd_user;
      break;

    case login_fwd:
      b->forwarding = fwd_standard;
      break;

    case login_standard:
      b->forwarding = (fwdtype_t) (isforwardpartner (logincall) >= 0);
      break;

    case login_nofwd:
    default:
      b->forwarding = fwd_none;
      break;
    }
  if (b->forwarding == fwd_standard && isforwardpartner (logincall) < 0)
    b->forwarding = fwd_user;
  if (b->forwarding == fwd_user && isforwardpartner (logincall) >= 0)
    b->forwarding = fwd_standard;

  if (strcmp (uplink, "Import") == 0)
    b->forwarding = fwd_none;
  strcpy (b->uplink, uplink);
  strcpy (u->uplink, uplink);

#ifdef HRX_OPT
  if (m.autotrcwin
      && !strcmp (uplink, "Console") == 0
      && !strcmp (uplink, "Import") == 0      // JJ
      && (strlen (uplink) > 0
#ifdef _LCF                                                   // JJ
          || fwdcallok(logincall,m.logincallformat)))         // JJ
#else                                                         // JJ
          || mbcallok (logincall)))
#endif                                                        // JJ
    {
      char tids[2];
      sprintf (tids, "%i", gettaskid ());
      trace (report, "trcwin", "task %s", tids);
      fork (P_WIND | P_MAIL, 0, trcwin, tids);
    }
#endif

  if (b->forwarding == fwd_none) // PSE JJ DO NOT TOUCH
    {
      if (newdate (u->lastboxlogin, b->logintime) != 0)
	u->daybytes = 0;
      trace (report, "mblogin", "%s %s", logincall, uplink);
      if (!b->sysop && m.maxlogins && (eingelogt (logincall, 0) >= m.maxlogins)) 
      { b->logincall[0] = 0;                                                     
        trace(report,"mblogin","connect rejected - maxlogin");                  
        return;                                                                  
      }                                                                         
      if (u->status == 2 && !b->sysop)                                           
      { b->logincall[0] = 0;                                                   
        trace(report,"mblogin","connect rejected - status 2");                   
        return;                                                                 
      }                                                                         

#ifdef _UTIMEOUT	//db1ras
      timeout (m.usertimeout);
#endif

#ifdef HRX_OPT                   // JJ
    if (autosysop()) b->sysop=1; // JJ Autosysop
#endif                           // JJ
      if (lmode != login_silent)
	{
	  if (u->password[0] > 1 && u->loginpwtype <= 2 &&
	      !b->sysop && t->socket == 0
#ifdef _TTY
	      && !strcmp (b->uplink, "TTY") == 0
#endif
	    )
	    {
	      if (u->pwline)
		{
#ifdef _PWD_GPFIX	//db1ras
		  putf ("\n");
#endif
		  getline (buf, 79, 1);
		}
#ifdef _PWD_GPFIX	//db1ras	(Graphic Packet vertraegt kein
			//		RETURN vor dem Passwort)
	      else
#endif
	      putf ("\n");
	      char pwok = 1;
	      switch (u->loginpwtype)	// DG4MMI

		{
		case 0:
		  pwok = pwauswert (u->password);
		  break;
#ifdef FEATURE_MDPW
		case 1:
		  pwok = getMDpw (2, u->password);
		  break;
		case 2:
		  pwok = getMDpw (5, u->password);
		  break;
#endif
		default:
		  pwok = 1;
		}
	      if (!pwok)
		{
		  pwlog (b->logincall, b->uplink, "userpw failure");
		  b->logincall[0] = 0;
		  return;
		}
	    }

#ifdef _EXDLOGIN	//db1ras
	  char ubbs[MYBBSLEN+1];
	  char mbox[HADRESSLEN+1];
	  strcpy(ubbs,u->mybbs);
	  strcpy(mbox,m.boxadress);
	  if(strchr(ubbs,'.'))
	    *strchr(ubbs,'.')=0;
	  if(strchr(mbox,'.'))
	    *strchr(mbox,'.')=0;

	  b->guestlevel = 0;
	  if(u->mybbs[0] &&				                        // ist MyBBS gesetzt?
	    u->mybbstime > (ad_time() - 3600L*24*180) &&  // ist MyBBS juenger als 6 Monate?
	    strcmp(ubbs,mbox))				                    // ist MyBBS nicht unser Boxcall?
	    {
	      if(!u->password[0] || u->loginpwtype > 2)	  // ist kein Passwort gesetzt
		      {
		        b->guestlevel = 1;			                // => Gastlogin
		        goto istok;
		      }					                                // Passwort gesetzt
	      goto istok;				                          // => voller Login
	    }
	  if(m.pwonly)					                          // ist Login nur mit Passwort erlaubt?
	  {
	    if(!u->password[0] || u->loginpwtype > 2)	    // ist kein Passwort gesetzt
		  {
		    b->guestlevel = 2;			                    // => Gastlogin
		    goto istok;
		  }					                                    // Passwort gesetzt
	  }						                                    // => voller Login

	  istok:
	  if(b->guestlevel)
	    defaultguest(logincall,u);
	  trace(report,"mblogin","%s guestlevel %i", logincall, b->guestlevel);
#endif

#ifdef _PACLEN		//hpk + db1ras
	  if(m.defpaclen && (u->paclen<m.minpaclen || u->paclen>m.maxpaclen))
	    u->paclen=m.defpaclen;
#endif
	  putf ("\nBayCom-Mailbox V" VNUMMER " (" OPSYSTEM ") ");
	  if (m.callformat)
	    putf (CBMODEID " ");
#ifdef _GUEST
	  if (!strcmp (logincall, m.guestcall) == 0)
	    {
	      readtext ("ctext");
	      if (u->helplevel == 2)
		readtext ("cnew");
	      leerzeile ();
#ifdef _ASKLOGIN
	      if (!strcmp (logincall, m.guestcall) == 0)
		asklogin (logincall);
#endif
	      putaktuell (0);
	    }
	  else
	    {
	      b->sysop = 0;	//guest can not be sysops!

	      readtext ("cguest");
	      leerzeile ();
	    }
#else
	  if (!readtext ("ctext"))
	    putf ("\n");
	  if (u->helplevel == 2)
	    readtext ("cnew");
	  leerzeile ();
	  putaktuell (0);
#endif
	  if (u->name[0])
	    putf (ms (m_servus), u->name);
	  putf (ms (m_helplines), u->helplevel, u->zeilen);
	  if (u->lastboxlogin)
	    putf (ms (m_lastlogin), datestr (u->lastboxlogin, 2),
		  timestr (u->lastboxlogin, 1));
	  else
	    putf (ms (m_firstlogin));
	  if (u->mybbsok == 0)
	    putf (ms (m_inputmybbs));
	  else
	    {

#ifdef _EXDLOGIN
	      if (u->mybbstime < (ad_time () - 3600L * 24 * 30))
		  // wenn mybbs-Eintrag aelter als 1 Monat, dann auffrischen
#else	          
	      if (u->mybbstime < (ad_time () - 3600L * 24 * 180))
                  // wenn letzte mybbs-Eingabe aelter als ein halbes Jahr ist,
                  // dann auffrischen.
#endif	      

		{ 
		  set_mybbs (u->call, u->mybbs, ad_time (), newbid (0),
			     b->logincall, 0, NULL);
		  loaduser (u->call, u, 0);
		}
	    }
	  leerzeile ();

#ifdef _EXDLOGIN
	if(b->guestlevel==1)
	  { putf("\n\n");
	    readtext("gastbbs");
	  }
	if(b->guestlevel==2)
	  { putf("\n\n");
	    readtext("gastpwd");
	  }
#endif

	  if (u->notvisible[0])	// Zur Beseitigung von Altlasten

	    {
	      if (strlen (u->notvisible) > REJECTLEN)
		u->notvisible[REJECTLEN - 1] = 0;
	      if (u->notvisible[strlen (u->notvisible) - 1] != ' ')
		strcat (u->notvisible, " ");
	    }
	  strcpy (buf, u->firstcmd);
	  bufptr = buf;
	  saveuser (u);

#ifdef FILESURF			// DG4MMI
	  filesurf fs;
	  fs.getfirstpath (b->fspath);
#endif

	  do
	    {
	      semicolon = strchr (bufptr, ',');
	      if (semicolon)
		semicolon[0] = 0;
	      mailbef (bufptr, 0);
	      b->quit = 0;
	      bufptr = semicolon + 1;
	    }
	  while (semicolon);
	}
      //else
      //  putf("Call geaendert.\n");
    }
  saveuser (u);
}

/*---------------------------------------------------------------------------*/

void
mblogout (int kill)
//*************************************************************************
//
//  Fuehrt einen ordentlichen Logout aus.
//  Wird auch beim Kill eines Prozesses aufgerufen.
//
//*************************************************************************
{
  if (b && u)
    {
      if (b->logincall[0] && b->logintime)	// gegen login-fakes

	{
	  FILE *uf = s_fopen (USERNAME, "sr+b");	//User file accessable?

	  if (uf)
	    {
	      s_fclose (uf);
	      if (loaduser (b->logincall, u, 0))
		{
		  u->daybytes += (b->rxbytes + b->txbytes);
		  u->lastboxlogin = b->logintime;
#ifdef _EXDLOGIN	//db1ras
		  if(b->guestlevel)
		    defaultguest(b->logincall,u);
#endif
		  saveuser (u);
		  if (!kill && b->forwarding == fwd_none)
		    {
		      readtext ("qtext");
		      putflush ();
		    }
		  if (strcmp (b->uplink, "Import") != 0)
		    logbuch ();
		}
	      else
		trace (serious, "mblogout", "no user %s", b->logincall);

	    }

	  if (b->sysop && strcmp (b->uplink, "POP3") &&
              strcmp (b->uplink, "SMTP"))	//not smtp/pop3
	    cmdlog ("******** Logout");

	  if (b->forwarding != fwd_none)
	    {
	      if (kill)
		fwdlog ("---- ", "disconnect", '-');
	      else
		fwdlog ("---- ", "logout", '-');
	    }

	  if (kill)
	    trace (report, "mblogout", "%s (kill)", b->logincall);
	  else
	    trace (report, "mblogout", "%s", b->logincall);

	  b->logincall[0] = 0;
	  b->prompt[0] = 0;
	  if (gettaskid () != NOTASK)
	    t->cputics = 0;
	}
    }
}
