/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ------------
  POP3 for BCM   Reference: RFC 1725 (Definitions)
  ------------


  Copyright (C)       Deti Fliegl, deti@lrz.de, DG9MHZ
                      Guardinistr. 47
                      81375 Muenchen

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/
#ifdef __FLAT__

#define MAX_RCPTCNT 100

#ifdef __UNIX__
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define closesocket close
#endif
#ifdef _WIN32
#include "winsock.h"
#endif

/*---------------------------------------------------------------------------*/

class pop3
{
  public:
  void start_pop3 (char *name);
  void show_popdb(void);
  void onkill(void);
    private:
  enum
  {
    _ERR = -1, _USER, _PASS, _QUIT, _STAT, _LIST, _RETR, _DELE, _NOOP, _RSET, _UIDL
  }
  _cmdlist;
  void add_to_popdb(void);
  void charset (char *s);
  int checkcmd (char *cmd, char **cmdlist);
  int search_msg (int msg);
  int init_list (void);
  int put_list (int mode);
  int put_uidl (int msg);
  int retr_msg (int msg);
  int dele_msg (int msg);
  int extract_argument (char *s, int size);
  FILE *f;
  char lockfile[42];
  char tmpname[40];
  char buffer[1024];
  char cmd[32];
  int finish;
  int badcmd;
  int login;
  int msgcnt;
  int bytecnt;
  char user[256];
  char pass[256];
  int msg;
  int waslocked;
};
#endif

/*---------------------------------------------------------------------------*/
