/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------------
  Lschen von Files mit abgelaufener Lifetime
  -------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980223 OE3DZW fixed fsetopt
//19980614 OE3DZW purge will remove max. 10000 bulletins (lifetime)

#include "baycom.h"

/*---------------------------------------------------------------------------*/

static int near purgeboard(char *name,unsigned *er,unsigned *obs,unsigned *all)
{ char fname[FNAMELEN+1];
  int npos;
  char timestr[8];
  time_t akt=ad_time();
  int lt;
  int mail_lt;
  int loeschen_noetig;
  handle cf=EOF;
  FILE *f,*of;
  char listlockname[20]="";

  if(get_nopurge(name))
    return 2;

  int i=strlen(name)-1;
  while(i && name[i-1]!='/') i--;
  if(strlen(name+i)<10)
  { strcpy(listlockname,name+i);
    if(sema_lock(listlockname)==0)
       return 0;
  }


  lastcmd(name);
  if(mbcallok(name))
    sprintf(fname,"%s/%s/",m.userpath,name);
  else
    sprintf(fname,"%s/%s/",m.infopath,name);
  npos=strlen(fname);
  strcat(fname,DIRLISTNAME);

  strlwr(fname);
  f=s_fopen(fname,"srb");
  if(f)
  { loeschen_noetig=0;
    while(fread(b->line,128,1,f))
    { if((b->line[23]!='~')||(b->line[77]!='-'))
      { trace(serious,"purgeboard","corrupt %s",fname);
	s_fclose(f);
	f=NULL;
	xunlink(fname);
	loeschen_noetig=0;
	reorg_noetig++;
	break;
      }
      strncpy(timestr,b->line,7);
      timestr[7]=0;
      mail_lt=atoi(b->line+51);
      lt=mail_lt-(int)((akt-filename2time(timestr))/86400L);
      if(mail_lt==999)
        lt=999;
      if(lt<=0 || (b->line[14]!='>' && (b->line[14]!='X'||m.remerase!=3)))
	loeschen_noetig++;
        if (  (b->line[60] == '|') &&    //new format  
              (b->line[61] != 'B') &&    //mailtype is personal/ack
              (b->line[62] != '!') &&    //forward hold is set
          ((akt-filename2time(timestr))/86400L > 30) ) //older 1 month
          loeschen_noetig++;
      waitfor(e_ticsfull);
      (*all)++;
    }
    if(loeschen_noetig)
    { fseek(f,0,SEEK_SET);
      strcpy(fname+npos,DIRTMPNAME);
      strlwr(fname);
      of=s_fopen(fname,"swb");
      if(!b->usermail)
	cf=s_open(CHECKNAME,"sr+b");
      if(of)
      {	s_fsetopt(of,1);
        while(fread(b->line,128,1,f))
	{ int rem_now=0;
          strncpy(timestr,b->line,7);
	  timestr[7]=0;
          mail_lt=atoi(b->line+51);
          lt=mail_lt-(int)((akt-filename2time(timestr))/86400L);
          if(mail_lt==999)
            lt=999;
          
          if(lt<=0||(b->line[14]!='>' && (b->line[14]!='X'||m.remerase!=3)))
            rem_now++;
          if (  (b->line[60] == '|') &&    //new format  
              (b->line[61] != 'B') &&    //mailtype is personal/ack
              (b->line[62] != '!') &&    //forward hold is set
             ((akt-filename2time(timestr))/86400L > 30) ) //older 1 month
            rem_now++;
          if (rem_now)
	  { if(lt>0)
	      (*er)++;
	    else
	      (*obs)++;
	    strcpy(fname+npos,timestr);
            strlwr(fname);
	    xunlink(fname);
	    if(cf!=EOF)
	    { seek_fname(cf,timestr,timestr);
	      if(timestr[0])
	      { if(_read(cf,b->line,128)>0)
		{ b->line[7]=' ';
		  lseek(cf,-128L,SEEK_CUR);
		  _write(cf,b->line,128);
		}
		else
		  trace(serious,"purgeboard","check read");
	      }
	    }
	  }
	  else
	    fwrite(b->line,128,1,of);
	  waitfor(e_ticsfull);
	}
	if(cf!=EOF)
	  s_close(cf);
	s_fclose(of);
	s_fclose(f);
	f=NULL;

	strcpy(b->line,fname);
	strcpy(b->line+npos,DIRTMPNAME);
	strcpy(fname+npos,DIRLISTNAME);
        strlwr(fname);
	if(xunlink(fname))
	  trace(replog,"purgeboard","unlink %s",fname);
	if(xrename(b->line,fname))
	  trace(serious,"purgeboard","rename %s",b->line);
      }
      else
	trace(serious,"purgeboard","fopen %s errno=%d",fname,errno);
    }
    if(f)
      s_fclose(f);
  }
  waitfor(e_ticsfull);
  fname[npos-1]=0;  // remove slash
  sema_unlock(listlockname);
  return rmemptydir(fname);
}

/*---------------------------------------------------------------------------*/

void mbpurge(char *)
{ char *userlist;
  char name[]="mbpurge";
  int i=0;
  unsigned er=0,obs=0,all=0;

  if(m.nopurge&1)
    return;

  strcpy(t->name,"Purge");

  while(sema_lock("purgereorg")==0)
    wdelay(1026);

  b->job=j_purge;
  b->usermail=0;
  if((m.nopurge&4) == 0)
  { i=0;
    trace(replog,name,"bulletins");
    while(i<treelen)
    { if(purgeboard(tree[i].name,&er,&obs,&all)==0)
        i++;
      if (obs > 10000)
      { trace(fatal,name,"%u lt aborting");
      }
    }
    trace(replog,name,"%u era, %u lt, %u all",er,obs,all);
  }
  if((m.nopurge&8) == 0)
  {
    trace(replog,name,"users");
    b->usermail=1;
    er=obs=all=0;
    userlist=(char *)t_malloc(8U * MAXUSERMAILS,"u_pu");
    if(userlist)
    { i=0;
#ifdef __BORLANDC__
      struct ffblk di;
      char mask_wild[FNAMELEN+1];
      sprintf(mask_wild,"%s/*.*",m.userpath);
      if(findfirst(mask_wild,&di,0xffff)==0)
      { do
        {
          if(di.ff_name[0]!='.')
          { strncpy(userlist+(i*8),di.ff_name,6);
            userlist[i*8+6]=0;
            i++;
            if(i>=MAXUSERMAILS)
              trace(fatal,name,"too many usermails");
          }
          waitfor(e_ticsfull);
        }
        while(findnext(&di)==0);
      }
#else
      DIR *d;
      struct dirent *di;

      d=opendir(m.userpath);

      while(d && (di=readdir(d))!=NULL)
      { if(di->d_name[0]!='.')
        { strncpy(userlist+(i*8),di->d_name,6);
          userlist[i*8+6]=0;
          i++;
          if(i>=MAXUSERMAILS)
            trace(fatal,name,"too many usermails");
          waitfor(e_ticsfull);
        }
      }
      closedir(d);
#endif
      userlist=(char *)t_realloc(userlist,8U * (i+1));

      while(i)
      { i--;
        purgeboard(userlist+(i*8),&er,&obs,&all);
      }
      t_free(userlist);
      trace(replog,name,"%u era, %u lt, %u all",er,obs,all);
    }
  }
  purgecheck("");
  trace(replog,name,"ready, %s sec cputime",
               zeitspanne(t->cputics,zs_cpuexact));
  sema_unlock("purgereorg");
  if(reorg_noetig)
    fork(P_BACK|P_MAIL,0,mbreorg,"");
}

/*---------------------------------------------------------------------------*/

void userpurge(char *befbuf)
{ char board[20];
  unsigned er=0,obs=0,all=0;

  if(m.nopurge&1)
  { putf("Purge disabled.\n");
    return;
  }
  if(sema_test("purgereorg") || sema_test("sendlock"))
  { putf("PURGE/REORG semaphore set. Retry later!\n");
    return;
  }
  if(stricmp(befbuf,"A")==0)
  { putf("PURGE (whole file system) started.\n");
    fork(P_BACK|P_MAIL,0,mbpurge,befbuf);
    return;
  }
  if(befbuf[0])
    strncpy(board,befbuf,19);
  else
    strcpy(board,b->logincall);
  board[19]=0;
  strupr(board);
  if(finddir(board,b->sysop)!=0)
  { if(sema_lock("purgereorg")==0)
      return;
    putf(ms(m_boardpurge),b->boardfullname);
    if(purgeboard(b->boardfullname,&er,&obs,&all)==2)
      putf("Purge disabled.\n");
    else
    { putf(ms(m_purgeresult),all,er,obs);
      if(!mbcallok(b->boardname))
        fork(P_BACK|P_MAIL,0,purgecheck,"P_Check");
    }
  }
  else
    putf(ms(m_noboxfound),board);
  sema_unlock("purgereorg");
}
