/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -----------------------------------------
  Erzeugen/Update von LIST- und CHECK-Files
  -----------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980218 OE3DZW added msgty / "7+" to listline
//19980219 OE3DZW removed callcheck for "herkunft" (sender of mail)
//19980223 OE3DZW added parameter "keep_msgtype" to add_dirlist
//19980913 OE3DZW added msgty 6 - broken 7+ file
//19990818 OE3DZW fixed y2k-bug, did not recognise mails >2000

#include "baycom.h"

/*---------------------------------------------------------------------------*/

int reorg_noetig=0;

/*---------------------------------------------------------------------------*/

static void near reorgboard(char *board,int remdouble)
//*************************************************************************
//
//  Erzeugt LIST-File fuer ein bestimmtes Board neu;
//  funktioniert fuer user- und infofiles
//
//*************************************************************************
{ b->index=finddir(board,b->sysop);
  lastcmd(board);
  waitfor(e_ticsfull);
  if(b->index!=0)
  { trace(report,"reorgboard","%s",b->boardfullname);
    make_mask(b->mask,b->boardfullname);
    strcpy(b->listpath,b->mask);
    if(!strstr(b->listpath,"*.*"))
       trace(fatal,"reorgboard","mask %s",b->mailpath);
    strcpy(strstr(b->listpath,"*.*"),DIRLISTNAME);
    createdirlist(remdouble);
  }
  waitfor(e_ticsfull);
}

/*---------------------------------------------------------------------------*/

void mbreorg(char *name)
//*************************************************************************
//
//  reorganisieren:
//  es werden alle LIST-Files und das CHECK-File neu aufgebaut
//  waehrend dieser Vorgang laeuft werden send-Zugriffe nicht erlaubt
//
//*************************************************************************
{ char *userlist;
  int i=0;
  char befehl[20];
  int remdouble=0;
  int old_disable=m.disable;
  int doall=0;

  strncpy(befehl,name,19);
  befehl[19]=0;

  if(sema_lock("purgereorg")==0)
    return;

  b->sysop=1;
  strcpy(t->name,"Reorg");

//Moegliche Reorgtypen: X (F) B C U L P I H N

  if(stricmp(befehl,"X")==0)
  { 
    remdouble=1;
    m.disable=1;
    xunlink("bids2.reo");
    xunlink("bidh2.reo");
    xrename(BIDNAME,"bids2.reo");
    xrename(BIDHASHNAME,"bidh2.reo");
    bidinit(0);
    doall=1;
  }
  if(stricmp(befehl,"F")==0)
  { doall=1;
    remdouble=2;
  }
  if(befehl[0]==0)
    doall=1;

  b->job=j_reorg;
  b->usermail=0;
  if(stricmp(befehl,"B")==0 || doall)
  { strcpy(t->name,"Reorg B");
    trace(replog,"reorg","bulletins");
    for (i=0;i<treelen;i++)
      reorgboard(tree[i].name,remdouble);
  }
  if(stricmp(befehl,"C")==0 || doall)
  { strcpy(t->name,"Reorg C");
    makecheck();
  }  

  if(stricmp(befehl,"X")==0)
  { strcpy(t->name,"Reorg X");
    m.disable=old_disable;
    xunlink(BIDNAME);
    xunlink(BIDHASHNAME);
    xrename("bids2.reo",BIDNAME);
    xrename("bidh2.reo",BIDHASHNAME);
  }
  if((doall) || (stricmp(befehl,"U")==0)) //oe3dzw: war befehl[0]=0
  { strcpy(t->name,"Reorg U");
    trace(replog,"reorg","usermails");
    b->usermail=1;
    userlist=(char *)t_malloc(8U * MAXUSERMAILS,"u_re");
    if(userlist)
    { i=0;
      struct dirent *di;
      DIR *d=opendir(m.userpath);

      while((di=readdir(d))!=NULL)
      { if(di->d_name[0]!='.')
	{ strncpy(userlist+(i*8),di->d_name,6);
	  userlist[i*8+6]=0;
	  i++;
          if(i>=MAXUSERMAILS)
            trace(fatal,"reorg","too many usermails");
	}
        waitfor(e_ticsfull);
      }
      closedir(d);

      userlist=(char *)t_realloc(userlist,8U * (i+1));
      while(i)
      { i--;
	reorgboard(userlist+(i*8),0);
      }
      t_free(userlist);
    }
  }
  if(stricmp(befehl,"L")==0)
  { strcpy(t->name,"Reorg L"); 
    reorguser(0);
  }
  if(stricmp(befehl,"P")==0)
  { strcpy(t->name,"Reorg P");
    reorguser(1);
  }
  if((doall) || (stricmp(befehl,"I")==0)) //war befehl[0]=0
  { strcpy(t->name,"Reorg I"); 
    reorgbid();
  }
  if((doall) || (stricmp(befehl,"H")==0)) //war befehl[0]=0
  { strcpy(t->name,"Reorg H");
    reorg_hadr();
  }
  if(stricmp(befehl,"N")==0)
  { strcpy(t->name,"Reorg N");
    make_checknum("reorg");
  }
  trace(replog,"reorg","ready, %s sec cputime",
               zeitspanne(t->cputics,zs_cpuexact));

  sema_unlock("purgereorg");
  reorg_noetig=0;
}

/*---------------------------------------------------------------------------*/

static void near add_dirlist(char *filename,handle fh,int check,
  int remdouble,int keep_msgtype)
{ FILE *tmpf=0;
  handle tmpfh;
  char *buf=b->line;
  char *betr=buf+160;
  unsigned position=0;
  int i;
  char local_msgtype=b->msgty;

  waitfor(e_ticsfull);

  if(strlen(filename)!=7)
    goto error;
  strcpy(b->mailpath,b->mask);

  if(!strstr(b->mailpath,"*.*"))
    trace(fatal,"add_dirlist","mask %s",b->mailpath);

  strcpy(strstr(b->mailpath,"*.*"),filename);

  strlwr(b->mailpath);
  if(sema_access(b->mailpath)>1) // wenn ein schreibender Zugriff besteht
    return;                      // den Eintrag noch ignorieren
  tmpf=s_fopen(b->mailpath,"srt");

  if(tmpf)
  { if(!fgets(buf,255,tmpf)) // Headerzeile, entspricht Syntax SEND-Befehl
      goto error;
    mbsend_parse(buf,0);
    if (keep_msgtype)
      b->msgty=local_msgtype;
//    if(!mbcallok(b->herkunft))
//      goto error;
    if(b->ziel[0]==0)
      goto error;
    if(!fgets(buf,255,tmpf)) // Forwardzeile, * fuer geloescht
      goto error;
    if(buf[0]=='*')
      b->geloescht=buf[1];
    else
      b->geloescht=0;
    if(!fgets(buf,255,tmpf)) // READ:-Zeile
      goto error;
    b->gelesen=!!strstr(buf,b->ziel); // Empfaenger hat gelesen?
    if(b->bytes==0)
      goto error;
    strcpy(buf,filename);
    strupr(buf);

    b->at[6]=0;
    if(strchr(b->at,'.'))
      strchr(b->at,'.')[0]=0;
    if(strchr(b->at,'-'))
      strchr(b->at,'-')[0]=0;

    if(!fgets(betr,79,tmpf)) // Betreff-Zeile 
      goto error;
    betr[strlen(betr)-1]=0; // newline weg
    strcpy(b->betreff,betr);

    if(b->lifetime==0)
    { b->lifetime=checklifeconv(betr);
      if((b->lifetime<0) || b->usermail)
	b->lifetime=b->boardlife_max;
    }

    if(!b->sysop && b->lifetime>(b->boardlife_max<<1))
      b->lifetime=(b->boardlife_max<<1);

    if(!b->sysop && b->lifetime<(b->boardlife_min))
      b->lifetime=b->boardlife_min;

    if(b->lifetime>999)
      b->lifetime=999;

    if(b->bid[0] && (check || remdouble))
    { char bidbuf[50];
      if(bidvorhanden(b->bid))
      { if(remdouble==1)
          goto error;
        sprintf(bidbuf,"%s/%s",b->boardname,filename);
        strupr(bidbuf);
	bidnewfilename(b->bid,bidbuf);
      }
      else
      { sprintf(bidbuf,"%s/%s",b->boardname,filename);
        strupr(bidbuf);
        bidrein(b->bid,bidbuf);
      }
    }
    sprintf(buf+7,"<%-6s>%-8s~%-6s@%-6s$%-12s#%3d%%%s",
	    b->herkunft,b->boardname,b->frombox,b->at,b->bid,b->lifetime,
	    dezasc(b->lines,2));
// OE3DZW: Mailtype nur dann, wenn Usermail
    if(b->usermail)
    { if(b->gelesen)
        buf[22]='R';  
    }     
    if(b->geloescht)
      buf[14]=b->geloescht;
    sprintf(buf+strlen(buf),"%s",dezasc(nonlin(b->bytes),3));
// OE3DZW: hier kann ein neues Flag eingefuegt werden!
// Die Positionen 3-11 sind bisher unbenutzt!
//  16  neue Flags             1 2 3 4 5 6 7 8 9 A B C D E F 0              
    sprintf(buf+strlen(buf),"|%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c-",
      b->mailtype,b->fwdhold,b->fwdprop,b->replied,
      b->msgty,b->flag6,b->flag7,b->flag8,b->flag9,
      b->flaga,b->flagb,b->flagc,b->flagd,b->flage,
      b->flagf,b->flag0
   );
    if(b->binstart)
      strcat(buf,"(BIN) ");
    else
    { if (b->msgty=='7')
        strcat(buf,"(7+) ");
      if (b->msgty=='6')
        strcat(buf,"(7-) ");
    }
    for(i=0;betr[i];i++)
      if(((unsigned char *)betr)[i] < 32) betr[i]='.';
    strcat(buf,betr);
    buf[126]=0;
    while(strlen(buf)<126)
      strcat(buf," ");

    strcat(buf,"\r\n");
    _write(fh,buf,128);
    position=(unsigned)(ltell(fh)>>7);
    s_fclose(tmpf);
    if(check && !b->usermail)
    { do
      { tmpfh=s_open(CHECKNAME,"sab");
	if(b->semalock) wdelay(519);
      } while(b->semalock);
      if(tmpfh!=EOF)
      { _write(tmpfh,buf,128);
	s_close(tmpfh);
        tmpfh=s_open("checknum.bcm","sab");
        if(tmpfh!=EOF)
        { _write(tmpfh,&position,2);
          s_close(tmpfh);
        }
      }
      else
	trace(serious,"add_dir","check open");
    }
    waitfor(e_ticsfull);
    return;
  }
  else
    trace(replog,"add_dir","text open %s",b->mailpath);
    return;

  error:
  { s_fclose(tmpf);
    xunlink(b->mailpath);
    trace(serious,"add_dir","%s>%s $%s",b->herkunft,b->boardname,b->bid);
  }
}

/*---------------------------------------------------------------------------*/

char *dirsort(char *mask,int users)
{ 
  char *list=NULL;
  unsigned pos=0;
  int ok;

  strlwr(mask);

#ifdef __BORLANDC__
  struct ffblk di;
  char mask_wild[FNAMELEN+1];
  sprintf(mask_wild,"%s/*.*",mask);
  if(findfirst(mask_wild,&di,0xffff)==0)
  { do
    { if(users)
	ok=(strlen(di.ff_name)>3) && (strlen(di.ff_name)<7);
      else
	ok=(!(di.ff_attrib&FA_DIREC)) && (strlen(di.ff_name)==7);

      if(ok)
      {	if(list==NULL)
	  list=(char *)t_malloc(MAXDIRENTRIES * 8,"dirs");
	strcpy(list+pos,di.ff_name);
	list[pos+7]=0;            // evtl zu langen Filenamen abschneiden
	pos+=8;

	if(pos>=(MAXDIRENTRIES * 8U))
	{ trace(fatal,"dirsort","dir overflow");
	  return NULL;
	}
      }
      waitfor(e_ticsfull);
    }
    while(findnext(&di)==0);
  }
#else
  DIR *d=opendir(mask);
  struct dirent *di;
  char dircheckbuf[FNAMELEN+1];
  strncpy(dircheckbuf, mask, FNAMELEN-7-1); // 7 bytes: filename, 1 byte: /
  dircheckbuf[FNAMELEN-7-1]=0;
  strcat(dircheckbuf, "/");
  char *ptr=dircheckbuf+strlen(dircheckbuf);

  while(d && (di=readdir(d))!=NULL)
  {
    if(users)
      ok=(strlen(di->d_name)>3) && (strlen(di->d_name)<7);
    else
    { if(strlen(di->d_name)!=7)
        ok=0;
      else
      { strcpy(ptr, di->d_name);
        ok=!isdir(dircheckbuf);
      }
    }

    if(ok)
    { if(list==NULL)
        list=(char *)t_malloc(MAXDIRENTRIES * 8,"dirs");
      strcpy(list+pos,di->d_name);
      list[pos+7]=0;            // evtl zu langen Filenamen abschneiden
      pos+=8;
      if(pos>=(MAXDIRENTRIES * 8U))
      { closedir(d);
        trace(fatal,"dirsort","dir overflow");
        return NULL;
      }
    }
    waitfor(e_ticsfull);
  }
  closedir(d);
#endif

  if(pos)
  { list[pos]=0;
    list=(char *)t_realloc(list,pos+8);
    qsort((void *)list,pos>>3,8,(int(*)(const void *,const void *))strcmp);
    return list;
  }
  else
  { if(list)
      t_free(list);
    return NULL;
  }
}

/*---------------------------------------------------------------------------*/

static void near touchname(void)
//*************************************************************************
//
//  Setzt Datum/Uhrzeit des aktuellen Files auf die Momentane Zeit
//
//*************************************************************************
{ char oldname[FNAMELEN+1];

  strcpy(oldname,b->mailpath);
  make_mask(b->mailpath,b->boardfullname);
  strcpy(b->mask,b->mailpath);
  strcpy(b->mailfname,time2filename(0));
  if(!strstr(b->mailpath,"*.*"))
    trace(fatal,"touchname","mask %s",b->mailpath);
  strcpy(strstr(b->mailpath,"*.*"),b->mailfname);
  strlwr(oldname);
  strlwr(b->mailpath);
  xrename(oldname,b->mailpath);
}

/*---------------------------------------------------------------------------*/

int appenddirlist(void)
{ handle fh;
  int nummer=0;

  while(sema_test(b->boardname) ||
       ((sema_test("sendlock")||m.disable) && !b->usermail))
  { wdelay(270);
  }
  touchname();
  strcpy(b->listpath,b->mask);
  if(!strstr(b->listpath,"*.*"))
    trace(fatal,"appenddirlist","mask %s",b->listpath);
  strcpy(strstr(b->listpath,"*.*"),DIRLISTNAME);
  strlwr(b->listpath);
  fh=s_open(b->listpath,"sab");
  if(fh==EOF)
    fh=s_open(b->listpath,"swb");
  if(fh!=EOF)
  { add_dirlist(b->mailfname,fh,1,0,1);
    nummer=(unsigned)(filelength(fh)/128);
    s_close(fh);
  }
  else
    trace(fatal,"appenddirlist","open %s",b->listpath);
  return nummer;
}

/*---------------------------------------------------------------------------*/

int checkdirlist(void)
{ handle fh;
  char buf[128];
  unsigned pos=0;
  char *dirlist;
  char tmpmask[FNAMELEN+1];
  int ok=1;
  int listda=0;

  strcpy(tmpmask,b->mask);
  if(strstr(tmpmask,"/*.*"))
    tmpmask[strlen(tmpmask)-4]=0;

  dirlist=dirsort(tmpmask,0);
  if(dirlist)
  { fh=s_open(b->listpath,"lrb");

    if(fh!=EOF)
    { listda=1;
      while(dirlist[pos])
      {
        if(_read(fh,buf,128)!=128)
        { sprintf(tmpmask+strlen(tmpmask),"/%s",dirlist+pos);
          if(sema_access(tmpmask)<=1)
            ok=0;
          break;
        }
        buf[7]=0;  
//oe3dzw Neue Positon des Titels 77 statt 60
        if(buf[77]!='-' || buf[23]!='~')
          ok=0;
        if(stricmp(buf,dirlist+pos)!=0)
          ok=0;
	pos+=8;
	waitfor(e_ticsfull);
      }
      if(pos!=(filelength(fh)>>4))
        ok=0;
      s_close(fh);
    }
    else
      ok=0;

    t_free(dirlist);
  }
  if(ok==0 && listda)
    trace(replog,"reorg","creating %s",b->listpath);
  return ok;
}

/*---------------------------------------------------------------------------*/

void createdirlist(int remdouble)
{ handle fh;
  unsigned pos=0;
  char *dirlist=NULL;
  char tmpfilename[FNAMELEN+1];
  char tmpmask[FNAMELEN+1];

  while(sema_lock(b->boardname)==0)
    wdelay(521);

  strlwr(b->mask);
  strlwr(b->listpath);

  if(remdouble || checkdirlist()==0)
  {
    strcpy(tmpfilename,b->mask);
    if(!strstr(tmpfilename,"*.*"))
      trace(fatal,"createdirlist","mask %s",tmpfilename);
    strcpy(strstr(tmpfilename,"*.*"),DIRTMPNAME);
    strcpy(tmpmask,b->mask);

    if(strstr(tmpmask,"/*.*"))
      tmpmask[strlen(tmpmask)-4]=0;
    //trace(report,"createdirlist","%s",tmpmask);
    dirlist=dirsort(tmpmask,0);
    if(dirlist)
    { strlwr(tmpfilename);
      fh=s_open(tmpfilename,"lwb");

      if(fh!=EOF)
      { while(dirlist[pos])
        {
          //trace(report,"reorg","add %s %s",tmpmask,dirlist+pos);
          add_dirlist(dirlist+pos,fh,0,remdouble,0);
	  pos+=8;
	  waitfor(e_ticsfull);
        }
        s_close(fh);
        xunlink(b->listpath);
        xrename(tmpfilename,b->listpath);
        if(filesize(b->listpath)==0)
          xunlink(b->listpath);
      }
      else
        trace(fatal,"createdirlist","open %s",tmpfilename);
      t_free(dirlist);
    }
  }
  sema_unlock(b->boardname);

  if(dirlist && m.disable==0) wdelay(332);
}

/*---------------------------------------------------------------------------*/

void postfwd(char *)
{
  char *userlist;
  unsigned i=0;
  char bef[80];
  char mybbs[HADRESSLEN+1];
  unsigned usermails=0, forwards=0;
  if(sema_lock("postfwd")==0)
    return;

  b->sysop=1;
  userlist=(char *)t_malloc(8U * MAXUSERMAILS,"fwdm");

  if(userlist)
  { i=0;
    struct dirent *di;
    DIR *d=opendir(m.userpath);

    while((di=readdir(d))!=NULL)
    { waitfor(e_ticsfull);
      if(di->d_name[0]!='.')
      { strncpy(userlist+(i*8),di->d_name,6);
	userlist[i*8+6]=0;
	i++;
        if(i>=MAXUSERMAILS)
          trace(fatal,"postfwd","too many usermails");
        waitfor(e_ticsfull);
      }
    }
    closedir(d);

    userlist=(char *)t_realloc(userlist,8U * (i+1));

    usermails=i;
    while(i)
    { i--;

      mybbs[0]=0;
      get_mybbs(userlist+(i*8),mybbs,0);
      waitfor(e_ticsfull);
      if(mybbs[0]==0 || strcmp(atcall(mybbs),m.boxname)==0)
        continue;

      sprintf(bef,"%s 1- @ %s",userlist+(i*8),mybbs);
      forwards+=mbchange(bef,w_forward,0);
      lastcmd(bef);
    }
    t_free(userlist);
    trace(replog,"postfwd","%u users, %d forw, %ss cpu",
                 usermails,forwards,zeitspanne(t->cputics,zs_cpuexact));
  }
}
