/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ----------------------------------------
  SEND-Befehl: Abspeichern von Nachrichten
  ----------------------------------------


  Copyright (C)       Florian Radlherr et al
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980115 OE3DZW removed define for /ex in fwd - removed this anti-bug-fix
//19980120 DG9MHZ fixed reject of mail
//19980121 DG9MHZ made reject parser resistant against space between
//19980124 OE3DZW added rejlog, removed wantmail-log for user@flood
//                removed support for DXL-bbs
//                removed "fwdmode", was not used
//                added ifdef for mailserver (not ready for DOS16)
//19980202 OE3DZW removed check for source-callsign
//                removed check for loop of mail in fwd
//19980202 OE3DZW added check for mailserver / dos16
//19980205 OE3DZW fixed writetext routine, \r was interpreted wrong
//19980205 OE3DZW wrong ifdef undefined mailserver under linux, fixed
//19980209 OE3DZW rejectlog/unknownlog not created, only appended
//19980215 OE3DZW added bytes=0,lines=0 in writetext (fixed double result)
//19980223 OE3DZW added "7+" in listfile
//19980224 OE3DZW fixed msgty, was not initialized
//19980301 OE3DZW fixed writelog, was static but returned 0
//                removed SSID in reply-to address
//                added bid and mailtype to "unknown", cosmetic changes
//                moved tmpbidvorhanden-check to end of wantmail
//                changed structure for check "tmpbidvorhanden"
//                added check for invalid bin-files in std-fwd
//19980304 OE3DZW fixed check for mailtype in reject, more robust now
//19980308 OE3DZW personal mails sysop @ <flood> will be accepted 
//                generating new bid when personal mail for own bbs
//                with mybbs != own bbs
//19980309 OE3DZW bad bin-crc -> rejectlog
//19980405 OE3DZW will not accept mails w/o call
//19980404 hrx    info/user-dir as zielboard (not ziel)
//19980404 hrx    guest
//19980407 OE3DZW bytes korrekt
//19980421 OE3DZW no HOLD mail for CP-Mails
//19980424 OE3DZW no,rej w/o reason when no reason given
//                7+rejlog only for bulletins
//19980525 DH3MB  fixed add_dir error
//19980614 OE3DZW diskfull will disable bbs
//19980614 OE3DZW trace for re-routing of usermails 
//19980614 OE3DZW added new function update_mail
//19980615 OE3DZW bid was not changed when mail was rerouted
//19980614 hrx    save mail() - displaying number of stored msg at
//                (ms(m_stored)). added condition for createboardfwd to
//                testmail directory()
//19980619 OE3DZW fixed update_mail - if was incorrect
//19980619 OE3DZW createboard will be "0" instead of "2" for fwd-connects
//19980830 OE3DZW fixed: fbb-fwd stopped on bin-err (output of "|")
//19980913 OE3DZW added savebroken-feature
//19980914 OE3DZW changed bin-header, filename w/o timestamp accepted
//19981001 OE3DZW now creates dir if empty inside savemail
//19981015 OE3DZW userfwd can be set to "off" or "passive"
//19990111 OE3DZW will no longer send binary messages to fbb
//19990117 OE3DZW added convat, converts adr for local bulletins
//19990208 OE3DZW moved remeraser to mbwp.cpp (used as function now)
//19990214 OE3DZW import will only acccept "nnnn" lower case at start of li.
//19990215 OE3DZW removed TELL-server
//19990427 OE3DZW import will die if send fails
//19990618 DH3MB  Cleaned up writebin()
//19990621 OE3DZW fixed ^z-bug (e/m-Mails)
//19990816 DH3MB  Restructured wantmail() and testmaildirectory()
//19991003 hpk    when guest sends a mail it will not be forwarded and it will
//                be marked.
//19991024 OE3DZW fixed check for import/kill
//19991110 OE3DZW removed bidrein for E/M-mails
//19991110 DB1RAS added _SENDLT in mbsend(): send-cmd ask for a lifetime if
//              the message is a bulletin

#include "baycom.h"

/*---------------------------------------------------------------------------*/

int mbsend_parse (char *befbuf, int def)
//*************************************************************************
//
//  Examines a line containing the fields of the SEND-command and
//  writes the parameters to the corresponding variables of the
//  current task
//
//  def: 0 = It's the first line of a mail-file (including file-length, etc.)
//           eg used in add_dirlist (mbreorg.cpp)
//       1 = It's a line entered by a user or received in S&F
//       2 = Used for transferring a mail 
//
//*************************************************************************
{ char lt[6];

  if (def!=2)
  { b->betreff[0] = 0;
    b->ziel[0] = 0;
    b->herkunft[0] = 0;
    b->at[0] = 0;
    b->bid[0] = 0;
    b->bytes = 0;
    b->lines = 0;
    b->lifetime = 0;
    b->binstart = 0;
    b->frombox[0] = 0;
  }

  if (def!=1)
  { b->mailtype = '?';  // OE3DZW: vorbesetzen wenn lesen
    b->fwdhold = b->fwdprop = b->replied = '!'; 
    b->msgty='!';
  }

  // Initialize the flags which are not used in this version
  b->flag6 = b->flag7 = b->flag8 = b->flag9 = b->flaga =
  b->flagb = b->flagc = b->flagd = b->flage = b->flagf = b->flag0 = '!';

  // First parameter = destination
  befbuf = nexttoken (befbuf, b->ziel, 8);
  strupr (b->ziel);

  // b->ziel:      Board, to which the mail is destined
  // b->zielboard: Board, to which we write the mail (may be different
  //               to b->ziel due to convname.bcm)
  strcpy(b->zielboard, b->ziel);
  nameconvert(b->zielboard);

  // Don't allow (back-)slashes
  while(strchr(b->ziel, '/'))
    *strchr(b->ziel, '/')='_';
  while(strchr(b->ziel, '\\'))
    *strchr(b->ziel, '\\')='_';

  // Only used to decide if we store the message in the info- or in the
  // user-path
  b->usermail=(char)mbcallok(b->zielboard); //hrx

  // Read the remaining parameters
  while (befbuf[0])
  { switch (befbuf[0])
    {
    case '<':
      befbuf = nexttoken (befbuf + 1, b->herkunft, 6);
      strupr (b->herkunft);
      break;

    case '@':
      b->at[0] = 0;
      if ((befbuf[2] != ' ') || (befbuf[3] != ' '))
      { befbuf = nexttoken (befbuf + 1, b->at, HADRESSLEN);
        strupr (b->at);
        if (strstr (b->at, m.boxname) == NULL && strchr (b->at, '-'))
          strchr (b->at, '-')[0] = 0;
        //strcpy(b->send_mybbs,b->at);
      }
      else
        befbuf++;
      break;

    case '$':
      befbuf = nexttoken (befbuf + 1, b->bid, 12);
      strupr (b->bid);
      break;

    case '#':
      if (isdigit (befbuf[1]) || befbuf[1] == ' ')
      { befbuf = nexttoken (befbuf + 1, lt, 5);
        b->lifetime = atoi (lt);
        if (b->lifetime > 999 || b->lifetime < 0)
          b->lifetime = 0;
      }
      else
        goto betreff;
      break;

    case '%':
      if (def==0)
      { b->lines = (unsigned) ascdez (befbuf + 1, 2);
        b->bytes = inonlin(ascdez (befbuf + 3, 3));
        befbuf += 6;
      }
      else
        goto betreff;
      break;

    case '~':
      if (def==0)
      { befbuf = nexttoken (befbuf + 1, b->frombox, 6);
        strupr (b->frombox);
      }
      else
        goto betreff;
      break;

    // Mailflags (OE3DZW)
    case '|':
      if ((b->forwarding == fwd_none) || (def == 0))
      { b->mailtype = befbuf[1];
        b->fwdhold = befbuf[2];
        b->fwdprop = befbuf[3];
        b->replied = befbuf[4];
        b->msgty = befbuf[5];
        if (b->msgty < '!')  //if set to 0 (bug in bcm139x22)
          b->msgty='!';   
      }
      befbuf += 17;
      break;

    case '=':
      if (def==0)
      { b->binstart = ascdez (befbuf + 1, 3);
        befbuf += 4;
      }
      else
        goto betreff;
      break;

    case ' ':
      befbuf++;
      break;

    default:
    betreff:
      if (def != 2)
      { strncpy(b->betreff,befbuf,sizeof(b->betreff)-1);
        b->betreff[sizeof(b->betreff)-1]=0;
      }
      befbuf += strlen (befbuf);
    }
  }

  // Guess the mailtype, if we don't already know it
  if (b->mailtype == '?')
    b->mailtype = mbmailt (b->ziel, b->at);

  // Attention: Mind the difference between frombox, herkunft and logincall:
  //            herkunft  = The call of the user, who has written the mail
  //            frombox   = BBS, *WE* have the mail received from
  //            logincall = AX.25-call of the partner without SSID
  //            DOS:  cr-lf 0xd 0xa ^M ^L  \r \n
  //            Unix:    lf     0xa    ^L     \n
  //            Packet:  cr 0xd     ^M     \r
  if (def == 1) //entered by user or received in s&f
  { // 1. Within normal box-logins we always use the user's AX25-Call as
    //    sender, even if he has specified another call after a '<'
    // 2. If we don't receive a sender-field in S&F, we will use the
    //    partner's AX25-Call for this
    if (!b->herkunft[0] || (b->forwarding==fwd_none && !b->sysop))
      strcpy (b->herkunft, b->logincall);

    if (!b->bid[0])
      if (b->forwarding != fwd_none && !b->usermail)
        // If we don't receive a BID in S&F, we defer this message
        strcpy(b->bid, "NOBID");
      else
        // But if we don't receive a MID, we create one
        strcpy(b->bid, newbid(0));

    // We keep the mailbox, we have the mail received from in mind
    if(b->forwarding == fwd_standard
#ifdef _FILEFWD
       || b->forwarding == fwd_file
#endif
    )
      strcpy(b->frombox, b->logincall);
  } 
  return b->ziel[0];
}

/*---------------------------------------------------------------------------*/

void writeheader (FILE *sendf, int transfer)
//*************************************************************************
//
//  Creates a mail header
//
//*************************************************************************
{ int i;

  fprintf (sendf, "%s < %s ", b->ziel, b->herkunft);
  if (b->frombox[0])
    fprintf (sendf, "~%s ", b->frombox);
#ifndef _LONG_HROUTE
  fprintf (sendf, "@%-24s ", b->at);
#else
  fprintf (sendf, "@%-39s ", b->at);
#endif
  if (b->bid[0])
    fprintf (sendf, "$%-12s ", b->bid);
  fprintf (sendf, "#%-3d ", b->lifetime);

  if (transfer)
  { fprintf (sendf, "%%%s", dezasc (b->lines, 2));
    fprintf (sendf, "%s ", dezasc (nonlin(b->bytes), 3));
    fprintf (sendf, "=%s ", dezasc (b->binstart, 3));
  }
  else
    fprintf (sendf, "%%!!!!! =!!! "); // Set lines, bytes and bin-offset to 0

  fprintf (sendf, "|%c!!!!!!!!!!!!!!! \n", b->mailtype);

  while(strlen(b->destboxlist)<139)
    strcat(b->destboxlist,".");
  fprintf (sendf, "%s\n", b->destboxlist);

  for (i = 0; i < 252; i++) // Create an empty "Read:"-line
    fputc ('.', sendf);
  fputc ('\n', sendf);

  fprintf (sendf, "%s\n", b->betreff);

  if (!transfer)
  { // Look, if the title begins with "ACK:", as some systems don't support
    // "S(end)A(cknowledge)"
    if (strncmp(b->betreff, "ACK:", 4)==0 ||
        !(b->mailtype == 'A') || b->frombox[0] == 0)
      fprintf (sendf, "%s\n", makeheader (b->frombox[0] == 0));


    // do not generate any header-texts for wp-updates
    if (b->mailtype=='P' &&  strcmp (b->uplink, "Import") == 0 &&
        strcmp(b->betreff,"WP Update") == 0)
    { fprintf(sendf,"\n");
      return;
    }

    if (b->frombox[0] == 0)
    { if (b->forwarding == fwd_user)
        fprintf (sendf, "X-Info: User S&F received from %s at %s\n",
                 b->logincall, m.boxadress);
      else
      {
#ifdef __FLAT__
        if (!b->headermode)
#endif
        { fprintf (sendf, "From: %s @ %s", b->herkunft, m.boxadress);
          if (u->name[0])
            fprintf (sendf, "  (%s)", u->name);
          // Colon is set according to RFC 822 (OE3DZW)
          fprintf (sendf, "\nTo:   %s", b->ziel);
          if (b->at[0])
            fprintf (sendf, " @ %s", b->at);
          fprintf (sendf, "\n");
          if (u->mybbsok)
          { char my[HADRESSLEN + 1];
            strcpy (my, u->mybbs);
            if (strchr(my,'-'))   //remove optional SSID in address
              strchr(my,'-')[0] = 0;  
            expand_hadr (my, 3);
            if (strcmp (my, m.boxadress) != 0 &&
                strcmp (b->herkunft, m.boxname) != 0)
              fprintf (sendf, "Reply-To: %s @ %s\n", b->herkunft, my);
          }
        }
      }
      if (strcmp (b->uplink, "Import") == 0)
        fprintf (sendf, "X-Info: This message was generated automatically\n");
      else if (b->forwarding == fwd_none && 
               u->password[0] == 0 && u->loginpwtype!=100 &&
               !b->sysop &&
               t->socket == 0 && strcmp (b->uplink, "Mailsv") != 0)
        fprintf (sendf, "X-Info: No login password\n");
      else if (b->forwarding == fwd_user && 
               u->password[0] == 0 && u->sfpwtype!=100 )
        fprintf (sendf, "X-Info: No upload password\n");
      else if (b->http)
        fprintf (sendf, "X-Info: Received from %s by HTTP-frontend\n",
          b->peerip);
      if (strcmp (b->uplink, "Mailsv") == 0)
        fprintf (sendf, "X-Info: Mail generated by mailing list server\n");
#ifdef _EXDLOGIN
      if (b->guestlevel)
        fprintf (sendf, "X-Info: Mail was sent from a guest\n");
#endif	
#ifdef __FLAT__
      switch (b->headermode)
      {
      case _SMTP:
        fprintf (sendf, "X-Info: Received from %s by SMTP-gateway\n",b->peerip);
        break;

      case _NNTP:
        fprintf (sendf, "X-Info: Received from %s by NNTP-gateway\n",
          b->peerip);
        break;

      default:
        fprintf (sendf, "\n");
      }
#else
      fprintf (sendf, "\n");
#endif
    }
  }
}

/*---------------------------------------------------------------------------*/

void writelines (void)
//*************************************************************************
//
//  Writes length, number of lines and BIN-offset to a completely
//  received message
//
//*************************************************************************
{ char *pos;
  char save;
  FILE *sendf;

  sendf = s_fopen (b->mailpath, "sr+t");
  if (!sendf)
    trace (fatal, "writelines", "fopen %s errno=%d", b->mailpath, errno);

  fgets (b->line, 255, sendf);
  fseek (sendf, 0L, SEEK_SET);

  pos = strstr (b->line, " %");
  if (pos)
  { save = pos[7];
    sprintf (pos + 2, "%s", dezasc (b->lines, 2));
    sprintf (pos + 4, "%s", dezasc (nonlin(b->bytes), 3));
    pos[7] = save; // Overwrite 0-byte
  }

  pos = strstr (b->line, " =");
  if (pos)
  { save = pos[5];
    sprintf (pos + 2, "%s", dezasc (b->binstart, 3));
    pos[5] = save; // Overwrite 0-byte
  }

  fputs (b->line, sendf);
  s_fclose (sendf);
}

/*---------------------------------------------------------------------------*/

void writemailflags (void)
//*************************************************************************
//
//  Writes the 16 mail-flags into an existing mail
//
//*************************************************************************
{ char *strich;
  char save;
  char line[256];
  FILE *sendf;
  handle fh;

  strlwr (b->mailpath);
  if (!*b->mailpath)
    trace(replog,"writemailflags","no mailpath %s %s %s",
      b->herkunft,b->ziel,b->bid);
  sendf = s_fopen (b->mailpath, "sr+t");
  if (!sendf)
    trace (fatal, "writemailflags", "fopen %s errno=%d", b->mailpath, errno);

  fgets (b->line, 255, sendf);
  fseek (sendf, 0L, SEEK_SET);

  strich = strstr (b->line, " |");
  if (strich)
  { save = strich[18];

    sprintf (strich + 2, "%c%c%c%c%c",  //%c%c%c%c%c%c%c%c%c%c%c",
              b->mailtype, b->fwdhold, b->fwdprop, b->replied,
              b->msgty
    //   ,b->flag6,b->flag7,b->flag8,b->flag9,
    //   b->flaga,b->flagb,b->flagc,b->flagd,b->flage,
    //   b->flagf,b->flag0
      );
    strich[18] = save;
  }
  fputs (b->line, sendf);
  s_fclose (sendf);

  strlwr (b->listpath);
  if (!*b->listpath)
    trace(replog,"writemailflags","no listpath %s %s %s",
      b->herkunft,b->ziel,b->bid);
  fh = s_open (b->listpath, "sr+b");
  if (fh != EOF)
  {
    strupr (b->mailfname);
    seek_fname (fh, b->mailfname, line);
    if (line[0])
    {
      _read (fh, b->line, 128);
      b->line[61] = b->mailtype;
      b->line[62] = b->fwdhold;
      b->line[63] = b->fwdprop;
      b->line[64] = b->replied;
      b->line[65] = b->msgty;
      lseek (fh, -128L, SEEK_CUR);
      _write (fh, b->line, 128);
    }
    s_close (fh);
  }
}

/*---------------------------------------------------------------------------*/

long near writebin(char *binline, FILE *sendf)
{ char bincmd[BINCMDLEN];
  int a;
  off_t flen, len;
  char rxed_crc=0;
  unsigned short int rx_crc;
  crcthp crc;
  unsigned long int bps;
  time_t startt, rxtime;

  // Get the file length
  flen=len=atol(binline+5);

  // Get the CRC
  if(strstr(binline, "#|"))
  { rx_crc=(unsigned short int) atol(strstr(binline, "#|")+2);
    rxed_crc=1;
  }

  fflush(sendf);
  b->binstart=ftell(sendf);
  s_fclose(sendf);

  if(len)
  { if(b->forwarding==fwd_none)
    { putf("#OK#\n");
      putflush();
    }

    sendf=s_fopen(b->mailpath, "lr+b");
    s_fsetopt(sendf, 1);

    fseek(sendf, 0, SEEK_END);
    if(ftell(sendf)!=b->binstart)
      trace(serious, "writebin", "wrong filesize");
    memset(bincmd, 0, BINCMDLEN);
    fwrite(bincmd, BINCMDLEN, 1, sendf);

    startt=ad_time();

    while(len--)
    { a=getv();
      fputc(a, sendf);
      crc.update(a);
      if((len&511)==0 && b->forwarding!=fwd_none)
        timeout(m.fwdtimeout);
    }

    // DH3MB: The #BIN#-header will be written to the mail file
    // without any changes; only a CRC will be inserted, if the
    // #BIN#-header sent by the user/forward-partner did not include one

    if(rxed_crc)
      snprintf(bincmd, BINCMDLEN, "%s\n", binline);
    else
    { if(!strchr(binline+5, '#'))
        snprintf(bincmd, BINCMDLEN, "%s#|%05d\n", binline, crc.result);
      else
      { *strchr(binline+5, '#')=0;
        snprintf(bincmd, BINCMDLEN, "%s#|%05d#%s\n", binline, crc.result,
                                    binline+strlen(binline)+1);
      }
    }

    fseek(sendf, b->binstart, SEEK_SET);
    fwrite(bincmd, BINCMDLEN, 1, sendf);

    s_fclose(sendf);

    if(rxed_crc && rx_crc!=crc.result)
    { flen=0;
      if(b->forwarding!=fwd_none && !(b->opt&o_f)) // Only in ASCII-fwd!
        putf("|");
      if(b->forwarding==fwd_none)
        putf("\nCRC-Error\n");
    }
    else
      if(b->forwarding==fwd_none)
      { rxtime=ad_time()-startt;
        if(rxtime==0)
          rxtime=1L;
        bps=flen/rxtime;
        putf("\nBIN-RX OK (CRC: %u/%04Xh, %lu bit/s, %lu byte/s)\n",
             crc.result, crc.result, bps*8L, bps);
      }
  }

  if(b->inputfile  // DG9MHZ
#ifdef _FILEFWD
     && b->forwarding!=fwd_file
#endif
    )
  { s_fclose(b->inputfile);
    b->inputfile=NULL;
    t->input=(io_t)b->oldinput;
  }

  return flen;
}

/*---------------------------------------------------------------------------*/

static void near put_rejectlog(char * reason)
{   //write reject-reason to logfile, OE3DZW

/*
Date/Time         From   To       BBSFro BID          Reason
*/

 handle fh;
 char buf[120];

 fh=s_open(TRACEPATH"/"REJECTLOGNAME,"sab");
 if (fh==EOF)
   fh=s_open(TRACEPATH"/"REJECTLOGNAME,"swb");  
 if(fh!=EOF)
 { sprintf(buf,"%s %c %-6s>%-8s@%.22s~%-6s$%-12s %s"NEWLINE,
   zeitstring(ad_time(),1),
   b->mailtype,b->herkunft,b->ziel,b->at,b->frombox,b->bid,reason);   
   _write(fh,buf,strlen(buf));
   s_close(fh);
 }
 return;
}

/*---------------------------------------------------------------------------*/

static int writetext(FILE *sendf)
//*************************************************************************
//
//  Gets the text from the current input and stores it into a mail file
//
//  Returns 1, if a ACK-message should be generated, 0 otherwise
//
//*************************************************************************
{ char *eof=NULL;
  char *line=b->line;
  int scanr=1;
  char headeradress[HADRESSLEN + 1] = {0};
  char rline[128]="";
  char *adrp;
  int hops=0;
  int invalid=0;
  int broken7p=0;
  int send_ack=0;
  char linestart=1; // DG4MMI: We are at the beginning of a new line
  int inside7p=0;   // inside a 7p-encoded file
  b->binstart=0;
  b->bytes=0;
  b->lines=0;
  line[251]=0;  //we never know what will happen..
  b->msgty='!'; //msgtype is not known
  int no_import=strcmp(b->uplink,"Import");

  do
  { waitfor (e_ticsfull);

    if(!getline(line,250,0)) // DG4MMI: feof(b->inputfile) is checked
      eof=line;
    
    { char *a;
      if ((a=strstr(line,"\r"))!=0)
      { *a='\n';
        *(a+1)=0;
      }
    }
    if (b->forwarding==fwd_none && strchr(line, CTRLX)) // Received Ctrl-X
    { b->bytes=0;
      b->lines=0;
      if(sendf)
        s_fclose(sendf);
      return(0);
    }

    if (linestart)
    {
      // OE3DZW: ACK-messages only on personal mails
      if(stricmp(line, "/ack\n")==0 && (b->mailtype=='P'))
        send_ack=1;

      if (inside7p)
      { if (strstr(line,STOP7PFLAG)==line)
        { inside7p=0;
          if (!broken7p)
          { b->msgty='7';
          }
        }
        else
        {
          if (!line_7p(line))
            broken7p=1;
        }
      }
      else
        if (strlen(line) == 70 && strstr(line,START7PFLAG)==line)
        { inside7p=1;
        }
    }

    if(!eof)
      eof=strchr(line, CTRLZ); // Received Ctrl-Z

#ifdef _FILEFWD
    if(b->forwarding == fwd_file && strcmp(line,"/EX\n")==0)
      eof=line;
#endif

    // Received an end-of-mail-specifier
    if(b->forwarding==fwd_none)
    { if (no_import)
      { // DG4MMI: "NNNN" or "nnnn" at end of line
        if(!eof)
          eof=strstr(line,"nnnn\n");
        if(!eof)
          eof=strstr(line,"NNNN\n");

        // DG4MMI: "***END" at end of line, ignore case
        if(!eof)
          eof=stristr(line, "***end\n");

        // DG4MMI: "/EX" at beginning of line, ignore case
        if(linestart && stricmp(line, "/EX\n")==0)
          eof=line;
      }
      else  //on import "nnnn" is only accepted at start of a new line
        if (linestart && strcmp(line,"nnnn\n")==0)
          eof=line;
    }

    if(eof)
    { *eof=0;
      if(line[0] && sendf)
        fputs(line, sendf);
    }
    else
    { // OE3DZW: Attach a file to the mail as BIN-part (modified by DG4MMI)
      if(linestart && b->sysop && strncmp(line, ".attach ", 8)==0 &&
         b->forwarding==fwd_none && t->input!=io_file)
      { char attachname[FNAMELEN+1]; // DG4MMI
        char timestring[9]; // DG4MMI
        if(strchr(line,'\n'))
          *strchr(line,'\n')=0;
        if(strrchr(line+8,'/')) // DG4MMI
          strncpy(attachname, strrchr(line+8,'/')+1, FNAMELEN);
        else
          strncpy(attachname, line+8, FNAMELEN);
        attachname[FNAMELEN]=0;
        b->inputfile=s_fopen(line+8, "lrb");
        if (b->inputfile)
        { fseek(b->inputfile, 0L, SEEK_END);
          unsigned long int binsize=ftell(b->inputfile);
          rewind(b->inputfile);
          time_unix2dos(filetime(line+8),timestring);
          waitfor(e_ticsfull);
          sprintf(line, "#BIN#%05lu#$%s#%s\n", binsize, timestring, attachname);
          b->oldinput=t->input;
          t->input=io_file;
          waitfor(e_ticsfull);
        }
        else
        { strcpy (line, "");
          putf("*** file not found\n");
        }
      }

      if(linestart && strncmp(line, "#BIN#", 5)==0)
        // do NOT send binary personal messages to a fbb-bbs
        // it turned out that this bbs is not able to deal 
        // with such messages correctly
      { if(boxbinok(0) && isdigit (line[5]))
        { if(strchr(line, '\n'))
            *strchr(line, '\n')=0;
          b->bytes=writebin (line, sendf);
          if ((b->bytes==0) && (b->forwarding == fwd_standard))
            put_rejectlog("bin crc");
          //   b->msgty='b';  // 'b' autobin
          eof = line;
          line[0] = 0;
          sendf = NULL;
        }
        else
          fprintf(sendf, " %s", line);  // replace "#BIN#" by " #BIN#"
      }
      else
      { if(linestart && stristr(line, "//e")==line)
          line[0] = '\\';
        if(scanr && b->forwarding==fwd_user)
        { if(line[0]!='R' || line[1]!=':')
            scanr=0;
        }
        if(!(scanr && b->forwarding==fwd_user) && sendf)
          fputs (line, sendf);
        if(scanr && (b->forwarding==fwd_standard
#ifdef _FILEFWD
           || b->forwarding==fwd_file
#endif
           ))
        { adrp = getheaderadress (line);
          if (adrp)
          { strcpy (headeradress, adrp);
            if (!b->usermail && strcmp (adrp, m.boxadress) == 0 && line[13] == 'z')
            { if (strcmp (b->logincall, m.boxname) != 0)
                invalid = 1;
              trace (report, "writetext", "loop %s>%s $%s",
                     b->herkunft, b->ziel, b->bid);
            }
            if (rline[0])
              update_hadr (rline, hops, 0);
            hops++;
            strncpy (rline, line, 127);
            rline[127] = 0;
          }
          else
          { if (rline[0])
              update_hadr (rline, hops, 1);
            scanr = 0;
            b->bytes = 0;
            b->lines = 0;
            if(strncmp(line, "From: ", 6)==0 || strncmp(line, "de ", 3)==0)
            { char *kl = strchr (line, '(');
              if (kl && strchr (kl, ')') && strstr (line, b->herkunft))
              { char n[NAMELEN + 1];
                int i = 0;
                kl++;
                n[0] = 0;
                while (i < NAMELEN && (kl[i] > '@' || kl[i] == ' ' || kl[i] == '-'))
                { n[i] = kl[i];
                  n[++i] = 0;
                }
                if (strlen (n) > 1)
                  set_name (b->herkunft, n);
              }
            }
          }
        }
      }
    }

    b->bytes+=strlen(line);

    if (b->forwarding != fwd_none)
      timeout (m.fwdtimeout);

    if(line[strlen(line)-1]=='\n') // DG4MMI
    { b->lines++;
      linestart=1;
    }
    else
      linestart=0;
  }
  while (!eof);

  if(sendf && eof!=line)
  { b->lines++;
    b->bytes++;
    fprintf(sendf, "\n");
  }

  if(sendf)
    s_fclose (sendf);

  if (broken7p)
  { 
    trace(report,"writetext","bad7+ %s>%s $%s",b->herkunft,b->ziel,b->bid);
    b->msgty='6';   //its a broken 7+ file  (7-)
    if (b->forwarding==fwd_none)
    {  putf("Sorry, this 7+ file is not correct!\n");
       invalid=1;
    }
    if (b->mailtype=='B' && ( m.savebroken==0 ||
         (m.savebroken==1 && !(b->opt & o_b))))
    { invalid=1;
      put_rejectlog("bad 7+");
    }
  }

  if (invalid)
  { b->bytes = 0;
    b->lines = 0;
  }
  else
  { if (mbhadrok (headeradress) == 1)
      get_mybbs (b->herkunft, headeradress, 2);
  }

  return send_ack;
}

/*---------------------------------------------------------------------------*/

static void near putno (char *reason)
//*************************************************************************
//
//  Defers the message with "NO - ..."
//
//*************************************************************************
{
  if (strcmp(b->uplink,"Import")==0)
    trace(fatal,"putno","bad import file, %s",reason);

  if (b->forwarding == fwd_none)
  { if (reason && reason[0])
      putf ("No, %s\n", reason);
  }
  else
  { if (reason)
    { strupr(reason);
      fwdput("NO - ", reason);
    }
    else
      fwdput("NO","");
  }
}

/*---------------------------------------------------------------------------*/

static void near putrej (char *reason)
//*************************************************************************
//
//  Defers the message with "REJ - ..."
//
//*************************************************************************
{
  if (strcmp(b->uplink,"Import")==0)
    trace(fatal,"putrej","bad import file,%s",reason);
 if (reason && reason[0])
  { strupr(reason);
    fwdput("REJ - ", reason);
  }
  else
    fwdput("REJ","");
}

/*---------------------------------------------------------------------------*/

static void near putlater (char *reason)
//*************************************************************************
//
//  Tells the forward-partner to send the mail again later
//
//*************************************************************************
{
  if (strcmp(b->uplink,"Import")==0 ||
      strcmp(b->uplink,"Mailsv")==0)
    trace(fatal,"putlater","failed to import, %s",reason);

  if (reason && reason[0])
  { strupr(reason);
    fwdput("LATER - ", reason);
  }
  else 
    fwdput("LATER","");
}

/*---------------------------------------------------------------------------*/

static void near putok (void)
//*************************************************************************
//
//  Accepts the message
//
//*************************************************************************
{ if(b->forwarding!=fwd_none)
    fwdput("OK", "");
}

/*---------------------------------------------------------------------------*/

void save_em (void)
//*************************************************************************
//
//  Wertet eine E (Erase) oder M (Mybbs) Meldung aus
//
//*************************************************************************
{ 

  if (!b->bid[0] || bidvorhanden(b->bid))
    return;

  if (strlen (b->betreff) > 75)
    return;

  strupr (b->betreff);

  if (b->ziel[0] == 'M')
  { time_t mybbszeit=atol(blankweg(b->betreff));
    if (mybbszeit > 721000000L)
    {
#ifdef _BCMNET_FWD
      if (is_bcmnet_bid (b->bid, 1)==1) return; //ignore MYBBS correction
#endif
      set_mybbs (b->herkunft, b->betreff, mybbszeit, b->bid,"?",0,NULL);
    }
  }
  else if (b->ziel[0] == 'E')
    remeraser("THEBOX",b->bid,b->herkunft,b->betreff,b->logincall,
     "?",0,"?");
}

/*---------------------------------------------------------------------------*/

static int near diskfull (void)
{ int full = 0;
  if (b->usermail)
    full=(dfree (m.userpath, 0) < USERDISKFULL);
  else
    full=(dfree (m.infopath, 0) < INFODISKFULL);

  if(full)
  { if (!m.disable)
     trace(serious,"diskfull","disabled, disk full");
    m.disable=1;
    if (b->forwarding != fwd_none)
      fwdlog ("disk is full", "", 'S');
    return 1;
  }
  return 0;
}

/*---------------------------------------------------------------------------*/

void add_unknown(void)
//*************************************************************************
//
//  Creates an entry in "unknown.bcm"
//  Generates a message to the sender if appropriate
//
//*************************************************************************
{ char sendcmd[80];
  char content[255];

  if (returnmailok()) 
  { sprintf (sendcmd, "SP %s < %s UNKNOWN:%.30s", b->herkunft,
             m.boxname, b->betreff);
    sendcmd[79]=0;
    sprintf (content, 
     "Your msg for %s @ %s $%s\ncould not be forwarded at %s.\n",
             b->zielboard, b->at, b->bid, m.boxname);
    genmail (sendcmd, content);
  }

  FILE *f = s_fopen (TRACEPATH "/" UNKNOWNNAME, "sab");
  if (!f)
    f=s_fopen (TRACEPATH "/" UNKNOWNNAME,"swb");
  if (f)
  { fprintf (f, "%s %s ", datestr (ad_time (), 1), timestr(ad_time (),1));
    fprintf (f, "%6s: %-6s > %-8s @", b->logincall, b->herkunft, b->zielboard);
    fprintf (f, "%-10s %.22s"NEWLINE, b->at, b->betreff);
    s_fclose (f);
  }
}

/*---------------------------------------------------------------------------*/

void generate_ack (char *to, char *from, char *subj)
//*************************************************************************
//
//  Creates an "ACK: ..."-message
//
//*************************************************************************
{ if (returnmailok())
  { char sendcmd[80];
    char content[80];
    sprintf (sendcmd, "SA %s < %s ACK:%.30s", to, m.boxname, subj);
    sprintf (content, "%s @ %s acknowledged (%s %s)",
             from, m.boxadress, datestr (ad_time (), 2), timestr(ad_time (),1));
    genmail (sendcmd, content);
  }
}

/*---------------------------------------------------------------------------*/

int searchreject (void)
//*************************************************************************
//
//  Scans "reject.bcm" for a match with the message-data. Returns:
//    0 = Message must be accepted (and forwarded if necessary)
//    1 = Message must be rejected
//    2 = Message must be set on hold
//    3 = Message must be set on hold, if entered locally
//    4 = Message must be set on hold, if entered locally without a password
//
//  (DG4MMI, based on searchbadname())
//  (DG9MHZ, added RegEx);
//
//*************************************************************************
{ FILE *f = s_fopen (REJECTNAME, "srt");
  char buf[80];
  char s[80];
  char *t;
  char *p;
  char c;
  char retval=0, match=0;
  CRegEx reg;

  if (f == NULL)
    return 0;
  while (!feof (f))
  { p = fgets (s, 79, f);

    if (p == NULL || (*p == ';') || (*p == 0) || strlen(p)<3)
      continue;

    subst (p, ';',0);  
    subst (p, 10, 0);
    subst (p, 13, 0);
    subst (p,CTRLZ,0);

    switch (p[0] & 0x5f)
    {
    case 'R':
      retval = 1;
      break;

    case 'H':
      retval = 2;
      break;

    case 'L':
      retval = 3;
      break;

    case 'P':
      retval = 4;
      break;

    default:
      trace (replog, "searchreject", "action %c invalid", *p);
      retval = 0;
      break;
    }
    p++;
    //p+=blkill(p);
    t = strtok (p, " ");
    while (t != NULL)
    { if (!t[0])
        break;
      c=t[0];

      if(t[1]==0)
      {
        t = strtok (NULL, " ");
        if(!t[0])
          break;
      }
      waitfor(e_ticsfull);
      switch (c)
      {
      case '<':		// Sender
        sprintf(buf,"%s\n",b->herkunft);
        match = reg.regex_match (t + 1, buf);
        break;

      case '>':		// Destination (Board/Call)
        sprintf(buf,"%s\n",b->ziel);
        match = reg.regex_match (t + 1, buf);
        break;

      case '$':		// BID
        sprintf(buf,"%s\n",b->bid);
        match = reg.regex_match (t + 1, buf);
        break;

      case '@':		// Address 
        sprintf(buf,"%s\n",b->at);
        match = reg.regex_match (t + 1, buf);
        break;

      case '.':		// Type (Bulletin/Personal)
        sprintf(buf,"%c\n",b->mailtype);
        match = reg.regex_match (t + 1, buf);
        break;
      }
      if (!match)
        break;
      t = strtok (NULL, " ");
    }
    if (match)
      break;
  }
  s_fclose (f);

  if (match)
    return retval;
  else
    return 0;
}

/*---------------------------------------------------------------------------*/

void convat(char *adr)
//converts address of bulletins
{
  FILE *f = s_fopen (CONVATNAME, "srt");
  char buf[80];
  char *p;
  char oldat[HADRESSLEN+1];

  if (f == NULL)
    return;
  while (!feof(f))
  { p=fgets(buf,79,f);
    if (p==NULL)
      continue;
    subst(p,';',0);
    subst(p,10,0);
    subst(p,13,0); 
    if (strlen(p) < 2)
      continue;
    while (*p == ' ')
      p++;
    p=nexttoken(p,oldat,HADRESSLEN);
    while (*p == ' ')
      p++;
    //same address?
    if (stricmp(oldat,adr)!=0||strlen(p)>HADRESSLEN)
      continue;
    nexttoken(p,adr,HADRESSLEN);
    strupr(adr);
    if (b->forwarding==fwd_none)
      putf("Converting: %s -> %s\n",oldat,adr);
  }
  s_fclose(f);
}
/*---------------------------------------------------------------------------*/

static char near testmaildirectory(void)
//*************************************************************************
//
//  Returns: 0 .. board not wanted
//           1 .. board accepted
//
//  19990816 DH3MB: Restructured the code; not using "dirok" anymore,
//                  directly using return; returning 0 instead of 2
//
//*************************************************************************
{ char i;
  unsigned cbd;

  if(finddir(b->zielboard,b->sysop))
   return 1; // DH3MB: Board exists, so we will accept the mail

  for(i=0;b->zielboard[i];i++)
    if(!isalnum(b->zielboard[i]) &&
       b->zielboard[i]!='_' && b->zielboard[i]!='-')
      return 0; // DH3MB

  cbd=m.createboard;
  if((b->forwarding==fwd_none || b->forwarding==fwd_user) && (cbd>1))
    cbd=0;

  switch (cbd)                                         
  {
  case 2L: // Sysop doesn't want any TMP-Board
    return 0;

  case 1L: // TMP-Board + Sub-Boards
    if(!finddir("TMP",b->sysop) && mkboard("/","TMP",0)!=0)
      return 0;
    else
    { if(mkboard("TMP",b->zielboard,0)==0)
        return 1;
      else
        return 0;
    }

  case 0L: // TMP-Board yes, but no Sub-Boards
  default:
    if(!finddir("TMP",b->sysop) && mkboard("/","TMP",0)!=0)
      return 0;
    else
    { strcpy(b->zielboard,"TMP");
      return 1;
    }
  }
}

/*---------------------------------------------------------------------------*/

#ifdef _BCMNET_FWD
int is_bcmnet_bid(char *bid, int cflag)
//*************************************************************************
//
// Checks the BID/MID if it is a valid CB-BCMNET BID/MID
//
// bid     the bid that should be checked
// cflag   0 : normal bid
//         1 : correction bid
//
//*************************************************************************
{ if(   (strlen(bid) == 12)                   //12 chars long
     && (bid[1] >= 'D' && bid[1] <= 'Z')      //year between 2003..2026
     && (   (bid[2] >= '1' && bid[2] <= '9')  //month between 1..
         || (bid[2] >= 'A' && bid[2] <= 'C')) //               ..12
     && (   (cflag == 0 && bid[9] == '_')     //underscore
         || (cflag == 1 && bid[9] == '='))    //equal sign
    )
    return YES;
  return NO;
}
#endif

/*---------------------------------------------------------------------------*/

char wantmail(char *reason)
//*************************************************************************
//
//  Checks if we accept a mail, or not and returns reason why
//
//*************************************************************************
{ char mybbs[HADRESSLEN+1]="";
  char usermail;
  char retval;

  if(reason)
    reason[0]=0;

  usermail=(char)mbcallok(b->ziel);

  // In User-S&F-mode we only accept messages from the uplink call
  if(b->forwarding==fwd_user && strcmp(b->herkunft,b->logincall)!=0)
  { if(reason)      
      strcpy(reason,"only from login call");
    retval=FBB_REJECT;
    goto notwanted;
  }

  // National Traffic Services are not supported  
  if(b->mailtype=='T')
  { if(reason)
      strcpy(reason,"NTS not supported");
    retval=FBB_REJECT;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  // Ack-mails are only accepted in forward-mode, otherwise a message
  // without routing-information would be created
  if ((b->mailtype=='A') && !b->sysop && (b->forwarding==fwd_none))
  { if(reason)
      strcpy(reason,"SA not allowed");
    retval=FBB_REJECT;
    goto notwanted;
  }

  // No destination specified
  if(!b->ziel[0])
  { if(reason)
      strcpy(reason,"destination missing"); // DH3MB: "call" -> "destination"
    retval=FBB_REJECT;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  // We won't accept messages destined to an unknown user, if the sender
  // doesn't specify an destination-BBS
  // but in userfwd?
  if(usermail)
  { get_mybbs(b->ziel,mybbs,0);
    if(b->forwarding==fwd_none && (!b->at[0]) && !mybbs[0])
    { if(reason)
        strcpy(reason,"user unknown");
      retval=FBB_REJECT;
      goto notwanted;
    }
  }

#ifdef _GUEST
  // Guests aren't allowed to send except  mails to the sysop.
  if(strcmp(b->herkunft,m.guestcall)==0 &&
     !strcmp(b->ziel,m.sysopcall)==0 &&
     !strcmp(b->ziel,"SYSOP")==0)                 
  { if(reason)                                     
      strcpy(reason,"guest");                    
    retval=FBB_REJECT;                             
    goto notwanted;
  }                                                 
#endif

  waitfor(e_ticsfull);

  // Did the user exceed his quota?
  if(b->forwarding!=fwd_standard && (b->mailtype=='B') && checkquota())
  { if(reason)
      strcpy(reason,"user quota exceeded");
    retval=FBB_LATER;
    goto notwanted;
  }

  // Is the disk full?
  if(diskfull())
  { if(reason)
      strcpy(reason,"disk is full");
    retval=FBB_LATER;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  // If the mail-files are beeing purged, no send is possible
  if((sema_test("sendlock") || m.disable) && !usermail)
  { if(b->forwarding!=fwd_none || strcmp(b->uplink,"Import") ||
       strcmp(b->uplink,"Mailsv"))
    { while(sema_test("sendlock") || m.disable)
	wdelay(2330);
    }
    else
    { if(reason)        
        strcpy(reason,"mails are beeing purged");
      retval=FBB_LATER;
      goto notwanted;
    }
  }

  // Check, if the sysop wishes to reject the mail
  if(searchreject()==1)
  { if(reason)      
      strcpy(reason,"found in reject list");
    retval=FBB_REJECT;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  // Usermails may not be addressed to a bulletin address
  // execpt personal mails to "SYSOP" 
  if(!(b->mailtype=='B') && b->at[0] && mbhadrok(b->at)!=1 &&
      (strcmp(b->ziel,"SYSOP")!=0))
  { if(reason)
      strcpy(reason,"invalid address");
    retval=FBB_REJECT;
    goto notwanted;
  }

  // We don't allow a bulletin to an user
  if((b->mailtype=='B') && mbcallok(b->ziel))
  { if(reason)
      strcpy(reason,"bulletin to user");
    retval=FBB_REJECT;
    goto notwanted;
  }

  waitfor(e_ticsfull);

/*
  // Is the source call valid?
  if(!mbcallok(b->herkunft)) 
  { if(reason)
      strcpy(reason,"invalid source call");
    retval=FBB_REJECT; 
    goto notwanted;
  }
*/

  // If a mail is addressed to the local SYSOP-board, we will deliver
  // it directly to the sysop (the one specified in init.bcm)
  if (strcmp(b->zielboard,"SYSOP")==0)
  { char atl[HADRESSLEN+1];
    strcpy(atl,b->at);
    expand_hadr(atl,3);
    if(!atl[0] || strcmp(atl,m.boxadress)==0)
    { usermail=1;
      strcpy(b->zielboard,m.sysopcall);
      b->mailtype='P';
    }
  }

  waitfor(e_ticsfull);

  // We only accept mails to "one-letter-boards" from a forward-partner
  // and from sysops
  if(strlen(b->zielboard)==1 && !b->sysop && b->forwarding!=fwd_standard)
  { if(b->forwarding==fwd_none)
      putf(ms(m_adrnotpossible),b->ziel);
    else
      if(reason)
        strcpy(reason,"board not wanted");

    retval=FBB_REJECT;
    goto notwanted;
  }

  if (bidvorhanden(b->bid))
  { if(reason)
      strcpy(reason,"BID already received");
    retval=FBB_NO;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  if(tmpbidvorhanden(b->bid))
  { if(reason)
      strcpy(reason,"already receiving BID");
    retval=FBB_DEFER;
    goto notwanted;
  }

/* 
  weiterleiten(1,b->ziel);

  // If the only route for the message leads back to the BBS, which the mail
  // is coming from, we will defer it
  if(b->forwarding==fwd_standard && strstr(b->destboxlist,b->logincall) &&
     strlen(b->destboxlist)<9  && b->mailtype!='B')
  { if(reason)
      strcpy(reason,"loop");
    retval=FBB_REJECT;
    goto notwanted;
  }
*/

  if(!testmaildirectory())
  { if(reason)
      strcpy(reason,"board not wanted");
    retval=FBB_REJECT;
    goto notwanted;
  }

  waitfor(e_ticsfull);

  finddir(b->zielboard,b->sysop);

  if(xmkdir(b->boardpath)!=0)
  { trace(serious,"wantmail","mkdir %s error",b->boardpath);
    if(reason)
      strcpy(reason,"invalid board name");
    retval=FBB_REJECT;
    goto notwanted;
  }

  if(b->mailtype=='B' && mbhadrok(b->at)==2 &&
     b->forwarding==fwd_none || 
     b->forwarding==fwd_user)
    convat(b->at);

  return FBB_ACCEPT;

notwanted: // DH3MB: No, I don't like labels, but...

  // If we will reject the mail, we put a note into the reject log
  if(retval==FBB_REJECT)
  { if(reason)
      put_rejectlog(reason);
    else
      put_rejectlog("-");
  } 

  // If the partner does not support extended reject-messages
  if((b->forwarding!=fwd_none) && !(b->opt&o_r))
    switch(retval)
    {
    case FBB_LATER:
    case FBB_DEFER:
      if(b->opt&o_f)
        retval=FBB_DEFER;
      else
        retval=FBB_NO;
      break;

    case FBB_REJECT:
    case FBB_ERROR:
      retval=FBB_NO;
      break;

    case FBB_HOLD:
      retval=FBB_ACCEPT;
      break;
    }

  if(b->forwarding==fwd_none && retval!=FBB_ACCEPT)
    retval=FBB_NO;

  return retval;
}

/*---------------------------------------------------------------------------*/

#ifdef MAILSERVER

void launch_mailserver(char *)
//*************************************************************************
//
//  Checks, if a mail destined to the BBS-call contains a command for the
//  mailing list server
//
//*************************************************************************
{ mailserv ma;
  ma.examine_mail();
}

#endif

/*---------------------------------------------------------------------------*/

void savemail(void)
//*************************************************************************
//
//  Saves a mail to a file to the bcm mail-tree
//
//*************************************************************************
{ char name[]="savemail";
  FILE *f;
  int nummer=0;
  char send_ack=0;
  int index;
  int fwdmode=weiterleiten(1, b->ziel);

  testmaildirectory();
 
  //make sure that board exists
  if(xmkdir(b->boardpath)!=0)
  { trace(fatal,name,"mkdir %s error",b->boardpath);
  }

  make_mask (b->mailpath, b->boardfullname);
  strcpy (b->mask, b->mailpath);
  strcpy (b->mailfname, time2filename (0));
  if (!strstr (b->mailpath, "*.*"))
    trace (fatal,name, "mask %s", b->mailpath);
  strcpy (strstr (b->mailpath, "*.*"), b->mailfname);
  strlwr (b->mailpath);

  f=s_fopen(b->mailpath, "lw+t");
  if(f)
  { s_fsetopt(f, 1);

    writeheader(f, 0);
    waitfor(e_ticsfull);

    send_ack=writetext(f); // mailfile is closed within writetext()
    waitfor(e_ticsfull);

    writelines();
    waitfor(e_ticsfull);

    if(b->bytes > 0)
    { if(fwdmode==unbekannt && b->at[0])
        add_unknown();

      nummer=appenddirlist ();
      writemailflags();

      waitfor(e_reschedule);

      add_fwdfile(b->logincall, get_fdelay (b->herkunft));
    }

    if(nummer)
    { if(b->forwarding==fwd_none)
      { if(b->binstart)
        { if (b->bytes < 1000000L)
            putf("%ld Bytes, ", b->bytes);
          else
            putf("%ld kBytes, ", b->bytes/1024L);
        }    
        putf(ms(m_linesfor), b->lines, b->boardfullname);
        if(b->at[0])
          putf("@ %s ", b->at);
        putf("(%i) ",nummer);
        putf(ms(m_stored));
        waitfor(e_ticsfull);
      }

      index=finddir(b->zielboard,b->sysop)-1;
      if (index>=0)
        tree[index].newestmail=ad_time();
      waitfor(e_ticsfull);

      inc_mailgot(b->boardname);
      waitfor(e_ticsfull);

      inc_mailsent(b->herkunft);

      if(b->usermail)
      { sprintf(b->line, "%s %u", b->herkunft, nummer);
        mbtalk("\001", b->zielboard, b->line);
        trigger_ufwd(b->zielboard);
      }

      b->sentfiles++;

      if(fwdmode==bleibtliegen && send_ack)
        generate_ack(b->herkunft, b->ziel, b->betreff);

      mk_perform (MK_MAILFROM, b->herkunft);
      mk_perform (MK_MAILTO, b->zielboard);

      scan_wp(); 


      #ifdef MAILSERVER // DG4MMI
      if ((strcmp(b->ziel, m.boxname)==0) && m.maillistserv)
        fork(P_BACK | P_MAIL | P_CLON, 0, launch_mailserver, "MailServ");
      #endif

      #ifdef TELLSERVER // DG4MMI
      if(m.tellserver && strcmp(b->ziel,"T")==0 && !b->at[0])
        fork(P_BACK | P_MAIL | P_CLON, 0, launch_tellserver, "TellServ");
      #endif
    }
    else
    { xunlink (b->mailpath);
      if(b->forwarding==fwd_none)
        putf(ms(m_nomessagestored));
    }
  }
  else
    trace (fatal,name, "fopen %s errno=%d", b->mailpath, errno);
}

/*---------------------------------------------------------------------------*/

void update_mail(void)
//*************************************************************************
//
// Updates Address and/or call of a mail received in forward
//
//*************************************************************************
{
  char name[]="update_mail";

  // If user has a new call -> update  at, ziel
  char newcall[CALLEN+1];

  if ((b->forwarding!=fwd_none && 
      ((strcmp(atcall(b->at), m.boxname)==0) || (!*b->at)) ||
      b->forwarding==fwd_none) &&
      b->mailtype=='P' && get_newcall(b->ziel,newcall))
  { trace(report,name,"%s new call %s ($%s)",b->ziel,newcall,b->bid);
    //send a mail to sender to prevent missuse
    if (b->forwarding!=fwd_none) 
    { if (returnmailok())
      { char sendcmd[80];
        char content[255];
        sprintf(sendcmd,"SP %s < %s New call: %s -> %s",b->herkunft,
           m.boxname,b->ziel,newcall);
        sprintf(content,
        "The new callsign of %s is %s.\nYour msg $%s will be sent to %s.\n",
           b->ziel,newcall,b->bid,newcall);
        genmail(sendcmd,content);
      }
    }
    else
      putf("New call: %s -> %s\n",b->ziel,newcall);      
    strcpy(b->ziel,newcall);     
    strcpy(b->zielboard,newcall);
    b->at[0]=0;
    // Message may go back..
    strcpy(b->bid,newbid(0));
  }

  // If we receive a mail addressed to us in S&F, we will throw
  // away the address, so that the message will be forwarded to the
  // user's MYBBS
  if (b->forwarding!=fwd_none && 
      ((strcmp(atcall(b->at), m.boxname)==0) || (!*b->at)))
  { b->at[0] = 0;  //change bid if address is changed
    if (weiterleiten(0,b->ziel)==bekannt)
    { strcpy(b->bid,newbid(0));
      trace(report,name,"new adr %s@%s $%s",
        b->ziel,b->at,b->bid);
    }
  }

  return;
}

/*---------------------------------------------------------------------------*/

int mbsend(char *befbuf, int changedir)
//*************************************************************************
//
//  SEND-procedure (used for normal box-logins and (user-)ascii-forwarding,
//  but NOT for fbb-type forwarding !!!
//
//  Returns: 0 = Not accepting mail
//           1 = Mail has been saved
//
//*************************************************************************
{ int fwdmode;
  char rejreason[40]; // TODO: Use snprintf when writing to this var

  waitfor(e_reschedule);

  mbsend_parse(befbuf, 1);
  update_mail();
  waitfor(e_ticsfull);

  if((b->forwarding==fwd_standard
#ifdef _FILEFWD
      || b->forwarding == fwd_file
#endif
     ) &&
     ((strcmp("M", b->ziel)==0) || (strcmp("E", b->ziel)==0)))
  { if(b->betreff[0] == 0)
    getline(b->betreff, 80, 1);

    putok();

    if(strchr(b->betreff, CTRLZ) == NULL)
      do
        getline(b->line, 40, 1);
      while(strchr (b->line, CTRLZ) == NULL
#ifdef _FILEFWD
            || (b->forwarding == fwd_file && strncmp(b->line,"/EX",3)!=0)
#endif
           );

    save_em();
    return 1;
  }

  switch(wantmail(rejreason))
  {
  case FBB_REJECT:
    putrej(rejreason);
#ifdef _FILEFWD
    if(b->forwarding == fwd_file)
      writetext(NULL);
#endif
    return 0;

  case FBB_DEFER:
    putlater(rejreason);
#ifdef _FILEFWD
    if(b->forwarding == fwd_file)
      writetext(NULL);
#endif
    return 0;

  case FBB_ACCEPT:
    if (!tmpbidvorhanden(b->bid))
    { tmpbidrein(b->bid,0);
      putok();
      break;
    } 
    // fall through

  case FBB_NO:
    putno(rejreason);
#ifdef _FILEFWD
    if(b->forwarding == fwd_file)
      writetext(NULL);
#endif
    return 0;
  }

  fwdmode=weiterleiten(1, b->ziel);

  finddir(b->zielboard,b->sysop);

  if(changedir)
    strcpy(b->prompt, b->boardfullname);

  if(b->forwarding != fwd_none)
  { char *bf1 = befbuf;
    getline(befbuf, 79, 1);
 /* if (b->forwarding != fwd_none && (b->boxtyp == b_dxl))
    { if (strstr (befbuf, "0 ") == befbuf)
        bf1 += 2;
      if (strstr (befbuf, "#0 ") == befbuf)
        bf1 += 3;
    }
 */
    strcpy(b->betreff, bf1);
  }
  else
  { if ((fwdmode == bleibtliegen) && (b->at[0] == 0) &&
        (strcmp(atcall(b->at), m.boxname) == 0))
      putf(ms(m_messagenotforward));
    else if(fwdmode == unbekannt)
      putf(ms(m_forwardunknown));

    if(b->betreff[0] == 0)
    { do
      { putf(ms(m_title));
        getline(befbuf, 79, 1);
        putv ('\n');
        if (strchr(befbuf, CTRLZ) || strchr(befbuf, CTRLX))
          return 0;
      }
      while(strlen(befbuf) < 2);
      strcpy(b->betreff, befbuf);
    }

#ifdef _SENDLT		//db1ras
    if (!b->lifetime && !b->usermail)
//     && (b->forwarding==fwd_none || b->forwarding==fwd_user))
    { do
      { putf("Lifetime >");
	getline(befbuf, 79, 1);
	putv ('\n');
	if (strchr(befbuf, CTRLZ) || strchr(befbuf, CTRLX))
	  return 0;

	while (strlen(befbuf)>1 && (befbuf[0]=='#' || befbuf[0]==' '))
 	  befbuf++;

	b->lifetime = atoi(befbuf);
      }
      while(b->lifetime > 999 || b->lifetime < 1);
    }
#endif

    putf (ms(m_textinput), b->ziel);
    if (b->at[0])
      putf("@ %s ", b->at);
    putf(ms(m_textsend), get_name(b->ziel,1));
  }

#ifdef _EXDLOGIN	//db1ras
  if ((b->guestlevel || u->fhold) && b->at[0] && !b->sysop &&
     (b->forwarding==fwd_none || b->forwarding==fwd_user))
    {
      char at[HADRESSLEN+1];
      b->at[HADRESSLEN]=0;
      sprintf(at,"~%s",b->at);
      strcpy(b->at,at);
    }
#endif

  waitfor(e_ticsfull);

  savemail();

  tmpbidraus(0);
  waitfor(e_ticsfull);

  return 1;
}

/*---------------------------------------------------------------------------*/

void showpath (char *adr, int alles)
//*************************************************************************
//
//  Zeigt die Nachbarbox(en) zur angegebenen H-Adresse an
//
//*************************************************************************
{ int fwdmode;

  if (alles)
  { scanoptions (adr);
    if (b->optplus & o_s)
    { browse_hadr (adr);
      return;
    }
    if (b->sysop && (b->optplus & o_e))
    { edit_hadr (b->optplus, adr);
      return;
    }
  }
  if (adr[0] == '@')
    adr++;
  while (adr[0] == ' ')
    adr++;

  if (adr[0])
  { strupr (adr);
    strcpy (b->at, adr);

    fwdmode = weiterleiten (0, "");

    if (alles || (fwdmode == unbekannt))
      putf (ms (m_address), b->at);
    switch (fwdmode)
    {
    case unbekannt:
      putf (ms (m_isunknown));
      break;

    case bekannt:
      { if (!alles)
          break;
        putf (ms (m_isknown));
        if (strlen (b->destboxlist) > 37)
          putf (":\n");
        putf ("%s\n", b->destboxlist);
      }
      break;

    case bleibtliegen: 
      if (!alles)
        break;
      putf (ms (m_noforwarding));
      break;
    }
    if ((alles == 2) || (alles && (b->optplus & o_a)))
      show_hadr (adr);
  }
  else
    putf (ms (m_syntaxpath));
}

/*---------------------------------------------------------------------------*/
