/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------
  Sysop-Kommandoauswertung und Zubehoer
  -------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19980126 OE3DZW lastlog 2k -> 2k5
//19980126 OE3DZW started implementation of ocp omv orm omd
//19980226 hrx    added 'twin' (sysbef, case)
//19980311 OE3DZW added rbin=rprg, wbin=wprg
//19980329 OE3DZW added new pwauswert by DG4MMI
//19980404 hrx    support for tty-controls ttyinit,ttycmd,ttydial
//19980408 hrx    trwin added to beftab/befnum/cases
//                case twin changed (no keyboard control)
//19980428 OE3DZW added logincall to shutdown
//19980505 OE3DZW added debug code for sysop-pw-length
//19980714 OE3DZW msg-number is reloaded after setuser
//19980709 DH3MB  added "scmdlist"
//19980914 OE3DZW fixed pwgen, break was missing (scmdlist)
//19990405 DH3MB  moved getpriv, getpw and pwauswert to mbpw.cpp
//                added commands MD2SUM and MD5SUM
//19990814 DH3MB  Fix: File was not closed after "TAIL -F"
//                Added RDIDADIT and WDIDADIT
//                Added #ifdef FEATURE_YAPP around RYAPP and WYAPP

#include "baycom.h"

/*---------------------------------------------------------------------------*/

#ifdef _FILEFWD
extern int fwdcmd();
extern int scan_fwdfile(char type);
#endif

/*---------------------------------------------------------------------------*/
void testdfull(void)
{ if((dfree(".",0)<HOMEDISKFULL) ||
     (dfree(m.userpath,0)<USERDISKFULL) ||
     (dfree(m.infopath,0)<INFODISKFULL))
    putf("***************** Disk is full *****************\n");
}

/*---------------------------------------------------------------------------*/

void sysimport(char *befbuf)
{ if(befbuf[0]==0)
    putf("Syntax: IMPORT <filename>\n");
  else if(t->input!=io_file && t->output!=io_file)
  { b->inputfile=s_fopen(defext(befbuf,"imp"),"lrt");
    if(b->inputfile)
    { b->oldinput=t->input;
      t->input=io_file;
    }
    else
      putf("import: file not found.\n");
  }
  else
  { char *im=stristr(befbuf,".imp");
    if(im)
      im[0]=0;
    runbatch(befbuf);
  }
}

/*---------------------------------------------------------------------------*/

void putlog(char *name, char *befbuf)
{ if(befbuf[0])
    grep(name, befbuf, u->opt[o_gr]);
  else
  { fileio_text fio;
    fio.usefile(name);
    fio.settail(-2500);
    fio.tx();
  }
}

/*---------------------------------------------------------------------------*/

int sysbef(char *befbuf)
{ static char shutdown_reason[23];
  static char *beftab[]=
    { "TNC","CONNECT","LOGIN","CALL","OSHELL","W2","UWIN",
      "RTEXT","CAT","RPRG","WTEXT","WPRG","RBIN","WBIN",
      "SLR","CLOG","REORG",
      "LIFETIME","MKBOARD","RMBOARD","MVBOARD","SHUTDOWN","NEW",
#ifdef FEATURE_EDITOR
      "EDIT","FEDIT",
#endif
      "CEDIT","KILL","TEST","IMPORT","DISABLE","ENABLE","UIMPORT",
      "SETUSER","BEACON","GREP","TGREP","TAIL","BEGIN","BATCH",
      "EXPORT","PWGEN","POSTFWD","MONITOR","NOTE","MACRO","CFGFLEX",
      "ORM","OMV","OCP","OMD","TWIN","APPEND",
#ifdef FEATURE_YAPP
      "WYAPP","RYAPP",
#endif
#ifdef FEATURE_DIDADIT
      "WDIDADIT","RDIDADIT",
#endif
#ifdef HRX_OPT
      "TRWIN",
#endif
#ifdef _TTY
      "TTYCMD","TTYDIAL","TTYINIT","TTYHANGUP","TTYSTATUS","TTYWIN", // JJ
      "TTYCOUNTERRESET", // JJ
#endif
#ifdef _AUTOFWD            // JJ
      "FWDLIST",           // JJ
#endif                     // JJ
#ifdef FEATURE_MD2
      "MD2SUM",
#endif
#ifdef FEATURE_MD5
      "MD5SUM",
#endif
#ifdef _FILEFWD
      "FWDIMPORT","FWDEXPORT",
#endif
      "SCMDLIST","CONVEDIT",
      NULL
    };

  enum befnum
    { unsinn,
      tnc,connect,login,call,oshell_,w2,uwin,
      rtext,rtext_,rprg,wtext,wprg,rbin,wbin,
      slr,clog,reorg,
      life,mkb,rmb,mvb,shutdown,new_,
#ifdef FEATURE_EDITOR
      edit,fedit,
#endif
      cedit,kill_,test,import,disable_,enable_,uimport_,
      setuser,beacon,grep_,tgrep,tail,begin,batch,
      export_,pwgen,postfwd_,monitor_,note,macro,cfgflex_,
      orm,omv,ocp,omd,twin,_append,
#ifdef FEATURE_YAPP
      wyapp,ryapp,
#endif
#ifdef FEATURE_DIDADIT
      wdidadit,rdidadit,
#endif
#ifdef HRX_OPT
      trwin,
#endif
#ifdef _TTY
      ttycmd,ttydial,ttyinit,ttyhangup,ttystatus,ttywin_, // JJ
      ttycounterreset, // JJ
#endif
#ifdef _AUTOFWD                 // JJ
      fwdlist_,                 // JJ
#endif                          // JJ
#ifdef FEATURE_MD2
      md2sum,
#endif
#ifdef FEATURE_MD5
      md5sum,
#endif
#ifdef _FILEFWD
      fwdimport, fwdexport,
#endif
      scmdlist,convedit_
    } cmd=unsinn;

  befbuf+=blkill(befbuf);
  cmd=(befnum)readcmd(beftab,&befbuf,0);

  // DH3MB
  switch(cmd)
  {
#ifdef FEATURE_YAPP
    case ryapp:
#endif
#ifdef FEATURE_DIDADIT
    case rdidadit:
#endif
#if defined(FEATURE_YAPP) || defined(FEATURE_DIDADIT)
      break;
#endif
    default:
      putf("\n");
      leerzeile(); // Sends the number of CRs stored in "ALTER LF"
  }

#ifdef _FILEFWD  
  struct tm *tt=ad_comtime(b->logintime);
#endif

  switch(cmd)
  { case unsinn:
      if(mbinitbef(befbuf,0)      // JJ
      #ifdef _TTY                 // JJ
       || ttyinitbef(befbuf,0)    // JJ
      #endif                      // JJ
      )
      { char xbuf[20]="^";
        mbparsave();
        #ifdef _TTY               // JJ
        ttyparsave();            // JJ
        #endif                    // JJ
        strncpy(xbuf+1,befbuf,18);
        xbuf[19]=0;
        if(strchr(xbuf,' '))
          strchr(xbuf,' ')[0]=0;
        if(strchr(xbuf,'='))
          strchr(xbuf,'=')[0]=0;
        grep(MBINITNAME,xbuf,o_i);
        #ifdef _TTY                          // JJ
        grep(INITTTYNAME,xbuf,o_i);        // JJ
        #endif                               // JJ
	return 1;
      }
      else
	return 0;

    case note:
      trace(replog,"note","%s",befbuf);
      break;

    case omv:
    { char f1[50],f2[50];
      befbuf=nexttoken(befbuf,f1,49);
      befbuf=nexttoken(befbuf,f2,49);
      if ((!f1[0]) || (!f2[0]) || xrename(f1,f2))
        putf("mv err.\n");
      else
        putf("mv ok.\n");
      break;
    }

    case ocp:
    { char f1[50],f2[50];
      befbuf=nexttoken(befbuf,f1,49);
      befbuf=nexttoken(befbuf,f2,49);
      if ((!f1[0]) || (!f2[0]) || filecopy(f1,f2))
        putf("cp err.\n");
      else
        putf("cp ok.\n");
      break;
    }  
 
    case orm:
    { char f1[50];
      befbuf=nexttoken(befbuf,f1,49);
      if ( (!f1[0]) || xunlink(f1))
        putf("rm err.\n");
      else
        putf("rm ok.\n");
      break;
    }  
           
    case omd:
    { char f1[50];
      befbuf=nexttoken(befbuf,f1,49);
      killbackslash(f1);
      if ((!f1) || xmkdir(f1))
        putf("md err.\n");
      else
        putf("md ok.\n");
      break;
    }  

    case _append:
    { char textline[82];
      befbuf=nexttoken(befbuf,textline,81);
      if (!befbuf[0])
      { putf("Syntax: APPEND <textline> <filename>\n");
        break;
      }
     
      FILE *f=s_fopen(befbuf,"sat");
      if (f)
      { fprintf(f,"%s\n",textline);
        s_fclose(f);
      }
      else
      { putf("File not found.");
        break;
      }

    }  
      break;
 
    case macro:
      mk_start(befbuf);
      break;

    case setuser:
    { char call[7];
      befbuf=nexttoken(befbuf,call,7);
      strupr(call);
      if(mbcallok(call) && befbuf[0])
      { if(!mbalter(NULL,befbuf,call))
	  putf("%s unknown.\n",call);
        b->msg_loadnum=0; //reload msg
	loaduser(b->logincall,u,1);
      }
      else
	putf("Syntax: SETUSER <call> <option> <value>\n");
    } break;

    case uimport_:
      putf("Userfile import started...\n");
      uimport();
      break;

    case disable_:
      if(befbuf[0]!='0')
      { putf("Box disabled\n");
        m.disable=1;
        mbparsave();
        break;
      }

    case enable_:
      putf("Box enabled\n");
      m.disable=0;
      mbparsave();
      break;

    case test:
      if(befbuf[0]=='W')      { while(1); } // for testing watchdog
      else if(befbuf[0]=='S') { trace(fatal,"test","abort"); }
      else if(befbuf[0]=='V') { *(char *)0=1; }
      else mk_start(befbuf);
      break;

    case batch:
      runbatch(befbuf);
      break;

    case rtext:
    case rtext_:
      { fileio_text fio;
        fio.usefile(befbuf);
        fio.tx();
        putf("\032\n");
      }
      break;

    case wtext:
      { fileio_text fio;
        fio.usefile(befbuf);
        fio.rx();
      }
      break;

    case rbin:
    case rprg:
      { fileio_abin fio;
        fio.usefile(befbuf);
        fio.tx();
      }
      break;

    case wbin:
    case wprg:
      { fileio_abin fio;
        fio.usefile(befbuf);
        fio.rx();
      }
      break;

#ifdef FEATURE_YAPP
    case ryapp:
      { fileio_yapp fio;
        fio.usefile(befbuf);
        fio.tx();
      }
      break;

    case wyapp:
      { fileio_yapp fio;
        fio.usefile(befbuf);
        fio.rx();
      }
      break;
#endif // FEATURE_YAPP

#ifdef FEATURE_DIDADIT
    case rdidadit:
      { fileio_dida fio;
        fio.usefile(befbuf);
        fio.tx();
      }
      break;

    case wdidadit:
      { fileio_dida fio;
        fio.usefile(befbuf);
        fio.rx();
      }
      break;
#endif // FEATURE_DIDADIT

    case slr:
      putlog(TRACEPATH "/syslog_r.bcm", befbuf);
      break;

    case clog:
      putlog(TRACEPATH "/" CMDLOGNAME, befbuf);
      break;

    case tail:
      scanoptions(befbuf);
      befbuf+=blkill(befbuf);
      if(b->optplus&o_f && befbuf[0])
      { int a;
        FILE *f=s_fopen(befbuf,"lrt");
        if(f)
        { fseek(f,0,SEEK_END);
          do
          { while((a=fgetc(f))!=EOF)
              putv(a);
            wdelay(349);
          }
          while(!testabbruch());
          s_fclose(f);
        }
      }
      else
      { fileio_text fio;
        fio.usefile(befbuf);
        fio.settail(-2000);
        fio.tx();
      }
      break;

    case begin:
      { fileio_text fio;
        fio.usefile(befbuf);
        fio.settail(2000);
        fio.tx();
      }
      break;

    case monitor_:
      if(befbuf[0])
      { scanoptions(befbuf);
        b->continous=1;
        monitor(atoi(befbuf),b->optplus);
      }
      else
        putf("Syntax: MONITOR [-iords] <task-id>\n");
      break;

    case tgrep:
    { char string [61];
      char name[40];
      scanoptions(befbuf);
      b->optgroup=o_gr;
      b->usermail=0;
      formoptions();
      if (!befbuf[0])
      { putf("Syntax: TGREP [pattern] <fwd-bbs>\n");
        break;
      }
      befbuf=nexttoken(befbuf,string,60);
      if(befbuf[0])
      { sprintf(name,TRACEPATH"/t_%s.bcm",befbuf);
        grep(name,string,b->opt);
      }
      else
      { sprintf(name,TRACEPATH"/t_%s.bcm",string);
        putlog(name,"");
      }
    } break;

    case grep_:
    { char string [61];
      scanoptions(befbuf);
      b->optgroup=o_gr;
      b->usermail=0;
      formoptions();
      befbuf=nexttoken(befbuf,string,60);
      grep(befbuf,string,b->opt);
    } break;

#ifdef _AUTOFWD                     // JJ
    case  fwdlist_:                 // JJ
     fwdlist(befbuf);               // JJ
     break;                         // JJ
#endif                              // JJ

    case life:
      if(befbuf[0])
      { strupr(befbuf);
        char *life=blankweg(befbuf);
	int board=finddir(befbuf,b->sysop);

	if(board>0)
	{ board-=1;
	  if(life && life[0])
	  { tree[board].lifetime_max=atoi(life);
	    tree[board].lifetime_min=0;
            if(tree[board].lifetime_max>999)
	      tree[board].lifetime_max=999;
            char *life_min=blankweg(life);
            if(life_min && life_min[0])
            { tree[board].lifetime_min=atoi(life_min);
              if(tree[board].lifetime_min>999)
	        tree[board].lifetime_min=999;
            } 
            mbtreesave();
	  }
	  putf("Lifetime %s: %d (min=%d) days.\n",b->boardfullname,
              tree[board].lifetime_max,tree[board].lifetime_min);
	}
	else
	  putf("Board %s not found.\n",befbuf);
      }
      else
	putf("Syntax: LIFETIME <board> <days_maximum> "
             "[<days_minimum>]    (days <= 999)\n");
      break;

    case tnc:
      control_tnc(befbuf);
      break;

    case connect:
      termqso(befbuf);
      break;

    case login:
      if(mbcallok(befbuf))
      { mblogin(befbuf,login_standard,b->uplink);
        cmdlog("login changed");
        putf("login: call changed.\n");
      }
      else
        putf("Syntax: LOGIN <new logincall>\n");
      break;

    case call:
      if(mbcallok(befbuf))
      { mblogin(befbuf,login_silent,b->uplink);
        cmdlog("call changed");
      }
      else
        putf("Syntax: CALL <new logincall>\n");
      break;

    case oshell_:
      if(t->input==io_file || t->output==io_file)
        oshell(befbuf,sh_noinput);
      else
        oshell(befbuf,m.dosinput?sh_forceinput:sh_ifmultitask);
      break;

    case reorg:
      if(sema_test("purgereorg")==1)
        putf("PURGE/REORG semaphore set. Retry later!\n");
      else 
      { putf("REORG invoked.\n");
        fork(P_BACK|P_MAIL,0,mbreorg,befbuf);
      }	
      break;

    case postfwd_:
      putf("POSTFWD invoked.\n");
      fork(P_BACK|P_MAIL,0,postfwd,"Postfwd");
      break;

#ifdef FEATURE_EDITOR
    case edit:
  #ifdef _DOSEDITOR_FIX		//db1ras
      if (!strcmp(b->uplink,"Console"))
  #endif
      fork(P_WIND|P_KEYB,0,editfile,befbuf);
  #ifdef _DOSEDITOR_FIX		//db1ras
      else
	putf("Console only.\n");
  #endif
      break;

    case fedit:
  #ifdef _DOSEDITOR_FIX		//db1ras
      if (!strcmp(b->uplink,"Console"))
  #endif
      fork(P_WIND|P_KEYB,0,editfile,FWDLISTNAME);
  #ifdef _DOSEDITOR_FIX		//db1ras
      else
	putf("Console only.\n");
  #endif
      break;

    case cedit:
  #ifdef _DOSEDITOR_FIX		//db1ras
      if (!strcmp(b->uplink,"Console"))
  #endif
      fork(P_WIND|P_KEYB,0,editfile,CONVFILENAME);
  #ifdef _DOSEDITOR_FIX		//db1ras
      else
	putf("Console only.\n");
  #endif
      break;
#else
    case cedit:
#endif
    case convedit_:
      convedit(befbuf);
      break;

   
    case new_:
      mbinit();
      initfwdlist(0);
      mbconvload();
      mbclifeload();
#ifdef RUNUTILS
      read_runfile();
#endif
      msg_dealloc(1);
      mk_read_jobs();
      break;

    case kill_:
      if(atoi(befbuf))
      { while(atoi(befbuf))
        { if(!kill(nextdez(&befbuf)))
	    putf("kill: own task ID or task not found.\n");
        }
      }
      else
	putf("Sytnax: KILL <task-id>\n");
      break;

    case w2:
      fork(P_WIND|P_KEYB|P_MAIL,0,mbwin2,m.sysopcall);
      break;

    case uwin:
      fork(P_WIND|P_KEYB|P_MAIL,0,userwin,"Users");
      break;

    case twin:                                     
      fork(P_WIND|P_MAIL,0,taskwin,befbuf); 
      break;                                        

#ifdef HRX_OPT
    case trwin:                                    
      if(befbuf[0])                                  
        fork(P_WIND|P_MAIL,0,trcwin,befbuf);         
      else                                         
        putf("Syntax: TRWIN [-iords] <task-id>\n"); 
      break;                                        
#endif

    case mkb:
      char mainboard[30];
      char newboard[20];
      char *slash;

      befbuf=nexttoken(befbuf,mainboard,29);
      befbuf=nexttoken(befbuf,newboard,19);
      slash=strchr(mainboard+1,'/');
      if(slash && (newboard[0]==0))
      { slash[0]=0;
	strcpy(newboard,slash+1);
      }

      if((newboard[0]==0)&&(mainboard[0]=='/'))
      { strcpy(newboard,mainboard+1);
	mainboard[1]=0;
      }

      if(mainboard[0] && newboard[0])
      { switch(mkboard(mainboard,newboard,0))
	{ case 0: putf("Board created.\n");
		  break;
	  case 1: putf("Main board not found.\n");
		  break;
	  case 2: putf("Too many boards.\n");
		  break;
	  case 3: putf("Boardname exists.\n");
		  break;
	  case 4: putf("Invalid Boardname.\n");
		  break;
	}
      }
      else
	putf("Syntax: MKBOARD <mainboard> <subboard>\n");
      break;

    case rmb:
    { if(befbuf[0])
      { if(strchr(befbuf,' '))
	  strchr(befbuf,' ')[0]='/';
	if((befbuf[0]=='/')&&(befbuf[1]=='/'))
	  befbuf++;
	switch(rmboard(befbuf))
	{ case 0: putf("Board removed.\n");
		  break;
	  case 1: putf("Board not found.\n");
		  break;
	  case 2: putf("Board is not empty.\n");
		  break;
	}
      }
      else
	putf("Syntax: RMBOARD <mainboard> <subboard>\n");
    } break;

    case mvb:
    { char oldboard[20];
      char subboard[20];
      char newboard[20];

      befbuf=nexttoken(befbuf,oldboard,19);
      befbuf=nexttoken(befbuf,subboard,19);
      befbuf=nexttoken(befbuf,newboard,19);

      if(oldboard[0] && subboard[0] && newboard[0])
      {	switch(mvboard(oldboard,subboard,newboard))
	{ case 0: putf("Board moved.\n");
		  break;
	  case 1: putf("New mainboard not found.\n");
		  break;
	  case 2: putf("Too many boards.\n");
		  break;
	  case 4: putf("Board not found.\n");
		  break;
	}
      }
      else
	putf("Syntax: MVBOARD <oldboard> <subboard> <newboard>\n");
    } break;

    case shutdown:
      scanoptions(befbuf);
#ifndef __FLAT__
      if(b->optplus&o_r)
        atexit((void(*)())MK_FP(0xffff,0x0000));
#endif	
      runterfahren=1;
      sprintf(shutdown_reason,"shutdown by %s",b->logincall);
      stopreason=shutdown_reason;
      break;

    case cfgflex_:
      if (befbuf[0] && filetime("cfgflex.bcm"))
      { putf("Flexnet configuration upload started.\n");
        fork(P_BACK|P_MAIL,0,cfgflex,befbuf);
      }
      else
        putf("Syntax: CFGFLEX <flexcall> (cfgflex.bcm must exist)\n");
      break;       

    case import:
      sysimport(befbuf);
      break;

    case export_:
      if(befbuf[0])
      { if((t->input!=io_file||t->output==io_dummy) && t->output!=io_file)
        { char fname[51];
          scanoptions(befbuf);
          befbuf=nexttoken(befbuf,fname,50);
          if(b->optplus & o_a) // neue Option -b fr binaer 
	  { if (b->optplus & o_b) 
              b->outputfile=s_fopen(fname,"sab");
            else
              b->outputfile=s_fopen(fname,"sat");
          }
          else
          { if (b->optplus & o_b)       
	      b->outputfile=s_fopen(fname,"swb"); 
            else
              b->outputfile=s_fopen(fname,"swt");     
          }
	  if(b->outputfile)
	  { s_fsetopt(b->outputfile,1);
            b->oldinput=t->input;
	    b->oldoutput=t->output;
            t->input=io_dummy;
            t->output=io_file;
            b->continous=1;
            if(b->optplus&o_u)
              b->sysop=0;
            if(befbuf[0])
              mailbef(befbuf,0);
            b->sysop=1;
	  }
	  else
	    putf("export: can't open %s\n",fname);
        }
      }
      else
	putf("Syntax: EXPORT <filename> <box-command>\n");
      break;

    case beacon:
      if(befbuf[0])
      { FILE *f=s_fopen(BEACONNAME,"srt");
        int i=0;
        char s[80];
	if(f)
        { while(fgets(s,70,f))
          { if(s[0])
            { s[strlen(s)-1]=0;
	      putbeacon_tnc(s,befbuf);
	      i++;
	    }  
	  }
          s_fclose(f);
        }
	putf("%d beacon frames sent.\n",i);
      }
      else
      { fork(P_BACK|P_MAIL,0,sendmailbake,"Beacon");
        putf("Beacon processing started.\n");
      }	
      break;

    case pwgen:
    { FILE *f;
      if (befbuf[0] && (f=s_fopen(befbuf,"swt"))!=0)
      { int i;
        for(i=0;i<1620;i++)
        { char c=0;
          while(!isalnum(c))
            c=random_max('z');
          fputc(c,f);
        }
        s_fclose(f);
      }
    }
    break;

    case scmdlist: // DH3MB
      { int i=0;

        while(beftab[i])
          putf("(%02d) %s\n",++i,beftab[i]);
      }
      break;

#ifdef FEATURE_MD2
    case md2sum:
      if(befbuf[0]==0)
      { putf("Syntax: MD2SUM <filename>\n");
        break;
      }
      if(!filetime(befbuf))
        putf("File %s does not exist.\n", befbuf);
      else
      { MD2 md2;
        md2.readfile(befbuf, 0L);
        md2.gethexdigest(b->line);
        putf("%s  %s\n", b->line, befbuf);
      }
      break; 
#endif

#ifdef FEATURE_MD5
    case md5sum:
      if(befbuf[0]==0)
      { putf("Syntax: MD5SUM <filename>\n");
        break;
      }
      if(!filetime(befbuf))
        putf("File %s does not exist.\n", befbuf);
      else
      { MD5 md5;
        md5.readfile(befbuf, 0L);
        md5.gethexdigest(b->line);
        putf("%s  %s\n", b->line, befbuf);
      }
      break; 
#endif

#ifdef _TTY                // JJ (alles)
    case ttycmd:
      if(befbuf[0])
      { if (m.ttydevice>1)
	 putf_tty("%s\r",befbuf);
	else
	 putf("tty: no modem selected");
      }
      else
	putf("Syntax: TTYCMD <command>\n");
      break;

    case ttydial:
      strupr(befbuf);
      char *nummer;
      char call[8];
      nummer=nexttoken(befbuf,call,8);
      if(befbuf[0] && mbcallok(call))
      {	if(m.ttydevice &&(get_ufwd(call)[0] || isforwardpartner(call)>=0))
	{ putf("Starting ttyforward to %s(%s).\n",call,nummer);
	  sprintf(befbuf,"%s TTY %s",call,nummer);
	  fork(P_BACK|P_MAIL,0,fwdsend,befbuf);
	}
	else
	  putf("no TTYDEVICE active\n");
      }
      else
	putf("Syntax: TTYDIAL <call> <number>\n");
      break;

    case ttyinit:
      if(eingelogt("getty",0))
       putf("tty: already active");
      else
       init_tty();
      break;

    case ttyhangup:
      tty_hangup();
      putf("hang up modem.\n");
      break;

    case ttystatus:
      tty_statustext();
      putf("\n");
      break;

    case ttywin_:
      fork(P_WIND|P_MAIL,0,tty_win,befbuf);
      break;

    case ttycounterreset:
      tty_counterreset();
      putf("\n");
      break;
#endif

#ifdef _FILEFWD
    case fwdimport:
     if(tt->tm_year<104)
     {
      if(befbuf[0])
      {
        char partner[CALLEN+1];
        char file[51];
        char orglogincall[CALLEN+1];

        befbuf=nexttoken(befbuf,partner,CALLEN);
        nexttoken(befbuf,file,50);

        strupr(partner);
        if(isforwardpartner(partner) == NOTFOUND)
        {
          putf("\"%s\" not found in fwd.bcm\n",partner);
          break;
        }
        if(!file[0])
        {
           putf("Syntax: FWDIMPORT <partner_call> <file>\n");
           break;
        }
        putf("Importing forward-file from %s (file %s)\n",partner,file);
        FILE* oldinpfile = b->inputfile;
        b->inputfile=s_fopen(file,"lrb");

        if(!b->inputfile)
        {
          b->inputfile = oldinpfile;
          putf("fwdimport: can't open %s\n",file);
	  break;
        }

        char oldinp = b->oldinput;
        char oldinp2 = t->input;

        b->forwarding=fwd_file;
//        strcpy(b->frombox,partner);
        strcpy(orglogincall,b->logincall);
        strcpy(b->logincall,partner);

    /* For RX SID is not really needed .. but just in case */
        b->opt = o_a | o_h | o_m | o_r | o_d | o_w; //SID AHMRDW($)
//	if(fpara()->options&o_i) //send binary files -> partner is BCM
//	  b->opt |= o_d | o_w;

        b->oldinput=io_dummy;
        t->input=io_file;
        fwdlog("---- ","fwdimport - start",'-');

        while(fwdcmd() == 0);

        fwdlog("---- ","fwdimport - end",'-');

        b->inputfile = oldinpfile;
        b->oldinput = oldinp;
        t->input = (io_t) oldinp2;
        b->forwarding = fwd_none;
        strcpy(b->logincall,orglogincall);
      }
      else
        putf("Syntax: FWDIMPORT <partner_call> <file>\n");
     }
      break;

    case fwdexport:
     if(tt->tm_year<104)
     {
      if(befbuf[0])
      {
        char partner[CALLEN+1];
        char orglogincall[CALLEN+1];
        char file[51];

        befbuf=nexttoken(befbuf,partner,CALLEN);
        nexttoken(befbuf,file,50);

        strupr(partner);
        if(isforwardpartner(partner) == NOTFOUND)
        {
          putf("\"%s\" not found in fwd.bcm\n",partner);
          break;
        }
        if(!file[0])
        {
          putf("Syntax: FWDEXPORT <partner_call> <file>\n");
          break;
        }

        putf("Exporting forward-file for %s (file %s)\n",partner,file);

        b->forwarding=fwd_file;
        strcpy(orglogincall,b->logincall);
        strcpy(b->logincall,partner);

        b->opt = o_a | o_h | o_m | o_r | o_f | o_d | o_w; //SID AFHMRDW($)
//        if(fpara()->options&o_i) //send binary files -> partner is BCM
//            b->opt |= o_d | o_w;  // SID +DW

        if((t->input!=io_file||t->output==io_dummy) && t->output!=io_file)
        {
          if(!filetime(file))
          {
            b->outputfile=s_fopen(file,"swb");

            if(b->outputfile)
            { s_fsetopt(b->outputfile,1);
              b->oldinput=t->input;
              b->oldoutput=t->output;
              t->input=io_dummy;
              t->output=io_file;
              b->continous=1;

              fwdlog("---- ","fwdexport - start",'-');
	      gen_wpmail(b->logincall);
              wdelay(349);

	      scan_fwdfile('u');
              scan_fwdfile('i');
              fwdlog("---- ","fwdexport - end",'-');

              s_fclose(b->outputfile);
              b->outputfile=NULL;
              t->input=(io_t)b->oldinput;
              t->output=(io_t)b->oldoutput;
              b->oldinput = io_dummy;
              b->oldoutput = io_dummy;
            } else
              putf("fwdexport: can't open %s\n",file);
          } else
            putf("File %s exists.\n", file);
        }

        strcpy(b->logincall,orglogincall);
        b->forwarding=fwd_none;
      }
      else
        putf("Syntax: FWDEXPORT <partner_call> <file>\n");
     }
      break;
#endif

#if 0
#define DIRLEN  40
#define MAXDIRS 200
    case catalog:
    case dir:
    { char *s;
      char mask[80];
      char *dirlist;
      int count=0;
      int i;

      dirlist=(char *)t_malloc(DIRLEN*(MAXDIRS+1),"sysd");
      if(dirlist)
      {
        wnd=rxwin;
        set_color(txcolor,0);
        if(remotefl && !b->pwok)
        { strcpy(mask,syspath("REMOTE\\"));
          if(befbuf[0]=='.') befbuf[0]=0;
          while(strstr(befbuf,"\\")) befbuf++;
          while(strstr(befbuf,"/"))  befbuf++;
          strcat(mask,befbuf);
        }
        else
          strcpy(mask,befbuf);
        modifymask(mask);
        putf(">>> Directory of %s\r",mask);
        s=dirline(mask,2);
        if(s)
        { while(s && count<MAXDIRS)
	  { strcpy(dirlist+count*DIRLEN,s);
	    count++;
            s=dirline(mask,3);
	  }
          qsort((void *)dirlist,count,DIRLEN,
                (int(*)(const void *,const void *))strcmp);
          for(i=0;i<(count/2);i++)
          {
            putf("%s      ",dirlist+DIRLEN*i);
            putf("%s\r"    ,dirlist+DIRLEN*(i+(count/2)));
          }
          if(count&1)
            putf("%*s%s\r",count==1?0:42,"",dirlist+DIRLEN*(count-1));

          putf(">>> %d File%s       %ld kBytes free.\r",
               count,count==1?"":"s",dfree(mask,0));
        }
        else
	  putf(">>> File not found.\r");
        t_free(dirlist);
      }
    }
#endif

  }
  return 1;
}

/*---------------------------------------------------------------------------*/
