/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -------------------------------------------------------------
  Fehlerbehandlung. Ausgabe und Abspeichern von Systemmeldungen
  -------------------------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

  $Id: mbtrace.cpp,v 1.2 1998/03/14 16:18:40 flori Exp $
  
  $Log: mbtrace.cpp,v $
  Revision 1.2  1998/03/14 16:18:40  flori
  log eingefuegt


 ***************************************************************/

//19980120 OE3DZW everything is saved in syslog_r.bcm
//19980121 OE3DZW report output was in syslog too, fixed
//19980215 OE3DZW non report output was in syslog_r twice, fixed
//                define for syslog_r in mail.h
//19980323 OE3DZW log on Linux/Win32-screen only showed report-msges
//19990206 OE3DZW Lines may be max. 130 chars long (before limit was 80)
//19990206 OE3DZW Linebreaks will be LF under Linux - not CRLF

#include "baycom.h"

/*---------------------------------------------------------------------------*/

#ifdef STANDALONE
void trace(int mode,int line,char *file,char *programm,char *string, ...)
{ va_list argpoint;
  char cbuf[100];
  char modestr[4][12]={"REPORT ","REPLOG ","SERIOUS","FATAL  ","ABORT  "};

  va_start(argpoint,string);
  vsprintf(cbuf,string,argpoint);
  va_end(argpoint);

  printf(">>> %s %s: %s\n",modestr[mode],programm,cbuf);
  if(mode==tr_abbruch)
    exit(1);
}
#else

/*---------------------------------------------------------------------------*/

#define BUFLEN 300

static char tracebuffer[BUFLEN];
char lasttrace[132];
static int  tracein=0;
static int  traceout=0;

/*---------------------------------------------------------------------------*/

static void near tracechr(int ch)
{ while(((tracein+1)%BUFLEN)==traceout)
  { if(gettaskid()==NOTASK)
      traceout=(traceout+1)%BUFLEN;
    else
      wdelay(49);
    if(runterfahren)
      return;
  }
  tracebuffer[tracein]=ch;
  tracein=(tracein+1)%BUFLEN;
}

/*---------------------------------------------------------------------------*/

static void near tracestr(char *s)
{ while(*s)
    tracechr(*(s++));
}

/*---------------------------------------------------------------------------*/

void tracelog(char *message,int mode)
{ 
  char buf[132];
  handle fh;
  char name[30];

  if(strlen(message)>103)
    message[103]=0;

  while(strchr(message,26))
    strchr(message,26)[0]=0x9f; //oe3dzw: Hex-Wert  

  sprintf(buf,"%s %6s: %s"NEWLINE,zeitstring(ad_time(),1),
	    (t && b && (b->logincall[0])?b->logincall:"SYSTEM"),message);

#if defined __LINUX__ || defined _WIN32
  int i;
  //?? if(mode==_s_report)  
  { for (i=0;buf[i];i++)
    { if ((buf[i] < 0x20 || buf[i] > 0x7f) && buf[i]!='\n'
       && buf[i]!='\r')
       printf(".");        
      else
       printf("%c",buf[i]);      
    } 
  }
#endif
  /*
#ifdef _WIN32
  if(mode==_s_report)
  { void win_out(char *);
    win_out(buf);
  }
#endif
  */
  if(mode>=m.tracelevel)
  {  
    if (m.tracelevel==_s_report) //OE3DZW
    { strcpy(name,TRACEPATH"/"SYSLOGRNAME);

      fh=sopen(name,O_RDWR|O_BINARY,SHAREMODE);
      if(fh==EOF)
        fh=_creat(name,CREATMODE);
      else
        lseek(fh,0L,SEEK_END);        // Workaround for bug
                                    // of Borland C++ 3.1
      if(fh!=EOF)
      { _write(fh,buf,strlen(buf));
        _close(fh);
      }
    }
    if (mode!=_s_report)
    { strcpy(name,TRACEPATH"/"SYSLOGNAME);
      fh=sopen(name,O_RDWR|O_BINARY,SHAREMODE);
      if(fh==EOF)
        fh=_creat(name,CREATMODE);
      else
        lseek(fh,0L,SEEK_END);        // Workaround for bug
                                    // of Borland C++ 3.1
      if(fh!=EOF)
      { _write(fh,buf,strlen(buf));
        _close(fh);
      }
    }
  }
}

/*---------------------------------------------------------------------------*/

void cmdlog(char *befehl)
{ char buf[120];
  handle fh;

  if(strcmp(b->uplink,"Import")==0)
    return;
  while(strchr(befehl,26))
    strchr(befehl,26)[0]='';
  if(strlen(befehl)>79) befehl[79]=0;
  fh=s_open(TRACEPATH"/"CMDLOGNAME,"sab");
  if(fh==EOF)
    fh=s_open(TRACEPATH"/"CMDLOGNAME,"swb");
  if(fh!=EOF)
  { sprintf(buf,"%s %6s: %s",
            zeitstring(ad_time(),1),b->logincall,befehl);
    buf[76]=0;
    strcat(buf,NEWLINE);
    _write(fh,buf,strlen(buf));
    s_close(fh);
  }
}

/*---------------------------------------------------------------------------*/

void pwlog(char *logincall,char *uplink,char *msg)
{ char buf[120];
  handle fh;

  fh=s_open(TRACEPATH"/"PWLOGNAME,"sab");
  if(fh==EOF)
    fh=s_open(TRACEPATH"/"PWLOGNAME,"swb");
  if(fh!=EOF)
  { sprintf(buf,"%s  %6s via %-9s %s"NEWLINE,
            zeitstring(ad_time(),1),logincall,uplink,msg);
    _write(fh,buf,strlen(buf));
    s_close(fh);
  }
}

/*---------------------------------------------------------------------------*/

void trace(int mode,int line,char *file,char *programm,char *string, ...)
{ va_list argpoint;
  char   cbuf[150];
  static char global_sema=0;
  char   *ms=" ";

  va_start(argpoint,string);
  vsprintf(cbuf,string,argpoint);
  va_end(argpoint);

  if(init_off) return;

  if(strlen(cbuf)>149)
  { tracelog("trace overflow",_s_serious);
    cbuf[59]=0;
    tracelog(cbuf,_s_serious);
    exit(1);
  }
  cbuf[59]=0;

  switch(mode)
  { case _s_report:  ms="R"; break;
    case _s_replog:  ms="L"; break;
    case _s_serious: ms="S"; break;
    case _s_fatal:   ms="F"; break;
    case _s_tr_abbruch: ms="A"; break;
  }
  sprintf(cbuf+60,"#%s %s: %s",ms,programm,cbuf);
  tracelog(cbuf+60,mode);
  
  strcpy(lasttrace,cbuf+60);  // capture the last trace message

  if(runterfahren)
    return;

  while(global_sema)
    wdelay(21);

  global_sema=1;
  cbuf[60]='\n';
  tracestr(cbuf+60);
  global_sema=0;
  if(mode==_s_tr_abbruch)
  { cbuf[121]=0;
    strcpy(abortreason,cbuf+63);
    exit(1);
  }
  else if(mode==_s_fatal)
  { if(b)
      trace(serious,"terminated","%d:%s \"%0.30s\"",gettaskid(),
                                            b->logincall,t->lastcmd);
    if(t)
      suicide();
  }
}

/*---------------------------------------------------------------------------*/

#ifdef __DOS16__
static void near winclock(void)
{ static time_t last=0;       // remember the last displayed time
  time_t actual=ad_time();
  struct tm *tt;
  unsigned col;

  if(actual>last)
  { last=actual;              // one second later
    if(iskeytask())
      col=color.activ_frame;
    else
      col=color.back_frame;
    tt=ad_comtime(actual);
    wf(e->xend-8,e->y,col,
       "%02d:%02d:%02d",tt->tm_hour,tt->tm_min,tt->tm_sec);
  }
}
#else
static void near winclock(void) {}
#endif

/*---------------------------------------------------------------------------*/

void tracewindow(char *name)
{ int action=0;
  e->x=30;
  e->xend=bildspalten-1;
  e->y=0;
  e->yend=bildzeilen/3;

  preparewin(putupdate,name,30*bildzeilen);

  putupdate(1);
  while(!init_off)
  { if(tracein!=traceout)
    { putv(tracebuffer[traceout]);
      traceout=(traceout+1)%BUFLEN;
      action=2;
    }
    else
    { if(action)
      { action--;
	wdelay(22);
      }
      else
	wdelay(251);
      set_watchdog(1);
      winclock();
    }
  }
  int i;
  for(i=255;i;i--)
    kill(i);
  wclose();
  t_free(buf);
  buf=NULL;
}

#endif
