/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  -----------------------------------------------------------------
  TRANSFER-Befehl: Uebertragen von Nachrichten in ein anderes Board
  -----------------------------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

//19880118 OE3DZW sec in timestr
//19980308 OE3DZW old R-lines will be ignored on transfer
//19980423 OE3DZW using newcall when transfering
//19981001 OE3DZW started bin-transfer 1 byte earlier, added date of
//                original mail
//19990715 OE3DZW newcall - invalid pointer, variable was missing

#include "baycom.h"

/*---------------------------------------------------------------------------*/

int mbtransfer(char *ziel)
//*************************************************************************
//
//  TRANSFER-Prozedur
//  (wird fuer jedes transferierte File einzeln aufgerufen)
//
//*************************************************************************
{ char *line=b->line;
  int index;
  FILE *f,*oldf;
  int usermail=0;
  int retwert=NO;
  int nocp; //no-copy flag
  char oldsubject[101];
  unsigned long int oldfpos,fpos;
  char oldmsgty;
  time_t oldmsgtime;
  int nummer=0;

  strupr(ziel);
  
  if(sema_test("sendlock")||m.disable)
  { putf(ms(m_sendnotpossible));
    return NO;
  }
   
  { // Use newcall
    char newcall[CALLEN+1];
    if (get_newcall(ziel,newcall))
    { strcpy(ziel,newcall);     
      putf("Using new call %s.\n",newcall);
    }
  }

  oldmsgtime=filename2time(b->mailfname);
  
  char *bbuf;
  bbuf=(char *)t_malloc(sizeof(tvar_t)-sizeof(task_t),"tran");
  if(!bbuf) return NO;
  memcpy(bbuf,(char *)b+sizeof(task_t),sizeof(tvar_t)-sizeof(task_t));

  char *oldfname;
  oldfname=(char *)t_malloc(sizeof(char)*(FNAMELEN+1),"tra2");

  strlwr(b->mailpath);
  strcpy(oldfname,b->mailpath);
  oldf=s_fopen(oldfname,"srt");
  if(oldf)
  { fgets(line,255,oldf);            // Befehlszeile einlesen
    mbsend_parse(line,0);    
    //save mailflags ...(msgty)
    oldmsgty=b->msgty;
    fgets(line,255,oldf);            // Forwardzeile vernichten
    fgets(line,255,oldf);            // Read-Zeile
    fgets(oldsubject,100,oldf);            // Betreff
    oldsubject[strlen(oldsubject)-1]=0;    // Newline entfernen

    if(mbcallok(ziel))
      b->at[0]=0;
    mbsend_parse(ziel,2);
    //set mailflags again.. (msgty)
    b->msgty=oldmsgty;
    weiterleiten(1,b->ziel);
    while(strlen(b->destboxlist)<139)
      strcat(b->destboxlist,".");

    waitfor(e_ticsfull);
    if(finddir(b->ziel,b->sysop) && !(strlen(b->ziel)==1 && !b->sysop))
    { if(xmkdir(b->boardpath)!=0)
      { trace(serious,"mbtransfer","mkdir %s error",b->boardpath);
        s_fclose(oldf);
        t_free(bbuf);
        t_free(oldfname);
        return NO;
      }
      index=finddir(b->ziel,b->sysop)-1;
      nocp=strcmp(b->herkunft,b->logincall);
      if ( nocp==0 || b->mailtype=='B')
        sprintf(b->betreff,"%.78s",oldsubject);
      else
        sprintf(b->betreff,"CP %s:%.65s",b->logincall,oldsubject);

      //Bei Nicht-Bulletin BID neu generieren bzw. wenn BID fehlt
      if (b->mailtype != 'B'|| b->bid[0]==0)
        strcpy(b->bid,newbid(0));
      make_mask(b->mailpath,b->boardfullname);
      strcpy(b->mask,b->mailpath);
      strcpy(b->mailfname,time2filename(0));
      if(!strstr(b->mailpath,"*.*"))
        trace(fatal,"mbtrans","mask %s",b->mailpath);
      strcpy(strstr(b->mailpath,"*.*"),b->mailfname);
      strlwr(b->mailpath);

#ifdef _EXDLOGIN	//db1ras
//trace(serious,"MBTRANSFER","b->at: %s",b->at);
      if ((b->guestlevel || u->fhold)
	   && b->at[0] && b->at[0]!='~' && !b->sysop)
	{
	  char at[HADRESSLEN+1];
	  b->at[HADRESSLEN]=0;
	  sprintf(at,"~%s",b->at);
	  strcpy(b->at,at);
	}
//trace(serious,"MBTRANSFER","b->at: %s",b->at);
#endif
      f=s_fopen(b->mailpath,"sw+t");
      if(f)
      { s_fsetopt(f,1);
        writeheader(f,1);
	if (b->mailtype!='B')
	{ if(fgets(line,255,oldf));
	  { do
	    { // fputs(line,f); skip old R-lines
	      waitfor(e_ticsfull);
	      fgets(line,255,oldf);
	    }
	    while(!feof(oldf) && (line[0]=='R') && (line[1]==':')); 
            fprintf(f,"%s\n",makeheader(1));
            
	    fprintf(f,"\nTransfer: %s %s by %s @ %s\n",datestr(ad_time(),2),
                      timestr(ad_time(),1),b->logincall,m.boxadress);
	  }
          do
	  { if (strncmp(line,"From: ",6)==0 && !nocp)
            {  fprintf(f,"X-Original-Date: %s\n",zeitstring(oldmsgtime,0));  
               fprintf(f,"Originally-From: %s",line+6);
            }
            else if (strncmp(line,"To: ",4)==0)
              fprintf(f,"Originally-To: %s",line+4);
            else if (strncmp(line,"X-MID: ",7)==0)
              fprintf(f,"X-Old-MID: %s",line+7);
            else if (strncmp(line,"X-BID: ",7)==0)
              fprintf(f,"X-Old-BID: %s",line+7);
            else
	      fputs(line,f);
	    waitfor(e_ticsfull);
            fgets(line,255,oldf);
          }
          while(!feof(oldf)&&strcmp(line,"\n")!=0);
          fputs("\n",f);
        }
        //Files binaer behandeln
        oldfpos = ftell(oldf)-1L;
        fpos = ftell(f)-1L;
        s_fclose(oldf);
        oldf=s_fopen(oldfname,"srb");
        s_fclose(f);
        writemailflags();
        if (oldf)
        { f=s_fopen(b->mailpath,"sab");
          if (f)
          { fseek(oldf,oldfpos,SEEK_SET);
            fseek(f,fpos,SEEK_SET);
            do
            { //oe3dzw: Transferroutine transparent
              int len;
              len = fread(line,1,255,oldf);
              if (len)
                fwrite(line,1,len,f);
              waitfor(e_ticsfull);
            }
            while(!feof(oldf));
            if (b->binstart)  //bei binaeren Mails offset neu berechnen
            { b->binstart += ftell(f)-ftell(oldf);
              if (b->binstart < 0)
                trace(serious,"mbtransfer","offset %ld in %s",b->binstart,
                  b->mailpath);
            }
            s_fclose(f);
            if (b->binstart)
              writelines(); //Neuen Binstart speichern
            if(b->bytes)
            { nummer=appenddirlist();
              if(b->usermail)
                add_fwdfile("",get_fdelay(b->herkunft));
              if(b->usermail)
              { sprintf(b->line, "%s %u", b->herkunft, nummer);
                mbtalk("\001", b->zielboard, b->line);
                trigger_ufwd(b->zielboard);
              }

              if(index>=0)
                tree[index].newestmail=ad_time();
              inc_mailgot(b->boardname);
              retwert=OK;
            }
          }
          else
          {trace(fatal,"mbtransfer","freopen %s errno=%d",
           b->mailpath,errno);
           s_fclose(oldf);
          }
        }
        else
        {trace(fatal,"mbtransfer","frepoen %s errno=%d", oldfname,errno);
        }
      }
      else
	trace(fatal,"mbtransfer","fopen %s errno=%d",b->mailpath,errno);
      s_fclose(oldf);
    }
    else
      putf(ms(m_adrnotpossible),b->ziel);
  }
  else
    trace(serious,"mbtransfer","oldfopen %s errno=%d",oldfname,errno);
  usermail=b->usermail;
  memcpy((char *)b+sizeof(task_t),bbuf,sizeof(tvar_t)-sizeof(task_t));
  t_free(bbuf);
  t_free(oldfname);
  b->usermail=usermail;
  return retwert;
}
