/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fr Benutzeroberflche


  ------------------------------
  Video- und Fileinitialisierung
  ------------------------------


  Copyright (c)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights reserved

 ***************************************************************/

#include "baycom.h"

int crit_error_device=0;
int crit_error_num=0;

/*---------------------------------------------------------------------------*/

static int break_handler(void)
{ return 2;
}

/*---------------------------------------------------------------------------*/

void test_critical(void)
{ if(crit_error_device!=0 || crit_error_num!=0)
  { trace(serious,"critical_error","device=%d errno=%d",
          crit_error_device,crit_error_num);
    crit_error_device=crit_error_num=0;
  }
}

/*---------------------------------------------------------------------------*/

#ifndef __DPMI32__
#pragma argsused
static int crit_handler(int errval,int ax,int bp,int si)
{
  unsigned di=_DI;
  if(ax>0)
    crit_error_device=ax & 0x00ff;
  else
    crit_error_device=(-1);
  crit_error_num= di & 0x00FF;

  hardretn(2);
  return 2;
}
#endif

/*---------------------------------------------------------------------------*/

static void near putfiles(void)
{ FILE *f[100];
  char s[20];
  int i;
#undef fopen
#undef fclose
  for(i=0;i<100;i++)
  { sprintf(s,"$$%d.$$$",i);
    f[i]=fopen(s,"wb");
    if(!f[i]) break;
  }
  printf("FILES=%d\n",i--);
#ifdef _BCM_F           //db1ras
  printf("_NFILE   =%d\n",_NFILE_);
  printf("FOPEN_MAX=%d\n",FOPEN_MAX);
  printf("SYS_OPEN =%d\n",SYS_OPEN);
#endif
  for(;i>=0;i--)
  { fclose(f[i]);
    sprintf(s,"$$%d.$$$",i);
    unlink(s);
  }
}

/*---------------------------------------------------------------------------*/

#ifdef __DPMI32__
static void create_swap(int kbytes)
{ char *page=(char *)malloc(4096);
  int i;

  kbytes/=4;

  if(page)
  { FILE *f=fopen("bcm32.swp","wb");
    if(f)
    { memset(page,0,4096);
      setvbuf(f,NULL,_IOFBF,16384);
      for(i=0;i<kbytes;i++)
        fwrite(page,1,4096,f);

      printf("Swap file BCM32.SWP (%d kBytes, %d pages) generated.\n",
             kbytes*4,kbytes);
    }
    else printf("create_swap: can't open swapfile.\n");
  }
  else printf("create_swap: can't allocate buffer.\n");
}
#endif

/*---------------------------------------------------------------------------*/

static void getparm(int argc,char *argv[])
{
#ifdef BOXCOMPILE
  puts("BayCom Packet-Radio Mailbox V"VNUMMER"  \n(C) GNU "YEAR
       " Florian Radlherr, DL8MBT et al.");
#endif
#ifdef TERMCOMPILE
  puts("BayCom Packet-Radio Terminal V"VNUMMER"  (C) "YEAR
       " Florian Radlherr, DL8MBT");
#endif
  while(argc>1)
  { switch(toupper(argv[argc-1][1]))
    { case 'C': cgadisp=1;  break;
      case 'M': monodisp=1; break;
      case 'N': novideo=1;  break;
      case 'F': putfiles(); exit(0);
#ifdef __DPMI32__
      case 'S': create_swap(atoi(argv[argc-1]+2)); exit(0);
#endif
      default:
      printf("\n%s [/C] [/M] [/F]\n",argv[0]);
      puts(" /C  use only 25 display lines (no VGA screen)\n"
	   " /M  use monochrome color set (for LCD display)\n"
           " /N  do not write into video memory\n"
	   " /F  shows maximum of accessible file handles\n"
#ifdef __DPMI32__
	   " /S<kBytes>  creates BCM32.SWP swap file for DPMI32 Server\n\n"
#endif
	   "Note: FLEXNET.EXE must be resident for packet-radio usage.\n");
      exit(0);
    }
    argc--;
  }
}

/*---------------------------------------------------------------------------*/

static void main_close(void)
{ video_close();

  if(abortreason[0])
    printf("\a\n>>> unrecoverable error condition:\n    %s\n",abortreason);
}

/*---------------------------------------------------------------------------*/

void exelock(char *argv0)
{ if(sopen(argv0, O_RDONLY, SH_DENYRD, S_IREAD) == -1)
    trace(tr_abbruch,"exelock","BCM is already running");
}

/*---------------------------------------------------------------------------*/

int main(int argc,char *argv[])
{ getparm(argc,argv);
#ifndef __DPMI32__
  harderr(crit_handler);
#endif
  ctrlbrk(break_handler);
  t_allocinit();
  video_open();
  fixpath(argv[0]);
#ifdef BOXCOMPILE
  cdhome();
#endif
  atexit(main_close);
  //exelock(argv[0]);
  maintask();
  return 0;
}

/*---------------------------------------------------------------------------*/
