/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ---------------------------------
  Meldungen fuer Parameter-Compiler
  ---------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#if DEUTSCH
#define I_LINE       "Zeile %u\r"
#define I_INITOPARA  "Initialisierungsfile %s wird zu Parameterfile %s konvertiert.\n"
#define I_LINEDONE   "Zeile %u fertig\n"
#define I_HELPFILE   "Helpfile wird durchsucht...\n"
#define I_ITEMSFOUND "%d Stichworte in %d Zeilen gefunden\n"
#define I_WRITEINDEX "Index wird aufgebaut...\n"
#define I_SORTING    "Index wird sortiert...\n"
#define I_ITEM       "Stichwort %d\r"
#define I_CROSSREFS  "Querverweise werden auf Konsistenz geprft...\n"
#define I_INDEXOK    "Indizierung des Helpfiles fertig.\n"
#define I_USCCFOUND  "User-SCC-Karte mit %d Kanlen bei Adresse $%04X gefunden.\n"
#define I_DSCCFOUND  "Digi-SCC-Karte mit %d Kanlen bei Adresse $%04X gefunden.\n"
#define H_EMPTYPAGE  "Hinweis: Leere Seite im Text entsteht bei Eintrag '%s' vor Zeile %d\n"
#define H_PAGELEN    "Hinweis: Ungnstige Seitenlnge im Eintrag '%s' vor Zeile %s\n"
#define W_TOOLONG    "Warnung: Stichwort '%s' zu lang in Zeile %d\n"
#define W_LONGTEXT   "Warnung: Maximal darstellbare Textlnge berschritten vor Zeile %d\n"
#define W_LONGLINE   "Warnung: Zeile zu lang bei Eintrag '%s' ab Zeile %d\n"
#define W_DOUBLEITEM "Warnung: Stichwort '%s' doppelt\n"
#define W_NOTININDEX "Warnung: Stichwort '%s' in Zeile %d existiert nicht\n"
#define W_OPENITEM   "Warnung: Fehlendes '^' am Ende des Stichworts in Zeile %d\n"
#define W_LONGITEM   "Warnung: Stichwort zu lang in Zeile %d\n"
#define W_NOIFACE    "Warnung: Keine Schnittstelle definiert, COM1 aktiviert.\n"
#define E_ERROR      "falsch"
#define E_MSG        "Zeile %u %s: %s\n"
#define E_NOMEM      "Zeile %u kein RAM gefunden: %s\n"
#define E_UMBMEM     "Zeile %u UMBs gefunden - \"xmemory %s\" wird ignoriert.\n"
#define E_TOOHIGH    "zu hoch"
#define E_TOOLOW     "zu niedrig"
#define E_NOTFOUND   "%s nicht gefunden!\n"
#define E_HELPNOFO   "Helpfile %s nicht gefunden\n"
#define E_ODDCHANNEL "Ungerade Anzahl von SCC-Kanlen. Bitte Karte berprfen!\n"
#define E_SCCNOFO    "SCC-Karte nicht gefunden. SCC-Kanle auf 0 gesetzt.\n"
#define E_ILLADR     "Adresse $%04X nicht durch %d teilbar. Bitte im File %s ndern.\n"
#define E_WRONGCARD  "Falsche Karte meldet sich an Adresse $%04X\n"
#define E_NOPARA     "\007Fehler: Zuwenige Parameterblcke fr SCC%d\n"
#define E_MAXCHAN    "\007Fehler: Zu viele Kanle definiert\n"
#define F_OUTOFMEM   "\007Fataler Fehler: Zuviele Stichworte\n"
#define F_MISSCOM    "\007Fataler Fehler: COMBASE oder COMINT nicht angegeben\n"
#endif

#if ENGLISCH
#define I_LINE       "line %u\r"
#define I_INITOPARA  "converting initialization file %s into parameter file %s.\n"
#define I_LINEDONE   "line %u done\n"
#define I_HELPFILE   "analyzing helpfile...\n"
#define I_ITEMSFOUND "found %d items in %d lines\n"
#define I_WRITEINDEX "building index...\n"
#define I_SORTING    "sorting index...\n"
#define I_ITEM       "item %d\r"
#define I_CROSSREFS  "checking cross references for consistency...\n"
#define I_INDEXOK    "index built.\n"
#define I_USCCFOUND  "%d channel user-SCC found at address $%04X\n"
#define I_DSCCFOUND  "%d channel node-SCC found at address $%04X\n"
#define H_EMPTYPAGE  "remark: there will be an empty page in item '%s' before line %d\n"
#define H_PAGELEN    "remark: improper page length in item '%s' before line %d\n"
#define W_TOOLONG    "warning: keyword '%s'too long in line %d\n"
#define W_LONGTEXT   "warning: text has too many lines to display (before line %d)\n"
#define W_LONGLINE   "warning: line too long in item '%s' after line %d\n"
#define W_DOUBLEITEM "warning: double defined item '%s'\n"
#define W_NOTININDEX "warning: referenced item '%s' in line %d does not exist\n"
#define W_OPENITEM   "warning: missing '^' at end of item in line %d\n"
#define W_LONGITEM   "warning: item too long in line %d\n"
#define W_NOIFACE    "warning: undefined interface, using COM1\n"
#define E_ERROR      "error"
#define E_MSG        "line %u %s: %s\n"
#define E_NOMEM      "line %u no RAM found at address %s\n"
#define E_UMBMEM     "line %u UMBs found - \"xmemory %s\" ignored\n"
#define E_TOOHIGH    "too high"
#define E_TOOLOW     "too low"
#define E_NOTFOUND   "%s not found!\n"
#define E_HELPNOFO   "helpfile %s not found!\n"
#define E_ODDCHANNEL "odd number of SCC-channels. Please check SCC-card!\n"
#define E_SCCNOFO    "SCC-card not found. Number of SCC-channels set to 0.\n"
#define E_ILLADR     "address $%04X is not an 32-byte-boundary. Please correct in file %s.\n"
#define E_WRONGCARD  "wrong card found at address $%04X\n"
#define E_NOPARA     "\007error: not enough parameter blocks for SCC%d\n"
#define E_MAXCHAN    "\007error: too many channels defined\n"
#define F_OUTOFMEM   "\007fatal error: too many items\n"
#define F_MISSCOM    "\007fatal error: COMBASE-entry  or COMINT-entry missing\n"
#endif

