/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Mailboxsystem


  ------------------------------------------
  Definitionen und Deklarationen fuer Mailbox
  ------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#ifndef _UTIL_H
#define _UTIL_H

#define ltell(fh) lseek(fh,0L,SEEK_CUR)
#define leof(fh) (lseek(fh,0L,SEEK_CUR)==filelength(fh))

#define CTRLX   24
#define CTRLZ   26

// Bits fuer die Optionen
//             
#define o_a (0x00000001L)
#define o_b (0x00000002L)
#define o_c (0x00000004L)
#define o_d (0x00000008L)
#define o_e (0x00000010L)
#define o_f (0x00000020L)
#define o_g (0x00000040L)
#define o_h (0x00000080L)
#define o_i (0x00000100L)
#define o_j (0x00000200L)
#define o_k (0x00000400L)
#define o_l (0x00000800L)
#define o_m (0x00001000L)
#define o_n (0x00002000L)
#define o_o (0x00004000L)
#define o_p (0x00008000L)
#define o_q (0x00010000L)
#define o_r (0x00020000L)
#define o_s (0x00040000L)
#define o_t (0x00080000L)
#define o_u (0x00100000L)
#define o_v (0x00200000L)
#define o_w (0x00400000L)
#define o_x (0x00800000L)
#define o_y (0x01000000L)
#define o_z (0x02000000L)
//oe3dzw Neue Flags
#define o_0  (0x04000000L)
#define o_b1 (0x04000000L)
#define o_1  (0x08000000L)
#define o_d1 (0x08000000L)
#define o_2 (0x20000000L)
#define o_3 (0x40000000L)
#define o_4 (0x80000000L)
 
typedef enum
{ j_idle,
  j_fwdlink,
  j_fwdsend,
  j_fwdsendf,
  j_fwdrecv,
  j_fwdrecvf,
  j_fbb_send_propose,
  j_fbb_send_mail,
  j_fbb_send_delay,
  j_fbb_recv_propose,
  j_fbb_recv_mail,
  j_fbb_end,
  j_fbb_error,
  j_send,
  j_read,
  j_cmd,
  j_search,
  j_purge,
  j_reorg,
  j_node,
  j_ftrans,
  j_router,
  j_convers
} job_typ;

typedef int handle;

//****************************
//       mbsema.c
//****************************
#define fopen error
#define fclose error
void     sema_list(void);
void     openfile_list(void);
FILE     *s_fopen(char *fname,char *mode);
handle   s_open(char *fname,char *mode);
int      s_set(handle fh,char *fname,char *mode);
void     s_fsetopt(FILE *f, char opt);
void     s_setopt(handle fh, char opt);
void     s_fclose(FILE *f);
void     s_close(handle fh);
void     close_task(int tid);
void     sema_init(void);
int      sema_send(void);
int      sema_access(char *name);

int      sema_test(char *name);
int      sema_lock(char *name);
void     sema_unlock(char *name);

//****************************
//       bc_util.cpp
//****************************
typedef enum delta_t
{ zs_runtime,
  zs_seconds,
  zs_cputime,
  zs_cpuexact
} delta_t;
char *zeitspanne(time_t zeit,delta_t mode);
unsigned strcrc(char *s);
char *stristr(char *s1,char *s2);
int strpos(char *s1,char *s2);
char *nexttoken(char *buf,char *token,int maxlen);
char *datestr(time_t time,int year);
char *timestr(time_t time);
int newdate(time_t d1,time_t d2);
time_t parse_time(char *datum);
int filecopy(char *src,char *dest);
void resetreadonly(char *name);
int xunlink(char *name);
int xrename(char *src,char *dest);
time_t filetime(char *name);
char *defext(char *name,char *ext);
void waitdoskey(void);
void subst(char *s,char i,char j);

//****************************
//       mbcmd.c
//****************************
int      blkill(char *bf);
char     *blankweg(char *s);
int      nextdez(char **bf);
int      readcmd(char *beftab[],char **buffer,int minimum);
char     *putzeit(time_t zeit);
char     *zeitstring(time_t zeit,int sec);
char     *modifymask(char *mask);
char     *dirline(char *mask,int mode);

extern char globalpath[];
void filepath(char *name,char *filename);
FILE *sysopen(char *name,char *mode);
char *syspath(char *name);

#endif
