/***************************************************************

  BayCom(R)           Packet-Radio fuer IBM PC

  BayCom-Terminal
  BayCom-Node
  BayCom-Mailbox

  Routinen fuer Benutzeroberflaeche


  --------------------------------------------------
  Definitionen und Prototypen fuer Window-Verwaltung
  --------------------------------------------------


  Copyright (c)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/


#ifndef _WINDOW_H
#define _WINDOW_H

#define EIN           1
#define YES           1
#define TRUE          1
#define OK            1
#define NO            0
#define NIX           4711
#define FALSE         0
#define AUS           0
#define CTRLF         6
#define TAB           9
#define CTRLL         12
#define CTRLK         11
#define CTRLN         14
#define CTRLQ         17
#define LINEDEL       25
#define ESC           27
#define INSERT        82
#define K_DELETE      83
#define LINKS         75
#define RECHTS        77
#define POS1          71
#define ENDE          79
#define RUNTER        80
#define RAUF          72
#define PG_RUNTER     81
#define PG_RAUF       73
#define CTL_PG_RAUF   132
#define CTL_PG_RUNTER 118
#define BACKSPACE     8
#define CR            '\r'
#define LF            '\n'

#define LINLEN 142
#define EBENEN 255
#define MAXWND 50

typedef short unsigned video;
#define GROSS 0
#define KLEIN 1

struct edstruct
{ unsigned curline;
  unsigned curcol;
  char     *linbuf;
  unsigned maxbuf;
  unsigned maxlines;
  unsigned index;
  unsigned readindex;
  unsigned blockbegin;
  unsigned blockend;
  unsigned blockmark;
  unsigned modified;
  unsigned shouldupdate;
  int      wpos;
  void     *esave;
  char     *buf;
  video    *save;
  char     title[40];
  int      (*update)(int);
  int      (*linefunc)(char *);
  char     wa;
  char     klein;
  char     ebene;
  char     wincnt;
  char     curx;
  char     cury;
  char     x;
  char     y;
  char     xend;
  char     yend;
  char     x2;
  char     y2;
  char     xend2;
  char     yend2;
  char     xlen;
  char     ylen;
  char     wordwrap;
  int      xoffset;
  int      readlines;
  int      pos;
  int      frame;
};
typedef struct edstruct edstruct;

//*************************************************************************
//
//  Datenstrukturen fr die Eingabe von Dialogboxen
//
//*************************************************************************


#define DIA_END 100         // wird bei letztem Feld zu 'input' addiert

typedef enum dia_input
{ dia_bool,                 // Eingabe Ein/Aus (zum Ankreuzen)
  dia_choice,               // Auswahl mehrerer Punkte
  dia_str,                  // Eingabe eines Strings
  dia_text                  // keine Eingabe, nur Ausgabe
} dia_input;

typedef struct dia_form
{ dia_input input;          // Art des Eingabefeldes
  int       width;          // max. Eingabebreite
  int       x;              // relative Position im Fenster
  int       y;
  char      *prompt;        // Ausgabe vor (nach) dem Eingabefeld
  char      *dest;          // Vorbesetzung und Resultat
} dia_form;




extern struct edstruct *e;
extern int allupdate;

extern char     *vorne; // fr jeden Bildpunkt, welches Fenster sichtbar ist
extern int       wa;    // aktuell aktives Fenster

extern unsigned bildzeilen;
extern unsigned bildspalten;
extern unsigned monochrome;
extern int boxopen;

extern video far *vram;
extern char      *fg;
extern char      *buf;

// edit.c
void editfile(char *);
void qsowin(int (*linefunc)(char *),unsigned buflen);
void putvo_edit(char c);

#define wc video_putc
#define ws video_puts

void wf(int x,int y,int attr,char *format,...);
void wstr(int line,int col,char *s);

void setzcurs(int x,int y,edstruct *e);
void wclear(int col);
void wframe(int col,char *headerln,int doppelstrich);
void wopen(void);
void wclose(void);
void boxwopen(int x,int y,int xlen,int ylen);
void boxwclose(void);
void nachvorne(int new_win);
void resize(int winnum,int mode);
void vorne_reorg(void);
void wscrollup(int col);

int yesno(char *s,int vorbesetzung);
void message(char *title,char *s[],unsigned zeit);
void msgline(char *s);
int inputwin(char *title,char *prompt,char *string,int maxlen);
int editline(unsigned &spalte,unsigned &zeile,int maxlen,char *string);

int menu(void);


// putwin.cpp
//
int  putupdate(int full);
void putwindow(char *name);
void preparewin(int (*update)(int),char *name,unsigned buflen);
void putf(char *format, ...);
void putv(int c);
void putvo_win(int);
void putflush_win(void);
void inputline_win(char *s,int maxlen,char cut);



// desktop.cpp
//
void desktop(char *);
void testcputask(void);
extern unsigned cpuindex;


unsigned alt_taste(unsigned scan);
unsigned f_taste(unsigned scan);


// vinit.c
void dosabspeichern(int platz);
void dosvideo(void);
void cdhome(void);


// mouse.asm
#ifdef __MSDOS__
extern "C"
{
#else
#define cdecl
#endif 
  int  cdecl mausistda(void);
  int  cdecl mausinit(int zeilen,int spalten);
  void cdecl maussetz(int xpos,int ypos);
  void cdecl mausein(void);
  void cdecl mausaus(void);
  int  cdecl mauszeile(void);
  int  cdecl mausspalte(void);
  int  cdecl mausknopf(void);
  int  cdecl mausrechts(void);
#ifdef __MSDOS__  
}
#endif
#endif
